=== modified file 'DBUS-API'
--- DBUS-API	2010-09-26 18:32:58 +0000
+++ DBUS-API	2011-10-02 19:18:24 +0000
@@ -5,7 +5,7 @@
 This file documents the D-Bus interface to the Mandos server.
 
 * Bus: System bus
-  Bus name: "se.bsnet.fukt.Mandos"
+  Bus name: "se.recompile.Mandos"
 
 
 * Object Paths:
@@ -17,7 +17,7 @@
 
   
 * Mandos Server Interface:
-  Interface name: "se.bsnet.fukt.Mandos"
+  Interface name: "se.recompile.Mandos"
   
 ** Methods:
 *** GetAllClients() → (ao: Clients)
@@ -44,7 +44,7 @@
 
 
 * Mandos Client Interface:
-  Interface name: "se.bsnet.fukt.Mandos.Client"
+  Interface name: "se.recompile.Mandos.Client"
   
 ** Methods
 *** Approve(b: Approve) → nothing
@@ -86,15 +86,17 @@
    | CheckerRunning (c)      | b    | Read/Write | N/A                 |
    | Created (d)             | s    | Read       | N/A                 |
    | Enabled (e)             | b    | Read/Write | N/A                 |
+   | Expires (f)             | s    | Read       | N/A                 |
+   | ExtendedTimeout (a)     | t    | Read/Write | extended_timeout    |
    | Fingerprint             | s    | Read       | fingerprint         |
    | Host                    | s    | Read/Write | host                |
    | Interval (a)            | t    | Read/Write | interval            |
-   | LastApprovalRequest (f) | s    | Read       | N/A                 |
-   | LastCheckedOK (g)       | s    | Read/Write | N/A                 |
-   | LastEnabled (h)         | s    | Read       | N/A                 |
+   | LastApprovalRequest (g) | s    | Read       | N/A                 |
+   | LastCheckedOK (h)       | s    | Read/Write | N/A                 |
+   | LastEnabled (i)         | s    | Read       | N/A                 |
    | Name                    | s    | Read       | (Section name)      |
    | ObjectPath              | o    | Read       | N/A                 |
-   | Secret (i)              | ay   | Write      | secret (or secfile) |
+   | Secret (j)              | ay   | Write      | secret (or secfile) |
    | Timeout (a)             | t    | Read/Write | timeout             |
    
    a) Represented as milliseconds.
@@ -104,25 +106,28 @@
    c) Setting this property is equivalent to calling StartChecker() or
       StopChecker().
    
-   d) The creation time of this client object, as a RFC 3339 string.
+   d) The creation time of this client object, as an RFC 3339 string.
    
    e) Setting this property is equivalent to calling Enable() or
       Disable().
    
-   f) The time of the last approval request, as a RFC 3339 string, or
-      an empty string if this has not happened.
-   
-   g) The last time a checker was successful, as a RFC 3339 string, or
-      an empty string if this has not happened.  Setting this property
-      is equivalent to calling CheckedOK(), i.e. the current time is
-      set, regardless of the string sent.  Please always use an empty
-      string when setting this property, to allow for possible future
-      expansion.
-   
-   h) The last time this client was enabled, as a RFC 3339 string, or
-      an empty string if this has not happened.
-   
-   i) A raw byte array, not hexadecimal digits.
+   f) The date and time this client will be disabled, as an RFC 3339
+      string, or an empty string if this has not happened.
+   
+   g) The date and time of the last approval request, as an RFC 3339
+      string, or an empty string if this has not happened.
+   
+   h) The date and time a checker was last successful, as an RFC 3339
+      string, or an empty string if this has not happened.  Setting
+      this property is equivalent to calling CheckedOK(), i.e. the
+      current time is set, regardless of the string sent.  Please
+      always use an empty string when setting this property, to allow
+      for possible future expansion.
+   
+   i) The date and time this client was last enabled, as an RFC 3339
+      string, or an empty string if this has not happened.
+   
+   j) A raw byte array, not hexadecimal digits.
 
 ** Signals
 *** CheckerCompleted(n: Exitcode, x: Waitstatus, s: Command)
@@ -140,17 +145,17 @@
     This client will be approved or denied in exactly Timeout
     milliseconds, depending on ApprovedByDefault.  Approve() can now
     usefully be called on this client object.
-
+    
 *** PropertyChanged(s: Property, v: Value)
     The Property on this client has changed to Value.
-
+    
 *** Rejected(s: Reason)
     This client was not given its secret for a specified Reason.
 
 * Copyright
 
-    Copyright © 2010 Teddy Hogeborn
-    Copyright © 2010 Björn Påhlsson
+    Copyright © 2010-2011 Teddy Hogeborn
+    Copyright © 2010-2011 Björn Påhlsson
   
 ** License:
    

=== modified file 'INSTALL'
--- INSTALL	2009-02-15 09:28:06 +0000
+++ INSTALL	2011-03-08 19:09:03 +0000
@@ -4,14 +4,14 @@
   
 ** Operating System
    
-   Debian 5.0 "lenny" or Ubuntu 8.04 "Hardy Heron".
+   Debian 6.0 "squeeze" or Ubuntu 10.10 "Maverick Meerkat".
    
    This is mostly for the support scripts which make sure that the
    client is installed and started in the initial RAM disk environment
    and that the initrd.img file is automatically made unreadable.  The
    server and client programs themselves *could* be run in other
    distributions, but they *are* specific to GNU/Linux systems, and
-   are not intended to be portable to other Unixes.
+   are not written with portabillity to other Unixes in mind.
   
 ** Libraries
    
@@ -39,18 +39,18 @@
 *** Mandos Server
     + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
     + Avahi 0.6.16        http://www.avahi.org/
-    + Python 2.5          http://www.python.org/
+    + Python 2.6          http://www.python.org/
     + Python-GnuTLS 1.1.5 http://pypi.python.org/pypi/python-gnutls/
     + dbus-python 0.82.4  http://dbus.freedesktop.org/doc/dbus-python/
-    + python-ctypes 1.0.0 http://pypi.python.org/pypi/ctypes
     + PyGObject 2.14.2    http://library.gnome.org/devel/pygobject/
+    + Urwid 0.9.8.3       http://excess.org/urwid/
     
     Strongly recommended:
     + fping 2.4b2-to-ipv6 http://www.fping.com/
     
     Package names:
     python-gnutls avahi-daemon python python-avahi python-dbus
-    python-ctypes python-gobject
+    python-gobject python-urwid
    
 *** Mandos Client
     + initramfs-tools 0.85i
@@ -99,16 +99,20 @@
      server computer*.
   
   4. Configure the client to use the correct network interface.  The
-     default is "eth0", and if this needs to be adjusted, it will be
-     necessary to edit /etc/mandos/plugin-runner.conf to uncomment and
-     change the line there.  If that file is changed, the initrd.img
-     file must be updated, possibly using the following command:
+     interface to use is automatically chosen at boot, and if this
+     needs to be adjusted, it will be necessary to edit
+     /etc/initramfs-tools/initramfs.conf to change the DEVICE setting
+     there.  Alternatively, the file /etc/mandos/plugin-runner.conf
+     can be edited to add a "--device" parameter for the
+     mandos-client(8) plugin.  Please note: If any of those files are
+     changed, the initrd.img file must be updated, possibly using the
+     following command:
      
 	# update-initramfs -k all -u
   
   5. On the server computer, start the server by running the command
      For Debian: su -c 'invoke-rc.d mandos start'
-     For Ubuntu: sudo invoke-rc.d mandos start
+     For Ubuntu: sudo service mandos start
      
      At this point, it is possible to verify that the correct password
      will be received by the client by running the command:

=== modified file 'Makefile'
--- Makefile	2010-10-11 17:45:21 +0000
+++ Makefile	2011-10-15 16:48:03 +0000
@@ -5,7 +5,7 @@
 	-Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings \
 	-Wconversion -Wstrict-prototypes -Wold-style-definition \
 	-Wpacked -Wnested-externs -Winline -Wvolatile-register-var
-#	-Wunreachable-code 
+#	-Wunreachable-code
 #DEBUG=-ggdb3
 # For info about _FORTIFY_SOURCE, see
 # <http://www.kernel.org/doc/man-pages/online/pages/man7/feature_test_macros.7.html>
@@ -23,7 +23,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.2.3
+version=1.4.1
 SED=sed
 
 ## Use these settings for a traditional /usr/local install
@@ -54,7 +54,7 @@
 CFLAGS=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
 	$(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS) \
 	-DVERSION='"$(version)"'
-LDFLAGS=$(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
+LDFLAGS=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
 
 # Commands to format a DocBook <refentry> document into a manual page
 DOCBOOKTOMAN=$(strip cd $(dir $<); xsltproc --nonet --xinclude \
@@ -65,7 +65,9 @@
 	--param man.authors.section.enabled	0 \
 	 /usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
 	$(notdir $<); \
-	$(MANPOST) $(notdir $@))
+	$(MANPOST) $(notdir $@);\
+	LANG=en_US.UTF-8 MANWIDTH=80 man --warnings --encoding=UTF-8 \
+	--local-file $(notdir $@) >/dev/null)
 # DocBook-to-man post-processing to fix a '\n' escape bug
 MANPOST=$(SED) --in-place --expression='s,\\\\en,\\en,g;s,\\n,\\en,g'
 
@@ -92,7 +94,7 @@
 	plugins.d/mandos-client.8mandos \
 	plugins.d/password-prompt.8mandos plugins.d/usplash.8mandos \
 	plugins.d/splashy.8mandos plugins.d/askpass-fifo.8mandos \
-	plugins.d/plymouth.8mandos
+	plugins.d/plymouth.8mandos intro.8mandos
 
 htmldocs=$(addsuffix .xhtml,$(DOCS))
 
@@ -119,6 +121,11 @@
 %.8mandos.xhtml: %.xml common.ent legalnotice.xml
 	$(DOCBOOKTOHTML)
 
+intro.8mandos: intro.xml common.ent legalnotice.xml
+	$(DOCBOOKTOMAN)
+intro.8mandos.xhtml: intro.xml common.ent legalnotice.xml
+	$(DOCBOOKTOHTML)
+
 mandos.8: mandos.xml common.ent mandos-options.xml overview.xml \
 		legalnotice.xml
 	$(DOCBOOKTOMAN)
@@ -210,8 +217,8 @@
 		$@)
 
 plugins.d/mandos-client: plugins.d/mandos-client.c
-	$(LINK.c) $(GNUTLS_LIBS) $(AVAHI_LIBS) $(GPGME_LIBS) $(strip\
-		) $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
+	$(LINK.c) $^ -lrt $(GNUTLS_LIBS) $(AVAHI_LIBS) $(strip\
+		) $(GPGME_LIBS) $(LOADLIBES) $(LDLIBS) -o $@
 
 .PHONY : all doc html clean distclean run-client run-server install \
 	install-server install-client uninstall uninstall-server \

=== modified file 'NEWS'
--- NEWS	2010-10-11 17:45:21 +0000
+++ NEWS	2011-10-15 16:48:03 +0000
@@ -1,6 +1,39 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
+Version 1.4.1 (2011-10-15)
+* Server
+** Make D-Bus properties settable again, and handle checkers
+   for disabled clients correctly.
+* Miscellaneous fixes to "pedantic" Lintian warnings
+
+Version 1.4.0 (2011-10-09)
+* README file migrated to manual page intro(8mandos).
+* Client:
+** Fixed warning about "rmdir: Directory not empty".
+* Server:
+** Default values changed: timeout 5 minutes, interval 2 minutes.
+** Clients gets an expiration extension when receiving a password,
+   controlled by new "extended_timeout" setting.
+** New domain name: "fukt.bsnet.se" changes to "recompile.se".  This
+   also affects the D-Bus bus and interface names (old names still
+   work).  Users should start using the new names immediately.
+** New D-Bus Client object properties "Expires" and "ExtendedTimeout";
+   see DBUS-API for details.
+
+Version 1.3.1 (2011-07-27)
+* Client:
+** Client now retries all Mandos servers periodically.
+** Work around Debian bug #633582 - fixes "Permission denied" problem.
+
+Version 1.3.0 (2011-03-08)
+* Server:
+** Updated for Python 2.6.
+* Client:
+** Bug fix: Make the password-prompt plugin not conflict with
+   Plymouth.
+** Bug fix: Bug fix: update initramfs also when purging package.
+
 Version 1.2.3 (2010-10-11)
 * Server:
 ** Bug fix: Expose D-Bus API also in non-debug mode.

=== modified file 'README'
--- README	2010-09-26 18:32:58 +0000
+++ README	2011-10-05 16:00:56 +0000
@@ -1,182 +1,10 @@
--*- org -*-
-
-* Mandos
-  - Have your cake and eat it too!
-  
-  You know how it is.  You’ve heard of it happening.  The Man comes
-  and takes away your servers, your friends’ servers, the servers of
-  everybody in the same hosting facility. The servers of their
-  neighbors, and their neighbors’ friends.  The servers of people who
-  owe them money.  And like *that*, they’re gone.  And you doubt
-  you’ll ever see them again.
-  
-  That is why your servers have encrypted root file systems.  However,
-  there’s a downside.  There’s no going around it: rebooting is a
-  pain.  Dragging out that rarely-used keyboard and screen and
-  unraveling cables behind your servers to plug them in to type in
-  that password is messy, especially if you have many servers.  There
-  are some people who do clever things like using serial line consoles
-  and daisy-chain it to the next server, and keep all the servers
-  connected in a ring with serial cables, which will work, if your
-  servers are physically close enough.  There are also other
-  out-of-band management solutions, but with *all* these, you still
-  have to be on hand and manually type in the password at boot time.
-  Otherwise the server just sits there, waiting for a password.
-  
-  Wouldn’t it be great if you could have the security of encrypted
-  root file systems and still have servers that could boot up
-  automatically if there was a short power outage while you were
-  asleep?  That you could reboot at will, without having someone run
-  over to the server to type in the password?
-  
-  Well, with Mandos, you (almost) can!  The gain in convenience will
-  only be offset by a small loss in security.  The setup is as
-  follows:
-  
-  The server will still have its encrypted root file system.  The
-  password to this file system will be stored on another computer
-  (henceforth known as the Mandos server) on the same local network.
-  The password will *not* be stored in plaintext, but encrypted with
-  OpenPGP.  To decrypt this password, a key is needed.  This key (the
-  Mandos client key) will not be stored there, but back on the
-  original server (henceforth known as the Mandos client) in the
-  initial RAM disk image.  Oh, and all network Mandos client/server
-  communications will be encrypted, using TLS (SSL).
-  
-  So, at boot time, the Mandos client will ask for its encrypted data
-  over the network, decrypt it to get the password, use it to decrypt
-  the root file, and continue booting.
-  
-  Now, of course the initial RAM disk image is not on the encrypted
-  root file system, so anyone who had physical access could take the
-  Mandos client computer offline and read the disk with their own
-  tools to get the authentication keys used by a client.  *But*, by
-  then the Mandos server should notice that the original server has
-  been offline for too long, and will no longer give out the encrypted
-  key.  The timing here is the only real weak point, and the method,
-  frequency and timeout of the server’s checking can be adjusted to
-  any desired level of paranoia
-  
-  (The encrypted keys on the Mandos server is on its normal file
-  system, so those are safe, provided the root file system of *that*
-  server is encrypted.)
-
-* FAQ - couldn’t the security be defeated by...
-
-** Grabbing the Mandos client key from the initrd *really quickly*?
-   This, as mentioned above, is the only real weak point.  But if you
-   set the timing values tight enough, this will be really difficult
-   to do.  An attacker would have to physically disassemble the client
-   computer, extract the key from the initial RAM disk image, and then
-   connect to a *still online* Mandos server to get the encrypted key,
-   and do all this *before* the Mandos server timeout kicks in and the
-   Mandos server refuses to give out the key to anyone.
-   
-   Now, as the typical procedure seems to be to barge in and turn off
-   and grab *all* computers, to maybe look at them months later, this
-   is not likely.  If someone does that, the whole system *will* lock
-   itself up completely, since Mandos servers are no longer running.
-   
-   For sophisticated attackers who *could* do the clever thing, *and*
-   had physical access to the server for enough time, it would be
-   simpler to get a key for an encrypted file system by using hardware
-   memory scanners and reading it right off the memory bus.
-
-** Replay attacks?
-   Nope, the network stuff is all done over TLS, which provides
-   protection against that.
-
-** Man-in-the-middle?
-   No.  The server only gives out the passwords to clients which have
-   *in the TLS handshake* proven that they do indeed hold the OpenPGP
-   private key corresponding to that client.
-
-** Physically grabbing the Mandos server computer?
-   You could protect *that* computer the old-fashioned way, with a
-   must-type-in-the-password-at-boot method.  Or you could have two
-   computers be the Mandos server for each other.
-   
-   Multiple Mandos servers can coexist on a network without any
-   trouble.  They do not clash, and clients will try all available
-   servers.  This means that if just one reboots then the other can
-   bring it back up, but if both reboot at the same time they will
-   stay down until someone types in the password on one of them.
-
-** Faking ping replies?
-   The default for the server is to use "fping", the replies to which
-   could be faked to eliminate the timeout.  But this could easily be
-   changed to any shell command, with any security measures you like.
-   It could, for instance, be changed to an SSH command with strict
-   keychecking, which could not be faked.  Or IPsec could be used for
-   the ping packets, making them secure.
-
-* Security Summary
-  So, in summary:  The only weakness in the Mandos system is from
-  people who have:
-  1. The power to come in and physically take your servers, *and*
-  2. The cunning and patience to do it carefully, one at a time, and
-     *quickly*, faking Mandos client/server responses for each one
-     before the timeout.
-  
-  While there are some who may be threatened by people who have *both*
-  these attributes, they do not, probably, constitute the majority.
-  
-  If you *do* face such opponents, you must figure that they could
-  just as well open your servers and read the file system keys right
-  off the memory by running wires to the memory bus.
-  
-  What Mandos is designed to protect against is *not* such determined,
-  focused, and competent attacks, but against the early morning knock
-  on your door and the sudden absence of all the servers in your
-  server room.  Which it does nicely.
-
-* The Plugin System
-  In the early designs, the mandos-client(8mandos) program (which
-  retrieves a password from the Mandos server) also prompted for a
-  password on the terminal, in case a Mandos server could not be
-  found.  Other ways of retrieving a password could easily be
-  envisoned, but this multiplicity of purpose was seen to be too
-  complex to be a viable way to continue.  Instead, the original
-  program was separated into mandos-client(8mandos) and
-  password-prompt(8mandos), and a plugin-runner(8mandos) exist to run
-  them both in parallel, allowing the first successful plugin to
-  provide the password.  This opened up for any number of additional
-  plugins to run, all competing to be the first to find a password and
-  provide it to the plugin runner.
-  
-  Four additional plugins are provided:
-  * plymouth(8mandos)
-    This prompts for a password when using plymouth(8).
-  * usplash(8mandos)
-    This prompts for a password when using usplash(8).
-  * splashy(8mandos)
-    This prompts for a password when using splashy(8).
-  * askpass-fifo(8mandos)
-    To provide compatibility with the "askpass" program from
-    cryptsetup, this plugin listens to the same FIFO as askpass would
-    do.
-  
-  More plugins can easily be written and added by the system
-  administrator; see the section called "WRITING PLUGINS" in
-  plugin-runner(8mandos) to learn the plugin requirements.
-
-* Copyright
-
-    Copyright © 2008-2010 Teddy Hogeborn
-    Copyright © 2008-2010 Björn Påhlsson
-  
-** License:
-   
-   This program is free software: you can redistribute it and/or
-   modify it under the terms of the GNU General Public License as
-   published by the Free Software Foundation, either version 3 of the
-   License, or (at your option) any later version.
-
-   This program is distributed in the hope that it will be useful, but
-   WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program.  If not, see
-   <http://www.gnu.org/licenses/>.
+Please see: http://www.recompile.se/mandos/man/intro.8mandos
+
+This information previously in this file has been moved to the
+intro(8mandos) manual page.  Go to the above URL, or run this command:
+
+	man 8mandos intro
+
+In short, this is the Mandos system; it allows computers to have
+encrypted root file systems and at the same time be capable of remote
+and/or unattended reboots.

=== modified file 'TODO'
--- TODO	2010-11-16 17:58:49 +0000
+++ TODO	2011-11-13 13:55:45 +0000
@@ -2,38 +2,39 @@
 
 * Use _attribute_((nonnull)) wherever possible.
 
+* [[http://www.undeadly.org/cgi?action=article&sid=20110530221728][OpenBSD]]
+
 * mandos-applet
 
 * mandos-client
-** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
-** TODO [#B] Retry a server which has a non-definite reply:
-*** A closed connection during the TLS handshake
-*** A TCP timeout
+** TODO [#A] Document network hook functionality
 ** TODO [#B] Use capabilities instead of seteuid().
-** TODO [#A] Retry --connect forever
+** TODO [#B] Use struct sockaddr_storage instead of a union
+** TODO [#B] Use getaddrinfo(hints=AI_NUMERICHOST) instead of inet_pton()
+** TODO [#B] Use getnameinfo(serv=NULL, NI_NUMERICHOST) instead of inet_ntop()
+** TODO [#B] Prefer /run/tmp over /tmp, if it exists
 
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
 
-* usplash
+* usplash (Deprecated)
 ** TODO [#A] Make it work again
 ** TODO [#B] use scandir(3) instead of readdir(3)
-** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
 ** TODO Use [[info:libc:Argz%20Functions][argz_extract]]
 
 * askpass-fifo
-** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
 ** TODO [#B] Drop privileges after opening FIFO.
 
 * password-prompt
-** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
 ** TODO [#B] lock stdin (with flock()?)
 
+* plymouth
+
 * TODO [#B] passdev
 
 * plugin-runner
+** TODO handle printing for errors for plugins
+*** Hook up stderr of plugins, buffer them, and prepend mandos pluig [plugin name]
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#C] use same file name rules as run-parts(8)
 ** kernel command line option for debug info
@@ -58,33 +59,22 @@
 ** TODO [#C] DBusServiceObjectUsingSuper
 ** TODO [#B] Global enable/disable flag
 ** TODO [#B] By-client countdown on secrets given
-** TODO [#B] Fix problem with fsck taking a really long time
-   Whenever a client successfully gets a secret it could get a
-   one-time timeout boost to allow for an fsck-incurred delay
-** TODO [#A] Delay before client receives key
-   This would give an operator opportunity to cancel the request if
-   desired.
-** TODO [#A] Client manual approval mode
-   A client needs manual approval on the server before it gets the
-   secret
 ** TODO [#B] Support RFC 3339 time duration syntax
 ** More D-Bus methods
-*** NeedsApproval(50, True) -> timeout, default approve
-    Default approval is configurable, but True by default
-    + Approve(True) -> approve sending saved
-    + Approve(False) -> Close client connection immediately
 *** NeedsPassword(50) - Timeout, default disapprove
     + SetPass(u"gazonk", True) -> Approval, persistent
     + Approve(False) -> Close client connection immediately
 ** TODO [#C] python-parsedatetime
 ** TODO [#C] systemd/launchd
    http://0pointer.de/blog/projects/systemd.html
+   http://wiki.debian.org/systemd
 ** TODO Separate logging logic to own object
 ** TODO make clients to a dict!
 ** TODO [#A] Limit approval_delay to max gnutls/tls timeout value
 ** TODO [#B] break the wait on approval_delay if connection dies
 ** TODO Generate Client.runtime_expansions from client options + extra
 ** TODO Allow %%(checker)s as a runtime expansion
+** TODO Use python-tlslite?
 
 * mandos.xml
 ** Add mandos contact info in manual pages
@@ -93,13 +83,14 @@
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
 ** TODO Support RFC 3339 time duration syntax
+** TODO Send milliseconds if bare integer is passed as time duration
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with
   arguments.
 
 * mandos-monitor
-** TODO help should be toggable
+** TODO help should be toggleable
 ** Urwid client data displayer
    Better view of client data in the listing
 *** Properties popup
@@ -108,15 +99,12 @@
 ** Show timeout countdown for approval
 
 * mandos-keygen
-** TODO Loop until passwords match when run interactively
 ** TODO "--secfile" option
    Using the "secfile" option instead of "secret"
 ** TODO [#B] "--test" option
    For testing decryption before rebooting.
 
 * Makefile
-** TODO Add "--Xlinker --as-needed"
-   http://udrepper.livejournal.com/19395.html
 ** TODO [#C] Implement DEB_BUILD_OPTIONS
    http://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
 
@@ -129,8 +117,8 @@
    From XML sources directly?
 
 * Side Stuff
-** TODO Locate which packet move the other bin/sh when busy box is deactivated
-** TODO contact owner of packet, and ask them to have that shell static in position regardless of busybox
+** TODO Locate which package moves the other bin/sh when busybox is deactivated
+** TODO contact owner of package, and ask them to have that shell static in position regardless of busybox
 
 
 #+STARTUP: showall

=== modified file 'clients.conf'
--- clients.conf	2010-09-12 03:00:40 +0000
+++ clients.conf	2011-09-19 09:42:55 +0000
@@ -4,14 +4,19 @@
 
 # How long until a client is disabled and not be allowed to get the
 # data this server holds.
-;timeout = 1h
+;timeout = 5m
 
 # How often to run the checker to confirm that a client is still up.
 # Note: a new checker will not be started if an old one is still
 # running.  The server will wait for a checker to complete until the
 # above "timeout" occurs, at which time the client will be disabled,
 # and any running checker killed.
-;interval = 5m
+;interval = 2m
+
+# Extended timeout is an added timeout that is given once after a
+# password has been sent sucessfully to a client.  This allows for
+# additional delays caused by file system checks and quota checks.
+;extended_timeout = 15m
 
 # What command to run as "the checker".
 ;checker = fping -q -- %%(host)s
@@ -70,7 +75,7 @@
 ;host = 192.0.2.3
 ;
 ;# Parameters from the [DEFAULT] section can be overridden per client.
-;interval = 5m
+;interval = 1m
 ;
 ;# This client requires manual approval before it receives its secret.
 ;approved_by_default = False

=== modified file 'common.ent'
--- common.ent	2010-10-11 17:45:21 +0000
+++ common.ent	2011-10-15 16:48:03 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.2.3">
+<!ENTITY version "1.4.1">

=== modified file 'dbus-mandos.conf'
--- dbus-mandos.conf	2009-11-09 07:35:16 +0000
+++ dbus-mandos.conf	2011-10-02 19:18:24 +0000
@@ -7,12 +7,18 @@
     <allow own="se.bsnet.fukt.Mandos"/>
     <allow send_destination="se.bsnet.fukt.Mandos"/>
     <allow receive_sender="se.bsnet.fukt.Mandos"/>
+    <allow own="se.recompile.Mandos"/>
+    <allow send_destination="se.recompile.Mandos"/>
+    <allow receive_sender="se.recompile.Mandos"/>
   </policy>
   
   <policy user="root">
     <allow own="se.bsnet.fukt.Mandos"/>
     <allow send_destination="se.bsnet.fukt.Mandos"/>
     <allow receive_sender="se.bsnet.fukt.Mandos"/>
+    <allow own="se.recompile.Mandos"/>
+    <allow send_destination="se.recompile.Mandos"/>
+    <allow receive_sender="se.recompile.Mandos"/>
   </policy>
 
 </busconfig>

=== modified file 'debian/changelog'
--- debian/changelog	2010-10-11 17:45:21 +0000
+++ debian/changelog	2011-10-15 16:48:03 +0000
@@ -1,3 +1,55 @@
+mandos (1.4.1-1) unstable; urgency=low
+
+  * New upstream release.
+  * debian/control (Build-Depends): Added "man".
+  * debian/control (Conflicts): Changed to "Breaks:".
+  * debian/copyright: Updated format.
+  * debian/mandos-client.postinst: Use "set -e" instead of "#!/bin/sh -e".
+  * debian/mandos-client.postrm: - '' -
+  * debian/mandos.postinst: - '' -
+  * debian/mandos.prerm: Consistent magic.
+
+ -- Björn Påhlsson <belorn@fukt.bsnet.se>  Sat, 15 Oct 2011 18:18:52 +0200
+
+mandos (1.4.0-1) unstable; urgency=low
+
+  * New upstream release.
+  * Fix "FTBFS with binutils-gold": Added "-Xlinker --as-needed" to
+    LDFLAGS in Makefile. (Closes: #632145)
+  * Fix "/run transition: uses obsolete /dev/.initramfs": Try both old and
+    new PID file locations. (Closes: #643554)
+  * debian/source/local-options: New; contains "--single-debian-patch".
+  * debian/control (Standards-Version): Upgraded to "3.9.2".
+    (DM-Upload-Allowed): New; set to "yes".
+  * debian/control: Changed domain from "fukt.bsnet.se" to "recompile.se".
+  * debian/copyright: - '' -
+  * debian/mandos-client.README.Debian: - '' -
+  * debian/mandos.README.Debian: - '' -
+  * debian/watch: - '' -
+  * debian/control (mandos/Description): Fix language to placate lintian.
+
+ -- Teddy Hogeborn <teddy@recompile.se>  Sun, 09 Oct 2011 19:15:08 +0200
+
+mandos (1.3.1-1) unstable; urgency=low
+
+  * New upstream release.
+  * Conflict with correct version of dropbear.
+  * New version uses argparse; depend on python (<=2.7) | python-argparse.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Wed, 27 Jul 2011 19:47:17 +0200
+
+mandos (1.3.0-1) unstable; urgency=low
+
+  * New upstream release.
+  * debian/control (mandos): Depend on Python 2.6, remove dependency on
+    python-multiprocessing.
+  (mandos-client): Conflict with dropbear (<< 0.52-5).
+  * debian/mandos-client.postrm (purge): Bug fix: update initramfs also on
+    purge.
+  * debian/mandos-client.lintian-overrides: Added plugins.d/plymouth.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 08 Mar 2011 20:22:57 +0100
+
 mandos (1.2.3-1) experimental; urgency=low
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2010-10-01 18:40:55 +0000
+++ debian/control	2011-10-11 19:36:00 +0000
@@ -1,24 +1,25 @@
 Source: mandos
 Section: admin
 Priority: extra
-Maintainer: Mandos Maintainers <mandos@fukt.bsnet.se>
-Uploaders: Teddy Hogeborn <teddy@fukt.bsnet.se>,
-	   Björn Påhlsson <belorn@fukt.bsnet.se>
+Maintainer: Mandos Maintainers <mandos@recompile.se>
+Uploaders: Teddy Hogeborn <teddy@recompile.se>,
+	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 7), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
-	pkg-config
-Standards-Version: 3.9.1
-Vcs-Bzr: http://ftp.fukt.bsnet.se/pub/mandos/trunk
-Vcs-Browser: http://bzr.fukt.bsnet.se/loggerhead/mandos/trunk/files
-Homepage: http://www.fukt.bsnet.se/mandos
+	pkg-config, man
+Standards-Version: 3.9.2
+Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
+Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
+Homepage: http://www.recompile.se/mandos
+DM-Upload-Allowed: yes
 
 Package: mandos
 Architecture: all
-Depends: ${misc:Depends}, python (>=2.5), python-gnutls, python-dbus,
+Depends: ${misc:Depends}, python (>=2.6), python-gnutls, python-dbus,
 	python-avahi, python-gobject, avahi-daemon, adduser,
-	python-urwid, python (>=2.6) | python-multiprocessing
+	python-urwid, python (>=2.7) | python-argparse
 Recommends: fping
-Description: a server giving encrypted passwords to Mandos clients
+Description: server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
  computers to have encrypted root file systems and at the
  same time be capable of remote and/or unattended reboots.
@@ -37,6 +38,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
 	gnupg (<< 2)
+Breaks: dropbear (<= 0.53.1-1)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system
  This is the client part of the Mandos system, which allows

=== modified file 'debian/copyright'
--- debian/copyright	2010-09-26 18:32:58 +0000
+++ debian/copyright	2011-10-10 20:29:58 +0000
@@ -1,12 +1,11 @@
-Format-Specification:
- http://wiki.debian.org/Proposals/CopyrightFormat?action=recall&rev=233
+Format: http://anonscm.debian.org/viewvc/dep/web/deps/dep5.mdwn?revision=202
 Upstream-Name: Mandos
-Upstream-Maintainer: Mandos Maintainers <mandos@fukt.bsnet.se>
-Upstream-Source: <http://www.fukt.bsnet.se/mandos>
+Upstream-Contact: Mandos <mandos@recompile.se>
+Source: <http://www.recompile.se/mandos>
 
 Files: *
-Copyright: Copyright © 2008-2010 Teddy Hogeborn
-Copyright: Copyright © 2008-2010 Björn Påhlsson
+Copyright: Copyright © 2008-2011 Teddy Hogeborn
+Copyright: Copyright © 2008-2011 Björn Påhlsson
 License: GPL-3+
     This program is free software: you can redistribute it and/or
     modify it under the terms of the GNU General Public License as

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2010-09-27 17:53:53 +0000
+++ debian/mandos-client.README.Debian	2011-10-05 16:00:56 +0000
@@ -1,25 +1,3 @@
-* Choose the Client Network Interface
-  
-  Please make sure that the correct network interface is specified in
-  the DEVICE setting in the "/etc/initramfs-tools/initramfs.conf"
-  file.  If the setting is empty, the interface will be autodetected
-  at boot time, which may not be correct.  *If* the DEVICE setting is
-  changed, it will be necessary to update the initrd image by running
-  the command
-  
-	update-initramfs -k all -u
-  
-  The device can be overridden at boot time on the Linux kernel
-  command line using the sixth colon-separated field of the "ip="
-  option; for exact syntax, read the documentation in the file
-  "/usr/share/doc/linux-doc-*/Documentation/filesystems/nfsroot.txt",
-  available in the "linux-doc-*" package.
-  
-  Note that since this network interface is used in the initial RAM
-  disk environment, the network interface *must* exist at that stage.
-  Thus, the interface can *not* be a pseudo-interface such as "br0" or
-  "tun0"; instead, a real interface (such as "eth0") must be used.
-
 * Adding a Client Password to the Server
   
   The server must be given a password to give back to the client on
@@ -46,6 +24,34 @@
   it, and output it to standard output.  There it can be verified to
   be the correct password, before rebooting.
 
+* Emergency Escape
+  
+  If it ever should be necessary, the Mandos client can be temporarily
+  prevented from running at startup by passing the parameter
+  "mandos=off" to the kernel.
+
+* Specifying a Client Network Interface
+  
+  At boot time the network interface to use will by default be
+  automatically detected.  If should result in an incorrect interface,
+  edit the DEVICE setting in the "/etc/initramfs-tools/initramfs.conf"
+  file.  (The default setting is empty, meaning to autodetect the
+  interface.)  *If* the DEVICE setting is changed, it will be
+  necessary to update the initrd image by running the command
+  
+	update-initramfs -k all -u
+  
+  The device can be overridden at boot time on the Linux kernel
+  command line using the sixth colon-separated field of the "ip="
+  option; for exact syntax, read the documentation in the file
+  "/usr/share/doc/linux-doc-*/Documentation/filesystems/nfsroot.txt",
+  available in the "linux-doc-*" package.
+  
+  Note that since this network interface is used in the initial RAM
+  disk environment, the network interface *must* exist at that stage.
+  Thus, the interface can *not* be a pseudo-interface such as "br0" or
+  "tun0"; instead, only real interface (such as "eth0") can be used.
+
 * User-Supplied Plugins
   
   Any plugins found in "/etc/mandos/plugins.d" will override and add
@@ -62,19 +68,14 @@
   Mandos client will be the new default way for getting a password for
   the root file system when booting.
 
-* Emergency Escape
-  
-  If it ever should be necessary, the Mandos client can be temporarily
-  prevented from running at startup by passing the parameter
-  "mandos=off" to the kernel.
-
 * Non-local Connection (Not Using ZeroConf)
   
   If the "ip=" kernel command line option is used to specify a
   complete IP address and device name, as noted above, it then becomes
   possible to specify a specific IP address and port to connect to,
   instead of using ZeroConf.  The syntax for doing this is
-  "mandos=connect:<IP_ADDRESS>:<PORT_NUMBER>".
+  "mandos=connect:<IP_ADDRESS>:<PORT_NUMBER>" on the kernel command
+  line.
   
   For very advanced users, it it possible to specify simply
   "mandos=connect" on the kernel command line to make the system only
@@ -83,4 +84,4 @@
   work, "--options-for=mandos-client:--connect=<ADDRESS>:<PORT>" needs
   to be manually added to the file "/etc/mandos/plugin-runner.conf".
 
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Mon, 27 Sep 2010 19:53:21 +0200
+ -- Teddy Hogeborn <teddy@recompile.se>, Wed,  5 Oct 2011 17:50:22 +0200

=== modified file 'debian/mandos-client.postinst'
--- debian/mandos-client.postinst	2009-05-24 23:36:15 +0000
+++ debian/mandos-client.postinst	2011-10-10 20:29:58 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh -e
+#!/bin/sh
 # This script can be called in the following ways:
 #
 # After the package was installed:
@@ -15,6 +15,8 @@
 # If prerm fails during replacement due to conflict:
 #       <postinst> abort-remove in-favour <new-package> <version>
 
+set -e
+
 # Update the initial RAM file system image
 update_initramfs()
 {

=== modified file 'debian/mandos-client.postrm'
--- debian/mandos-client.postrm	2009-01-18 00:16:57 +0000
+++ debian/mandos-client.postrm	2011-10-10 20:29:58 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh -e
+#!/bin/sh
 # This script can be called in the following ways:
 #
 # After the package was removed:
@@ -26,6 +26,7 @@
 # If preinst fails during upgrade:
 #       <new-postrm> abort-upgrade <old-version>
 
+set -e
 
 # Update the initial RAM file system image
 update_initramfs()
@@ -45,6 +46,7 @@
 	rm --force /etc/mandos/plugin-runner.conf \
 	    /etc/keys/mandos/pubkey.txt \
 	    /etc/keys/mandos/seckey.txt 2>/dev/null
+	update_initramfs
 	;;
     upgrade|failed-upgrade|disappear|abort-install|abort-upgrade)
 	;;

=== modified file 'debian/mandos.README.Debian'
--- debian/mandos.README.Debian	2009-09-08 06:28:20 +0000
+++ debian/mandos.README.Debian	2011-10-05 16:00:56 +0000
@@ -1,10 +1,10 @@
 The Mandos server is useless without at least one configured client in
 /etc/mandos/clients.conf.  To create one, install the "mandos-client"
-package on a client computer, and run the command
+package on a client computer, and, on the client, run the command
 
 	# mandos-keygen --password
 
-there to get a config file stanza.  Append the output of that command
-to the file "/etc/mandos/clients.conf" on the Mandos server.
+to get a config file stanza.  Append the output of that command to the
+file "/etc/mandos/clients.conf" on the Mandos server computer.
 
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Tue,  8 Sep 2009 06:57:45 +0200
+ -- Teddy Hogeborn <teddy@recompile.se>, Wed,  5 Oct 2011 17:51:22 +0200

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2009-05-24 23:28:04 +0000
+++ debian/mandos.postinst	2011-10-10 20:29:58 +0000
@@ -1,4 +1,4 @@
-#!/bin/sh -e
+#!/bin/sh
 # This script can be called in the following ways:
 #
 # After the package was installed:
@@ -15,6 +15,8 @@
 # If prerm fails during replacement due to conflict:
 #       <postinst> abort-remove in-favour <new-package> <version>
 
+set -e
+
 case "$1" in
     configure)
 	# Rename old "mandos" user and group

=== modified file 'debian/mandos.prerm'
--- debian/mandos.prerm	2009-01-18 00:16:57 +0000
+++ debian/mandos.prerm	2011-10-10 20:29:58 +0000
@@ -1,4 +1,4 @@
-#! /bin/sh
+#!/bin/sh
 # prerm script for mandos
 #
 # see: dh_installdeb(1)

=== added file 'debian/source/local-options'
--- debian/source/local-options	1970-01-01 00:00:00 +0000
+++ debian/source/local-options	2011-10-08 21:13:46 +0000
@@ -0,0 +1,1 @@
+--single-debian-patch

=== modified file 'debian/watch'
--- debian/watch	2010-09-15 17:17:46 +0000
+++ debian/watch	2011-10-05 16:00:56 +0000
@@ -1,2 +1,2 @@
 version=3
-ftp://ftp.fukt.bsnet.se/pub/mandos/mandos[-_]([^\s]+?)(?:\.orig)?\.tar\.(?:gz|bz2|7z|xz)
+ftp://ftp.recompile.se/pub/mandos/mandos[-_]([^\s]+?)(?:\.orig)?\.tar\.(?:gz|bz2|7z|xz)

=== modified file 'init.d-mandos'
--- init.d-mandos	2009-09-16 23:28:39 +0000
+++ init.d-mandos	2011-10-05 16:00:56 +0000
@@ -9,8 +9,8 @@
 # Description:       Gives encrypted passwords to Mandos clients
 ### END INIT INFO
 
-# Author: Teddy Hogeborn <teddy@fukt.bsnet.se>
-# Author: Björn Påhlsson <belorn@fukt.bsnet.se>
+# Author: Teddy Hogeborn <teddy@recompile.se>
+# Author: Björn Påhlsson <belorn@recompile.se>
 #
 # Please remove the "Author" lines above and replace them
 # with your own name if you copy and modify this script.

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2010-09-09 18:16:14 +0000
+++ initramfs-tools-hook	2011-11-13 20:49:21 +0000
@@ -68,6 +68,7 @@
 CONFDIR="/conf/conf.d/mandos"
 MANDOSDIR="/lib/mandos"
 PLUGINDIR="${MANDOSDIR}/plugins.d"
+HOOKDIR="${MANDOSDIR}/network-hooks.d"
 
 # Make directories
 install --directory --mode=u=rwx,go=rx "${DESTDIR}${CONFDIR}" \
@@ -106,6 +107,24 @@
     esac
 done
 
+# Copy network hooks
+for hook in /etc/mandos/network-hooks.d/*; do
+    case "`basename \"$hook\"`" in
+	"*") continue ;;
+	*[!A-Za-z0-9_-]*) continue ;;
+	*) test -d "$hook" || copy_exec "$hook" "${HOOKDIR}" ;;
+    esac
+    # Copy any files needed by the network hook
+    MANDOSNETHOOKDIR=/etc/mandos/network-hooks.d MODE=files \
+	"$hook" files | while read file target; do
+	if [ -z "${target}" ]; then
+	    copy_exec "$file"
+	else
+	    copy_exec "$file" "$target"
+	fi
+    done
+done
+
 # GPGME needs /usr/bin/gpg
 if [ ! -e "${DESTDIR}/usr/bin/gpg" \
     -a -n "`ls \"${DESTDIR}\"/usr/lib/libgpgme.so* \
@@ -131,7 +150,7 @@
 	"${DESTDIR}${CONFDIR}/plugin-runner.conf"
 fi
 
-# Key files 
+# Key files
 for file in "$keydir"/*; do
     if [ -d "$file" ]; then
 	continue

=== modified file 'initramfs-tools-script'
--- initramfs-tools-script	2009-09-16 23:28:39 +0000
+++ initramfs-tools-script	2011-07-16 00:29:19 +0000
@@ -108,6 +108,7 @@
 
 # Our keyscript
 mandos=/lib/mandos/plugin-runner
+test -x "$mandos"
 
 # parse /conf/conf.d/cryptroot.  Format:
 # target=sda2_crypt,source=/dev/sda2,key=none,keyscript=/foo/bar/baz

=== added file 'intro.xml'
--- intro.xml	1970-01-01 00:00:00 +0000
+++ intro.xml	2011-10-05 16:00:56 +0000
@@ -0,0 +1,410 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
+"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
+<!ENTITY TIMESTAMP "2011-10-03">
+<!ENTITY % common SYSTEM "common.ent">
+%common;
+]>
+
+<refentry xmlns:xi="http://www.w3.org/2001/XInclude">
+   <refentryinfo>
+    <title>Mandos Manual</title>
+    <!-- NWalsh’s docbook scripts use this to generate the footer: -->
+    <productname>Mandos</productname>
+    <productnumber>&version;</productnumber>
+    <date>&TIMESTAMP;</date>
+    <authorgroup>
+      <author>
+	<firstname>Björn</firstname>
+	<surname>Påhlsson</surname>
+	<address>
+	  <email>belorn@recompile.se</email>
+	</address>
+      </author>
+      <author>
+	<firstname>Teddy</firstname>
+	<surname>Hogeborn</surname>
+	<address>
+	  <email>teddy@recompile.se</email>
+	</address>
+      </author>
+    </authorgroup>
+    <copyright>
+      <year>2011</year>
+      <holder>Teddy Hogeborn</holder>
+      <holder>Björn Påhlsson</holder>
+    </copyright>
+    <xi:include href="legalnotice.xml"/>
+  </refentryinfo>
+  
+  <refmeta>
+    <refentrytitle>intro</refentrytitle>
+    <manvolnum>8mandos</manvolnum>
+  </refmeta>
+  
+  <refnamediv>
+    <refname>intro</refname>
+    <refpurpose>
+      Introduction to the Mandos system
+    </refpurpose>
+  </refnamediv>
+  
+  <refsect1 id="description">
+    <title>DESCRIPTION</title>
+    <para>
+      This is the the Mandos system, which allows computers to have
+      encrypted root file systems and at the same time be capable of
+      remote and/or unattended reboots.
+    </para>
+    <para>
+      The computers run a small client program in the initial RAM disk
+      environment which will communicate with a server over a network.
+      All network communication is encrypted using TLS.  The clients
+      are identified by the server using an OpenPGP key; each client
+      has one unique to it.  The server sends the clients an encrypted
+      password.  The encrypted password is decrypted by the clients
+      using the same OpenPGP key, and the password is then used to
+      unlock the root file system, whereupon the computers can
+      continue booting normally.
+    </para>
+  </refsect1>
+  
+  <refsect1 id="introduction">
+    <title>INTRODUCTION</title>
+    <para>
+      You know how it is.  You’ve heard of it happening.  The Man
+      comes and takes away your servers, your friends’ servers, the
+      servers of everybody in the same hosting facility. The servers
+      of their neighbors, and their neighbors’ friends.  The servers
+      of people who owe them money.  And like
+      <emphasis>that</emphasis>, they’re gone.  And you doubt you’ll
+      ever see them again.
+    </para>
+    <para>
+      That is why your servers have encrypted root file systems.
+      However, there’s a downside.  There’s no going around it:
+      rebooting is a pain.  Dragging out that rarely-used keyboard and
+      screen and unraveling cables behind your servers to plug them in
+      to type in that password is messy, especially if you have many
+      servers.  There are some people who do clever things like using
+      serial line consoles and daisy-chain it to the next server, and
+      keep all the servers connected in a ring with serial cables,
+      which will work, if your servers are physically close enough.
+      There are also other out-of-band management solutions, but with
+      <emphasis>all</emphasis> these, you still have to be on hand and
+      manually type in the password at boot time.  Otherwise the
+      server just sits there, waiting for a password.
+    </para>
+    <para>
+      Wouldn’t it be great if you could have the security of encrypted
+      root file systems and still have servers that could boot up
+      automatically if there was a short power outage while you were
+      asleep?  That you could reboot at will, without having someone
+      run over to the server to type in the password?
+    </para>
+    <para>
+      Well, with Mandos, you (almost) can!  The gain in convenience
+      will only be offset by a small loss in security.  The setup is
+      as follows:
+    </para>
+    <para>
+      The server will still have its encrypted root file system.  The
+      password to this file system will be stored on another computer
+      (henceforth known as the Mandos server) on the same local
+      network.  The password will <emphasis>not</emphasis> be stored
+      in plaintext, but encrypted with OpenPGP.  To decrypt this
+      password, a key is needed.  This key (the Mandos client key)
+      will not be stored there, but back on the original server
+      (henceforth known as the Mandos client) in the initial RAM disk
+      image.  Oh, and all network Mandos client/server communications
+      will be encrypted, using TLS (SSL).
+    </para>
+    <para>
+      So, at boot time, the Mandos client will ask for its encrypted
+      data over the network, decrypt it to get the password, use it to
+      decrypt the root file, and continue booting.
+    </para>
+    <para>
+      Now, of course the initial RAM disk image is not on the
+      encrypted root file system, so anyone who had physical access
+      could take the Mandos client computer offline and read the disk
+      with their own tools to get the authentication keys used by a
+      client.  <emphasis>But</emphasis>, by then the Mandos server
+      should notice that the original server has been offline for too
+      long, and will no longer give out the encrypted key.  The timing
+      here is the only real weak point, and the method, frequency and
+      timeout of the server’s checking can be adjusted to any desired
+      level of paranoia
+    </para>
+    <para>
+      (The encrypted keys on the Mandos server is on its normal file
+      system, so those are safe, provided the root file system of
+      <emphasis>that</emphasis> server is encrypted.)
+    </para>
+  </refsect1>
+  
+  <refsect1 id="faq">
+    <title>FREQUENTLY ASKED QUESTIONS</title>
+    <para>
+      Couldn’t the security be defeated by…
+    </para>
+    <refsect2 id="quick">
+      <title>Grabbing the Mandos client key from the
+      initrd <emphasis>really quickly</emphasis>?</title>
+    <para>
+      This, as mentioned above, is the only real weak point.  But if
+      you set the timing values tight enough, this will be really
+      difficult to do.  An attacker would have to physically
+      disassemble the client computer, extract the key from the
+      initial RAM disk image, and then connect to a <emphasis>still
+      online</emphasis> Mandos server to get the encrypted key, and do
+      all this <emphasis>before</emphasis> the Mandos server timeout
+      kicks in and the Mandos server refuses to give out the key to
+      anyone.
+    </para>
+    <para>
+      Now, as the typical procedure seems to be to barge in and turn
+      off and grab <emphasis>all</emphasis> computers, to maybe look
+      at them months later, this is not likely.  If someone does that,
+      the whole system <emphasis>will</emphasis> lock itself up
+      completely, since Mandos servers are no longer running.
+    </para>
+    <para>
+      For sophisticated attackers who <emphasis>could</emphasis> do
+      the clever thing, <emphasis>and</emphasis> had physical access
+      to the server for enough time, it would be simpler to get a key
+      for an encrypted file system by using hardware memory scanners
+      and reading it right off the memory bus.
+    </para>
+    </refsect2>
+    
+    <refsect2 id="replay">
+      <title>Replay attacks?</title>
+      <para>
+	Nope, the network stuff is all done over TLS, which provides
+	protection against that.
+      </para>
+    </refsect2>
+    
+    <refsect2 id="mitm">
+      <title>Man-in-the-middle?</title>
+      <para>
+	No.  The server only gives out the passwords to clients which
+	have <emphasis>in the TLS handshake</emphasis> proven that
+	they do indeed hold the OpenPGP private key corresponding to
+	that client.
+      </para>
+    </refsect2>
+    
+    <refsect2 id="physgrab">
+      <title>Physically grabbing the Mandos server computer?</title>
+      <para>
+	You could protect <emphasis>that</emphasis> computer the
+	old-fashioned way, with a must-type-in-the-password-at-boot
+	method.  Or you could have two computers be the Mandos server
+	for each other.
+      </para>
+      <para>
+	Multiple Mandos servers can coexist on a network without any
+	trouble.  They do not clash, and clients will try all
+	available servers.  This means that if just one reboots then
+	the other can bring it back up, but if both reboot at the same
+	time they will stay down until someone types in the password
+	on one of them.
+      </para>
+    </refsect2>
+    
+    <refsect2 id="fakeping">
+      <title>Faking ping replies?</title>
+      <para>
+	The default for the server is to use
+	<quote><literal>fping</literal></quote>, the replies to which
+	could be faked to eliminate the timeout.  But this could
+	easily be changed to any shell command, with any security
+	measures you like.  It could, for instance, be changed to an
+	SSH command with strict keychecking, which could not be faked.
+	Or IPsec could be used for the ping packets, making them
+	secure.
+      </para>
+    </refsect2>
+  </refsect1>
+  
+  <refsect1 id="security">
+    <title>SECURITY</title>
+    <para>
+      So, in summary:  The only weakness in the Mandos system is from
+      people who have:
+    </para>
+    <orderedlist>
+      <listitem>
+	<para>
+	  The power to come in and physically take your servers,
+	  <emphasis>and</emphasis>
+	</para>
+      </listitem>
+      <listitem>
+	<para>
+	  The cunning and patience to do it carefully, one at a time,
+	  and <emphasis>quickly</emphasis>, faking Mandos
+	  client/server responses for each one before the timeout.
+	</para>
+      </listitem>
+    </orderedlist>
+    <para>
+      While there are some who may be threatened by people who have
+      <emphasis>both</emphasis> these attributes, they do not,
+      probably, constitute the majority.
+    </para>
+    <para>
+      If you <emphasis>do</emphasis> face such opponents, you must
+      figure that they could just as well open your servers and read
+      the file system keys right off the memory by running wires to
+      the memory bus.
+    </para>
+    <para>
+      What Mandos is designed to protect against is
+      <emphasis>not</emphasis> such determined, focused, and competent
+      attacks, but against the early morning knock on your door and
+      the sudden absence of all the servers in your server room.
+      Which it does nicely.
+    </para>
+  </refsect1>
+  
+  <refsect1 id="plugins">
+    <title>PLUGINS</title>
+    <para>
+      In the early designs, the
+      <citerefentry><refentrytitle>mandos-client</refentrytitle
+      ><manvolnum>8mandos</manvolnum></citerefentry> program (which
+      retrieves a password from the Mandos server) also prompted for a
+      password on the terminal, in case a Mandos server could not be
+      found.  Other ways of retrieving a password could easily be
+      envisoned, but this multiplicity of purpose was seen to be too
+      complex to be a viable way to continue.  Instead, the original
+      program was separated into <citerefentry><refentrytitle
+      >mandos-client</refentrytitle><manvolnum>8mandos</manvolnum
+      ></citerefentry> and <citerefentry><refentrytitle
+      >password-prompt</refentrytitle><manvolnum>8mandos</manvolnum
+      ></citerefentry>, and a <citerefentry><refentrytitle
+      >plugin-runner</refentrytitle><manvolnum>8mandos</manvolnum
+      ></citerefentry> exist to run them both in parallel, allowing
+      the first successful plugin to provide the password.  This
+      opened up for any number of additional plugins to run, all
+      competing to be the first to find a password and provide it to
+      the plugin runner.
+    </para>
+    <para>
+      Four additional plugins are provided:
+    </para>
+    <variablelist>
+      <varlistentry>
+	<term>
+	  <citerefentry><refentrytitle>plymouth</refentrytitle>
+	  <manvolnum>8mandos</manvolnum></citerefentry>
+	</term>
+	<listitem>
+	  <para>
+	    This prompts for a password when using <citerefentry>
+	    <refentrytitle>plymouth</refentrytitle><manvolnum
+	    >8</manvolnum></citerefentry>.
+	  </para>
+	</listitem>
+      </varlistentry>
+      <varlistentry>
+	<term>
+	  <citerefentry><refentrytitle>usplash</refentrytitle>
+	  <manvolnum>8mandos</manvolnum></citerefentry>
+	</term>
+	<listitem>
+	  <para>
+	    This prompts for a password when using <citerefentry>
+	    <refentrytitle>usplash</refentrytitle><manvolnum
+	    >8</manvolnum></citerefentry>.
+	  </para>
+	</listitem>
+      </varlistentry>
+      <varlistentry>
+	<term>
+	  <citerefentry><refentrytitle>splashy</refentrytitle>
+	  <manvolnum>8mandos</manvolnum></citerefentry>
+	</term>
+	<listitem>
+	  <para>
+	    This prompts for a password when using <citerefentry>
+	    <refentrytitle>splashy</refentrytitle><manvolnum
+	    >8</manvolnum></citerefentry>.
+	  </para>
+	</listitem>
+      </varlistentry>
+      <varlistentry>
+	<term>
+	  <citerefentry><refentrytitle>askpass-fifo</refentrytitle>
+	  <manvolnum>8mandos</manvolnum></citerefentry>
+	</term>
+	<listitem>
+	  <para>
+	    To provide compatibility with the "askpass" program from
+	    cryptsetup, this plugin listens to the same FIFO as
+	    askpass would do.
+	  </para>
+	</listitem>
+      </varlistentry>
+    </variablelist>
+    <para>
+      More plugins can easily be written and added by the system
+      administrator; see the section called "WRITING PLUGINS" in
+      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry> to learn the
+      plugin requirements.
+    </para>
+  </refsect1>
+  
+  <refsect1 id="see_also">
+    <title>SEE ALSO</title>
+    <para>
+      <citerefentry><refentrytitle>mandos</refentrytitle>
+      <manvolnum>8</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos.conf</refentrytitle>
+      <manvolnum>5</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
+      <manvolnum>5</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-ctl</refentrytitle>
+      <manvolnum>8</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-monitor</refentrytitle>
+      <manvolnum>8</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>plugin-runner</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-client</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>password-prompt</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>plymouth</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>usplash</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>splashy</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>askpass-fifo</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-keygen</refentrytitle>
+      <manvolnum>8</manvolnum></citerefentry>
+    </para>
+    <variablelist>
+      <varlistentry>
+	<term>
+	  <ulink url="http://www.recompile.se/mandos">Mandos</ulink>
+	</term>
+	<listitem>
+	  <para>
+	    The Mandos home page.
+	  </para>
+	</listitem>
+      </varlistentry>
+    </variablelist>
+  </refsect1>
+</refentry>
+<!-- Local Variables: -->
+<!-- time-stamp-start: "<!ENTITY TIMESTAMP [\"']" -->
+<!-- time-stamp-end: "[\"']>" -->
+<!-- time-stamp-format: "%:y-%02m-%02d" -->
+<!-- End: -->

=== modified file 'mandos'
--- mandos	2011-02-13 10:19:26 +0000
+++ mandos	2011-10-15 16:48:03 +0000
@@ -11,8 +11,8 @@
 # "AvahiService" class, and some lines in "main".
 # 
 # Everything else is
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
+# Copyright © 2008-2011 Teddy Hogeborn
+# Copyright © 2008-2011 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -28,7 +28,7 @@
 # along with this program.  If not, see
 # <http://www.gnu.org/licenses/>.
 # 
-# Contact the authors at <mandos@fukt.bsnet.se>.
+# Contact the authors at <mandos@recompile.se>.
 # 
 
 from __future__ import (division, absolute_import, print_function,
@@ -36,7 +36,7 @@
 
 import SocketServer as socketserver
 import socket
-import optparse
+import argparse
 import datetime
 import errno
 import gnutls.crypto
@@ -62,6 +62,7 @@
 import functools
 import cPickle as pickle
 import multiprocessing
+import types
 
 import dbus
 import dbus.service
@@ -82,7 +83,7 @@
         SO_BINDTODEVICE = None
 
 
-version = "1.2.3"
+version = "1.4.1"
 
 #logger = logging.getLogger('mandos')
 logger = logging.Logger('mandos')
@@ -151,6 +152,7 @@
         self.group = None       # our entry group
         self.server = None
         self.bus = bus
+        self.entry_group_state_changed_match = None
     def rename(self):
         """Derived from the Avahi example code"""
         if self.rename_count >= self.max_renames:
@@ -158,7 +160,8 @@
                             " after %i retries, exiting.",
                             self.rename_count)
             raise AvahiServiceError("Too many renames")
-        self.name = unicode(self.server.GetAlternativeServiceName(self.name))
+        self.name = unicode(self.server
+                            .GetAlternativeServiceName(self.name))
         logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
         syslogger.setFormatter(logging.Formatter
@@ -168,25 +171,29 @@
         self.remove()
         try:
             self.add()
-        except dbus.exceptions.DBusException, error:
+        except dbus.exceptions.DBusException as error:
             logger.critical("DBusException: %s", error)
             self.cleanup()
             os._exit(1)
         self.rename_count += 1
     def remove(self):
         """Derived from the Avahi example code"""
+        if self.entry_group_state_changed_match is not None:
+            self.entry_group_state_changed_match.remove()
+            self.entry_group_state_changed_match = None
         if self.group is not None:
             self.group.Reset()
     def add(self):
         """Derived from the Avahi example code"""
+        self.remove()
         if self.group is None:
             self.group = dbus.Interface(
                 self.bus.get_object(avahi.DBUS_NAME,
                                     self.server.EntryGroupNew()),
                 avahi.DBUS_INTERFACE_ENTRY_GROUP)
-            self.group.connect_to_signal('StateChanged',
-                                         self
-                                         .entry_group_state_changed)
+        self.entry_group_state_changed_match = (
+            self.group.connect_to_signal(
+                'StateChanged', self .entry_group_state_changed))
         logger.debug("Adding Zeroconf service '%s' of type '%s' ...",
                      self.name, self.type)
         self.group.AddService(
@@ -215,28 +222,56 @@
     def cleanup(self):
         """Derived from the Avahi example code"""
         if self.group is not None:
-            self.group.Free()
+            try:
+                self.group.Free()
+            except (dbus.exceptions.UnknownMethodException,
+                    dbus.exceptions.DBusException) as e:
+                pass
             self.group = None
-    def server_state_changed(self, state):
+        self.remove()
+    def server_state_changed(self, state, error=None):
         """Derived from the Avahi example code"""
         logger.debug("Avahi server state change: %i", state)
-        if state == avahi.SERVER_COLLISION:
-            logger.error("Zeroconf server name collision")
-            self.remove()
+        bad_states = { avahi.SERVER_INVALID:
+                           "Zeroconf server invalid",
+                       avahi.SERVER_REGISTERING: None,
+                       avahi.SERVER_COLLISION:
+                           "Zeroconf server name collision",
+                       avahi.SERVER_FAILURE:
+                           "Zeroconf server failure" }
+        if state in bad_states:
+            if bad_states[state] is not None:
+                if error is None:
+                    logger.error(bad_states[state])
+                else:
+                    logger.error(bad_states[state] + ": %r", error)
+            self.cleanup()
         elif state == avahi.SERVER_RUNNING:
             self.add()
+        else:
+            if error is None:
+                logger.debug("Unknown state: %r", state)
+            else:
+                logger.debug("Unknown state: %r: %r", state, error)
     def activate(self):
         """Derived from the Avahi example code"""
         if self.server is None:
             self.server = dbus.Interface(
                 self.bus.get_object(avahi.DBUS_NAME,
-                                    avahi.DBUS_PATH_SERVER),
+                                    avahi.DBUS_PATH_SERVER,
+                                    follow_name_owner_changes=True),
                 avahi.DBUS_INTERFACE_SERVER)
         self.server.connect_to_signal("StateChanged",
                                  self.server_state_changed)
         self.server_state_changed(self.server.GetState())
 
 
+def _timedelta_to_milliseconds(td):
+    "Convert a datetime.timedelta() to milliseconds"
+    return ((td.days * 24 * 60 * 60 * 1000)
+            + (td.seconds * 1000)
+            + (td.microseconds // 1000))
+        
 class Client(object):
     """A representation of a client host served by this server.
     
@@ -270,7 +305,10 @@
     secret:     bytestring; sent verbatim (over TLS) to client
     timeout:    datetime.timedelta(); How long from last_checked_ok
                                       until this client is disabled
+    extended_timeout:   extra long timeout when password has been sent
     runtime_expansions: Allowed attributes for runtime expansion.
+    expires:    datetime.datetime(); time (UTC) when a client will be
+                disabled, or None
     """
     
     runtime_expansions = ("approval_delay", "approval_duration",
@@ -278,23 +316,20 @@
                           "host", "interval", "last_checked_ok",
                           "last_enabled", "name", "timeout")
     
-    @staticmethod
-    def _timedelta_to_milliseconds(td):
-        "Convert a datetime.timedelta() to milliseconds"
-        return ((td.days * 24 * 60 * 60 * 1000)
-                + (td.seconds * 1000)
-                + (td.microseconds // 1000))
-    
     def timeout_milliseconds(self):
         "Return the 'timeout' attribute in milliseconds"
-        return self._timedelta_to_milliseconds(self.timeout)
+        return _timedelta_to_milliseconds(self.timeout)
+    
+    def extended_timeout_milliseconds(self):
+        "Return the 'extended_timeout' attribute in milliseconds"
+        return _timedelta_to_milliseconds(self.extended_timeout)
     
     def interval_milliseconds(self):
         "Return the 'interval' attribute in milliseconds"
-        return self._timedelta_to_milliseconds(self.interval)
-
+        return _timedelta_to_milliseconds(self.interval)
+    
     def approval_delay_milliseconds(self):
-        return self._timedelta_to_milliseconds(self.approval_delay)
+        return _timedelta_to_milliseconds(self.approval_delay)
     
     def __init__(self, name = None, disable_hook=None, config=None):
         """Note: the 'checker' key in 'config' sets the
@@ -327,11 +362,14 @@
         self.last_enabled = None
         self.last_checked_ok = None
         self.timeout = string_to_delta(config["timeout"])
+        self.extended_timeout = string_to_delta(config
+                                                ["extended_timeout"])
         self.interval = string_to_delta(config["interval"])
         self.disable_hook = disable_hook
         self.checker = None
         self.checker_initiator_tag = None
         self.disable_initiator_tag = None
+        self.expires = None
         self.checker_callback_tag = None
         self.checker_command = config["checker"]
         self.current_checker_command = None
@@ -344,30 +382,33 @@
             config["approval_delay"])
         self.approval_duration = string_to_delta(
             config["approval_duration"])
-        self.changedstate = multiprocessing_manager.Condition(multiprocessing_manager.Lock())
+        self.changedstate = (multiprocessing_manager
+                             .Condition(multiprocessing_manager
+                                        .Lock()))
     
     def send_changedstate(self):
         self.changedstate.acquire()
         self.changedstate.notify_all()
         self.changedstate.release()
-        
+    
     def enable(self):
         """Start this client's checker and timeout hooks"""
         if getattr(self, "enabled", False):
             # Already enabled
             return
         self.send_changedstate()
-        self.last_enabled = datetime.datetime.utcnow()
         # Schedule a new checker to be started an 'interval' from now,
         # and every interval from then on.
         self.checker_initiator_tag = (gobject.timeout_add
                                       (self.interval_milliseconds(),
                                        self.start_checker))
         # Schedule a disable() when 'timeout' has passed
+        self.expires = datetime.datetime.utcnow() + self.timeout
         self.disable_initiator_tag = (gobject.timeout_add
                                    (self.timeout_milliseconds(),
                                     self.disable))
         self.enabled = True
+        self.last_enabled = datetime.datetime.utcnow()
         # Also start a new checker *right now*.
         self.start_checker()
     
@@ -382,6 +423,7 @@
         if getattr(self, "disable_initiator_tag", False):
             gobject.source_remove(self.disable_initiator_tag)
             self.disable_initiator_tag = None
+        self.expires = None
         if getattr(self, "checker_initiator_tag", False):
             gobject.source_remove(self.checker_initiator_tag)
             self.checker_initiator_tag = None
@@ -413,17 +455,22 @@
             logger.warning("Checker for %(name)s crashed?",
                            vars(self))
     
-    def checked_ok(self):
+    def checked_ok(self, timeout=None):
         """Bump up the timeout for this client.
         
         This should only be called when the client has been seen,
         alive and well.
         """
+        if timeout is None:
+            timeout = self.timeout
         self.last_checked_ok = datetime.datetime.utcnow()
-        gobject.source_remove(self.disable_initiator_tag)
-        self.disable_initiator_tag = (gobject.timeout_add
-                                      (self.timeout_milliseconds(),
-                                       self.disable))
+        if self.disable_initiator_tag is not None:
+            gobject.source_remove(self.disable_initiator_tag)
+        if getattr(self, "enabled", False):
+            self.disable_initiator_tag = (gobject.timeout_add
+                                          (_timedelta_to_milliseconds
+                                           (timeout), self.disable))
+            self.expires = datetime.datetime.utcnow() + timeout
     
     def need_approval(self):
         self.last_approval_request = datetime.datetime.utcnow()
@@ -445,7 +492,7 @@
         # If a checker exists, make sure it is not a zombie
         try:
             pid, status = os.waitpid(self.checker.pid, os.WNOHANG)
-        except (AttributeError, OSError), error:
+        except (AttributeError, OSError) as error:
             if (isinstance(error, OSError)
                 and error.errno != errno.ECHILD):
                 raise error
@@ -469,10 +516,10 @@
                                        'replace')))
                     for attr in
                     self.runtime_expansions)
-
+                
                 try:
                     command = self.checker_command % escaped_attrs
-                except TypeError, error:
+                except TypeError as error:
                     logger.error('Could not format string "%s":'
                                  ' %s', self.checker_command, error)
                     return True # Try again later
@@ -497,7 +544,7 @@
                 if pid:
                     gobject.source_remove(self.checker_callback_tag)
                     self.checker_callback(pid, status, command)
-            except OSError, error:
+            except OSError as error:
                 logger.error("Failed to start subprocess: %s",
                              error)
         # Re-run this periodically if run by gobject.timeout_add
@@ -516,11 +563,12 @@
             #time.sleep(0.5)
             #if self.checker.poll() is None:
             #    os.kill(self.checker.pid, signal.SIGKILL)
-        except OSError, error:
+        except OSError as error:
             if error.errno != errno.ESRCH: # No such process
                 raise
         self.checker = None
 
+
 def dbus_service_property(dbus_interface, signature="v",
                           access="readwrite", byte_arrays=False):
     """Decorators for marking methods of a DBusObjectWithProperties to
@@ -572,7 +620,7 @@
 
 class DBusObjectWithProperties(dbus.service.Object):
     """A D-Bus object with properties.
-
+    
     Classes inheriting from this can use the dbus_service_property
     decorator to expose methods as D-Bus properties.  It exposes the
     standard Get(), Set(), and GetAll() methods on the D-Bus.
@@ -585,24 +633,22 @@
     def _get_all_dbus_properties(self):
         """Returns a generator of (name, attribute) pairs
         """
-        return ((prop._dbus_name, prop)
+        return ((prop.__get__(self)._dbus_name, prop.__get__(self))
+                for cls in self.__class__.__mro__
                 for name, prop in
-                inspect.getmembers(self, self._is_dbus_property))
+                inspect.getmembers(cls, self._is_dbus_property))
     
     def _get_dbus_property(self, interface_name, property_name):
         """Returns a bound method if one exists which is a D-Bus
         property with the specified name and interface.
         """
-        for name in (property_name,
-                     property_name + "_dbus_property"):
-            prop = getattr(self, name, None)
-            if (prop is None
-                or not self._is_dbus_property(prop)
-                or prop._dbus_name != property_name
-                or (interface_name and prop._dbus_interface
-                    and interface_name != prop._dbus_interface)):
-                continue
-            return prop
+        for cls in  self.__class__.__mro__:
+            for name, value in (inspect.getmembers
+                                (cls, self._is_dbus_property)):
+                if (value._dbus_name == property_name
+                    and value._dbus_interface == interface_name):
+                    return value.__get__(self)
+        
         # No such property
         raise DBusPropertyNotFound(self.dbus_object_path + ":"
                                    + interface_name + "."
@@ -642,7 +688,7 @@
     def GetAll(self, interface_name):
         """Standard D-Bus property GetAll() method, see D-Bus
         standard.
-
+        
         Note: Will not include properties with access="write".
         """
         all = {}
@@ -704,12 +750,116 @@
             xmlstring = document.toxml("utf-8")
             document.unlink()
         except (AttributeError, xml.dom.DOMException,
-                xml.parsers.expat.ExpatError), error:
+                xml.parsers.expat.ExpatError) as error:
             logger.error("Failed to override Introspection method",
                          error)
         return xmlstring
 
 
+def datetime_to_dbus (dt, variant_level=0):
+    """Convert a UTC datetime.datetime() to a D-Bus type."""
+    if dt is None:
+        return dbus.String("", variant_level = variant_level)
+    return dbus.String(dt.isoformat(),
+                       variant_level=variant_level)
+
+class AlternateDBusNamesMetaclass(DBusObjectWithProperties
+                                  .__metaclass__):
+    """Applied to an empty subclass of a D-Bus object, this metaclass
+    will add additional D-Bus attributes matching a certain pattern.
+    """
+    def __new__(mcs, name, bases, attr):
+        # Go through all the base classes which could have D-Bus
+        # methods, signals, or properties in them
+        for base in (b for b in bases
+                     if issubclass(b, dbus.service.Object)):
+            # Go though all attributes of the base class
+            for attrname, attribute in inspect.getmembers(base):
+                # Ignore non-D-Bus attributes, and D-Bus attributes
+                # with the wrong interface name
+                if (not hasattr(attribute, "_dbus_interface")
+                    or not attribute._dbus_interface
+                    .startswith("se.recompile.Mandos")):
+                    continue
+                # Create an alternate D-Bus interface name based on
+                # the current name
+                alt_interface = (attribute._dbus_interface
+                                 .replace("se.recompile.Mandos",
+                                          "se.bsnet.fukt.Mandos"))
+                # Is this a D-Bus signal?
+                if getattr(attribute, "_dbus_is_signal", False):
+                    # Extract the original non-method function by
+                    # black magic
+                    nonmethod_func = (dict(
+                            zip(attribute.func_code.co_freevars,
+                                attribute.__closure__))["func"]
+                                      .cell_contents)
+                    # Create a new, but exactly alike, function
+                    # object, and decorate it to be a new D-Bus signal
+                    # with the alternate D-Bus interface name
+                    new_function = (dbus.service.signal
+                                    (alt_interface,
+                                     attribute._dbus_signature)
+                                    (types.FunctionType(
+                                nonmethod_func.func_code,
+                                nonmethod_func.func_globals,
+                                nonmethod_func.func_name,
+                                nonmethod_func.func_defaults,
+                                nonmethod_func.func_closure)))
+                    # Define a creator of a function to call both the
+                    # old and new functions, so both the old and new
+                    # signals gets sent when the function is called
+                    def fixscope(func1, func2):
+                        """This function is a scope container to pass
+                        func1 and func2 to the "call_both" function
+                        outside of its arguments"""
+                        def call_both(*args, **kwargs):
+                            """This function will emit two D-Bus
+                            signals by calling func1 and func2"""
+                            func1(*args, **kwargs)
+                            func2(*args, **kwargs)
+                        return call_both
+                    # Create the "call_both" function and add it to
+                    # the class
+                    attr[attrname] = fixscope(attribute,
+                                              new_function)
+                # Is this a D-Bus method?
+                elif getattr(attribute, "_dbus_is_method", False):
+                    # Create a new, but exactly alike, function
+                    # object.  Decorate it to be a new D-Bus method
+                    # with the alternate D-Bus interface name.  Add it
+                    # to the class.
+                    attr[attrname] = (dbus.service.method
+                                      (alt_interface,
+                                       attribute._dbus_in_signature,
+                                       attribute._dbus_out_signature)
+                                      (types.FunctionType
+                                       (attribute.func_code,
+                                        attribute.func_globals,
+                                        attribute.func_name,
+                                        attribute.func_defaults,
+                                        attribute.func_closure)))
+                # Is this a D-Bus property?
+                elif getattr(attribute, "_dbus_is_property", False):
+                    # Create a new, but exactly alike, function
+                    # object, and decorate it to be a new D-Bus
+                    # property with the alternate D-Bus interface
+                    # name.  Add it to the class.
+                    attr[attrname] = (dbus_service_property
+                                      (alt_interface,
+                                       attribute._dbus_signature,
+                                       attribute._dbus_access,
+                                       attribute
+                                       ._dbus_get_args_options
+                                       ["byte_arrays"])
+                                      (types.FunctionType
+                                       (attribute.func_code,
+                                        attribute.func_globals,
+                                        attribute.func_name,
+                                        attribute.func_defaults,
+                                        attribute.func_closure)))
+        return type.__new__(mcs, name, bases, attr)
+
 class ClientDBus(Client, DBusObjectWithProperties):
     """A Client class using D-Bus
     
@@ -737,49 +887,72 @@
         DBusObjectWithProperties.__init__(self, self.bus,
                                           self.dbus_object_path)
         
-    def _get_approvals_pending(self):
-        return self._approvals_pending
-    def _set_approvals_pending(self, value):
-        old_value = self._approvals_pending
-        self._approvals_pending = value
-        bval = bool(value)
-        if (hasattr(self, "dbus_object_path")
-            and bval is not bool(old_value)):
-            dbus_bool = dbus.Boolean(bval, variant_level=1)
-            self.PropertyChanged(dbus.String("ApprovalPending"),
-                                 dbus_bool)
+    def notifychangeproperty(transform_func,
+                             dbus_name, type_func=lambda x: x,
+                             variant_level=1):
+        """ Modify a variable so that it's a property which announces
+        its changes to DBus.
 
-    approvals_pending = property(_get_approvals_pending,
-                                 _set_approvals_pending)
-    del _get_approvals_pending, _set_approvals_pending
-    
-    @staticmethod
-    def _datetime_to_dbus(dt, variant_level=0):
-        """Convert a UTC datetime.datetime() to a D-Bus type."""
-        return dbus.String(dt.isoformat(),
-                           variant_level=variant_level)
-    
-    def enable(self):
-        oldstate = getattr(self, "enabled", False)
-        r = Client.enable(self)
-        if oldstate != self.enabled:
-            # Emit D-Bus signals
-            self.PropertyChanged(dbus.String("Enabled"),
-                                 dbus.Boolean(True, variant_level=1))
-            self.PropertyChanged(
-                dbus.String("LastEnabled"),
-                self._datetime_to_dbus(self.last_enabled,
-                                       variant_level=1))
-        return r
-    
-    def disable(self, quiet = False):
-        oldstate = getattr(self, "enabled", False)
-        r = Client.disable(self, quiet=quiet)
-        if not quiet and oldstate != self.enabled:
-            # Emit D-Bus signal
-            self.PropertyChanged(dbus.String("Enabled"),
-                                 dbus.Boolean(False, variant_level=1))
-        return r
+        transform_fun: Function that takes a value and a variant_level
+                       and transforms it to a D-Bus type.
+        dbus_name: D-Bus name of the variable
+        type_func: Function that transform the value before sending it
+                   to the D-Bus.  Default: no transform
+        variant_level: D-Bus variant level.  Default: 1
+        """
+        attrname = "_{0}".format(dbus_name)
+        def setter(self, value):
+            if hasattr(self, "dbus_object_path"):
+                if (not hasattr(self, attrname) or
+                    type_func(getattr(self, attrname, None))
+                    != type_func(value)):
+                    dbus_value = transform_func(type_func(value),
+                                                variant_level
+                                                =variant_level)
+                    self.PropertyChanged(dbus.String(dbus_name),
+                                         dbus_value)
+            setattr(self, attrname, value)
+        
+        return property(lambda self: getattr(self, attrname), setter)
+    
+    
+    expires = notifychangeproperty(datetime_to_dbus, "Expires")
+    approvals_pending = notifychangeproperty(dbus.Boolean,
+                                             "ApprovalPending",
+                                             type_func = bool)
+    enabled = notifychangeproperty(dbus.Boolean, "Enabled")
+    last_enabled = notifychangeproperty(datetime_to_dbus,
+                                        "LastEnabled")
+    checker = notifychangeproperty(dbus.Boolean, "CheckerRunning",
+                                   type_func = lambda checker:
+                                       checker is not None)
+    last_checked_ok = notifychangeproperty(datetime_to_dbus,
+                                           "LastCheckedOK")
+    last_approval_request = notifychangeproperty(
+        datetime_to_dbus, "LastApprovalRequest")
+    approved_by_default = notifychangeproperty(dbus.Boolean,
+                                               "ApprovedByDefault")
+    approval_delay = notifychangeproperty(dbus.UInt16,
+                                          "ApprovalDelay",
+                                          type_func =
+                                          _timedelta_to_milliseconds)
+    approval_duration = notifychangeproperty(
+        dbus.UInt16, "ApprovalDuration",
+        type_func = _timedelta_to_milliseconds)
+    host = notifychangeproperty(dbus.String, "Host")
+    timeout = notifychangeproperty(dbus.UInt16, "Timeout",
+                                   type_func =
+                                   _timedelta_to_milliseconds)
+    extended_timeout = notifychangeproperty(
+        dbus.UInt16, "ExtendedTimeout",
+        type_func = _timedelta_to_milliseconds)
+    interval = notifychangeproperty(dbus.UInt16,
+                                    "Interval",
+                                    type_func =
+                                    _timedelta_to_milliseconds)
+    checker_command = notifychangeproperty(dbus.String, "Checker")
+    
+    del notifychangeproperty
     
     def __del__(self, *args, **kwargs):
         try:
@@ -794,9 +967,6 @@
                          *args, **kwargs):
         self.checker_callback_tag = None
         self.checker = None
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String("CheckerRunning"),
-                             dbus.Boolean(False, variant_level=1))
         if os.WIFEXITED(condition):
             exitstatus = os.WEXITSTATUS(condition)
             # Emit D-Bus signal
@@ -812,24 +982,6 @@
         return Client.checker_callback(self, pid, condition, command,
                                        *args, **kwargs)
     
-    def checked_ok(self, *args, **kwargs):
-        r = Client.checked_ok(self, *args, **kwargs)
-        # Emit D-Bus signal
-        self.PropertyChanged(
-            dbus.String("LastCheckedOK"),
-            (self._datetime_to_dbus(self.last_checked_ok,
-                                    variant_level=1)))
-        return r
-    
-    def need_approval(self, *args, **kwargs):
-        r = Client.need_approval(self, *args, **kwargs)
-        # Emit D-Bus signal
-        self.PropertyChanged(
-            dbus.String("LastApprovalRequest"),
-            (self._datetime_to_dbus(self.last_approval_request,
-                                    variant_level=1)))
-        return r
-    
     def start_checker(self, *args, **kwargs):
         old_checker = self.checker
         if self.checker is not None:
@@ -842,20 +994,8 @@
             and old_checker_pid != self.checker.pid):
             # Emit D-Bus signal
             self.CheckerStarted(self.current_checker_command)
-            self.PropertyChanged(
-                dbus.String("CheckerRunning"),
-                dbus.Boolean(True, variant_level=1))
         return r
     
-    def stop_checker(self, *args, **kwargs):
-        old_checker = getattr(self, "checker", None)
-        r = Client.stop_checker(self, *args, **kwargs)
-        if (old_checker is not None
-            and getattr(self, "checker", None) is None):
-            self.PropertyChanged(dbus.String("CheckerRunning"),
-                                 dbus.Boolean(False, variant_level=1))
-        return r
-
     def _reset_approved(self):
         self._approved = None
         return False
@@ -863,13 +1003,13 @@
     def approve(self, value=True):
         self.send_changedstate()
         self._approved = value
-        gobject.timeout_add(self._timedelta_to_milliseconds
+        gobject.timeout_add(_timedelta_to_milliseconds
                             (self.approval_duration),
                             self._reset_approved)
     
     
     ## D-Bus methods, signals & properties
-    _interface = "se.bsnet.fukt.Mandos.Client"
+    _interface = "se.recompile.Mandos.Client"
     
     ## Signals
     
@@ -922,7 +1062,7 @@
     # CheckedOK - method
     @dbus.service.method(_interface)
     def CheckedOK(self):
-        return self.checked_ok()
+        self.checked_ok()
     
     # Enable - method
     @dbus.service.method(_interface)
@@ -961,9 +1101,6 @@
         if value is None:       # get
             return dbus.Boolean(self.approved_by_default)
         self.approved_by_default = bool(value)
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String("ApprovedByDefault"),
-                             dbus.Boolean(value, variant_level=1))
     
     # ApprovalDelay - property
     @dbus_service_property(_interface, signature="t",
@@ -972,21 +1109,15 @@
         if value is None:       # get
             return dbus.UInt64(self.approval_delay_milliseconds())
         self.approval_delay = datetime.timedelta(0, 0, 0, value)
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String("ApprovalDelay"),
-                             dbus.UInt64(value, variant_level=1))
     
     # ApprovalDuration - property
     @dbus_service_property(_interface, signature="t",
                            access="readwrite")
     def ApprovalDuration_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(self._timedelta_to_milliseconds(
+            return dbus.UInt64(_timedelta_to_milliseconds(
                     self.approval_duration))
         self.approval_duration = datetime.timedelta(0, 0, 0, value)
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String("ApprovalDuration"),
-                             dbus.UInt64(value, variant_level=1))
     
     # Name - property
     @dbus_service_property(_interface, signature="s", access="read")
@@ -1005,21 +1136,16 @@
         if value is None:       # get
             return dbus.String(self.host)
         self.host = value
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String("Host"),
-                             dbus.String(value, variant_level=1))
     
     # Created - property
     @dbus_service_property(_interface, signature="s", access="read")
     def Created_dbus_property(self):
-        return dbus.String(self._datetime_to_dbus(self.created))
+        return dbus.String(datetime_to_dbus(self.created))
     
     # LastEnabled - property
     @dbus_service_property(_interface, signature="s", access="read")
     def LastEnabled_dbus_property(self):
-        if self.last_enabled is None:
-            return dbus.String("")
-        return dbus.String(self._datetime_to_dbus(self.last_enabled))
+        return datetime_to_dbus(self.last_enabled)
     
     # Enabled - property
     @dbus_service_property(_interface, signature="b",
@@ -1039,19 +1165,17 @@
         if value is not None:
             self.checked_ok()
             return
-        if self.last_checked_ok is None:
-            return dbus.String("")
-        return dbus.String(self._datetime_to_dbus(self
-                                                  .last_checked_ok))
+        return datetime_to_dbus(self.last_checked_ok)
+    
+    # Expires - property
+    @dbus_service_property(_interface, signature="s", access="read")
+    def Expires_dbus_property(self):
+        return datetime_to_dbus(self.expires)
     
     # LastApprovalRequest - property
     @dbus_service_property(_interface, signature="s", access="read")
     def LastApprovalRequest_dbus_property(self):
-        if self.last_approval_request is None:
-            return dbus.String("")
-        return dbus.String(self.
-                           _datetime_to_dbus(self
-                                             .last_approval_request))
+        return datetime_to_dbus(self.last_approval_request)
     
     # Timeout - property
     @dbus_service_property(_interface, signature="t",
@@ -1060,27 +1184,35 @@
         if value is None:       # get
             return dbus.UInt64(self.timeout_milliseconds())
         self.timeout = datetime.timedelta(0, 0, 0, value)
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String("Timeout"),
-                             dbus.UInt64(value, variant_level=1))
         if getattr(self, "disable_initiator_tag", None) is None:
             return
         # Reschedule timeout
         gobject.source_remove(self.disable_initiator_tag)
         self.disable_initiator_tag = None
-        time_to_die = (self.
-                       _timedelta_to_milliseconds((self
-                                                   .last_checked_ok
-                                                   + self.timeout)
-                                                  - datetime.datetime
-                                                  .utcnow()))
+        self.expires = None
+        time_to_die = _timedelta_to_milliseconds((self
+                                                  .last_checked_ok
+                                                  + self.timeout)
+                                                 - datetime.datetime
+                                                 .utcnow())
         if time_to_die <= 0:
             # The timeout has passed
             self.disable()
         else:
+            self.expires = (datetime.datetime.utcnow()
+                            + datetime.timedelta(milliseconds =
+                                                 time_to_die))
             self.disable_initiator_tag = (gobject.timeout_add
                                           (time_to_die, self.disable))
     
+    # ExtendedTimeout - property
+    @dbus_service_property(_interface, signature="t",
+                           access="readwrite")
+    def ExtendedTimeout_dbus_property(self, value=None):
+        if value is None:       # get
+            return dbus.UInt64(self.extended_timeout_milliseconds())
+        self.extended_timeout = datetime.timedelta(0, 0, 0, value)
+    
     # Interval - property
     @dbus_service_property(_interface, signature="t",
                            access="readwrite")
@@ -1088,9 +1220,6 @@
         if value is None:       # get
             return dbus.UInt64(self.interval_milliseconds())
         self.interval = datetime.timedelta(0, 0, 0, value)
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String("Interval"),
-                             dbus.UInt64(value, variant_level=1))
         if getattr(self, "checker_initiator_tag", None) is None:
             return
         # Reschedule checker run
@@ -1098,7 +1227,7 @@
         self.checker_initiator_tag = (gobject.timeout_add
                                       (value, self.start_checker))
         self.start_checker()    # Start one now, too
-
+    
     # Checker - property
     @dbus_service_property(_interface, signature="s",
                            access="readwrite")
@@ -1106,10 +1235,6 @@
         if value is None:       # get
             return dbus.String(self.checker_command)
         self.checker_command = value
-        # Emit D-Bus signal
-        self.PropertyChanged(dbus.String("Checker"),
-                             dbus.String(self.checker_command,
-                                         variant_level=1))
     
     # CheckerRunning - property
     @dbus_service_property(_interface, signature="b",
@@ -1142,7 +1267,7 @@
         self._pipe.send(('init', fpr, address))
         if not self._pipe.recv():
             raise KeyError()
-
+    
     def __getattribute__(self, name):
         if(name == '_pipe'):
             return super(ProxyClient, self).__getattribute__(name)
@@ -1155,12 +1280,14 @@
                 self._pipe.send(('funcall', name, args, kwargs))
                 return self._pipe.recv()[1]
             return func
-
+    
     def __setattr__(self, name, value):
         if(name == '_pipe'):
             return super(ProxyClient, self).__setattr__(name, value)
         self._pipe.send(('setattr', name, value))
 
+class ClientDBusTransitional(ClientDBus):
+    __metaclass__ = AlternateDBusNamesMetaclass
 
 class ClientHandler(socketserver.BaseRequestHandler, object):
     """A class to handle client connections.
@@ -1174,17 +1301,17 @@
                         unicode(self.client_address))
             logger.debug("Pipe FD: %d",
                          self.server.child_pipe.fileno())
-
+            
             session = (gnutls.connection
                        .ClientSession(self.request,
                                       gnutls.connection
                                       .X509Credentials()))
-
+            
             # Note: gnutls.connection.X509Credentials is really a
             # generic GnuTLS certificate credentials object so long as
             # no X.509 keys are added to it.  Therefore, we can use it
             # here despite using OpenPGP certificates.
-
+            
             #priority = ':'.join(("NONE", "+VERS-TLS1.1",
             #                      "+AES-256-CBC", "+SHA1",
             #                      "+COMP-NULL", "+CTYPE-OPENPGP",
@@ -1196,7 +1323,7 @@
             (gnutls.library.functions
              .gnutls_priority_set_direct(session._c_object,
                                          priority, None))
-
+            
             # Start communication using the Mandos protocol
             # Get protocol number
             line = self.request.makefile().readline()
@@ -1204,30 +1331,31 @@
             try:
                 if int(line.strip().split()[0]) > 1:
                     raise RuntimeError
-            except (ValueError, IndexError, RuntimeError), error:
+            except (ValueError, IndexError, RuntimeError) as error:
                 logger.error("Unknown protocol version: %s", error)
                 return
-
+            
             # Start GnuTLS connection
             try:
                 session.handshake()
-            except gnutls.errors.GNUTLSError, error:
+            except gnutls.errors.GNUTLSError as error:
                 logger.warning("Handshake failed: %s", error)
                 # Do not run session.bye() here: the session is not
                 # established.  Just abandon the request.
                 return
             logger.debug("Handshake succeeded")
-
+            
             approval_required = False
             try:
                 try:
                     fpr = self.fingerprint(self.peer_certificate
                                            (session))
-                except (TypeError, gnutls.errors.GNUTLSError), error:
+                except (TypeError,
+                        gnutls.errors.GNUTLSError) as error:
                     logger.warning("Bad certificate: %s", error)
                     return
                 logger.debug("Fingerprint: %s", fpr)
-
+                
                 try:
                     client = ProxyClient(child_pipe, fpr,
                                          self.client_address)
@@ -1241,11 +1369,11 @@
                 
                 while True:
                     if not client.enabled:
-                        logger.warning("Client %s is disabled",
+                        logger.info("Client %s is disabled",
                                        client.name)
                         if self.server.use_dbus:
                             # Emit D-Bus signal
-                            client.Rejected("Disabled")                    
+                            client.Rejected("Disabled")
                         return
                     
                     if client._approved or not client.approval_delay:
@@ -1268,10 +1396,11 @@
                         return
                     
                     #wait until timeout or approved
-                    #x = float(client._timedelta_to_milliseconds(delay))
                     time = datetime.datetime.now()
                     client.changedstate.acquire()
-                    client.changedstate.wait(float(client._timedelta_to_milliseconds(delay) / 1000))
+                    (client.changedstate.wait
+                     (float(client._timedelta_to_milliseconds(delay)
+                            / 1000)))
                     client.changedstate.release()
                     time2 = datetime.datetime.now()
                     if (time2 - time) >= delay:
@@ -1292,17 +1421,17 @@
                 while sent_size < len(client.secret):
                     try:
                         sent = session.send(client.secret[sent_size:])
-                    except (gnutls.errors.GNUTLSError), error:
+                    except gnutls.errors.GNUTLSError as error:
                         logger.warning("gnutls send failed")
                         return
                     logger.debug("Sent: %d, remaining: %d",
                                  sent, len(client.secret)
                                  - (sent_size + sent))
                     sent_size += sent
-
+                
                 logger.info("Sending secret to %s", client.name)
-                # bump the timeout as if seen
-                client.checked_ok()
+                # bump the timeout using extended_timeout
+                client.checked_ok(client.extended_timeout)
                 if self.server.use_dbus:
                     # Emit D-Bus signal
                     client.GotSecret()
@@ -1312,7 +1441,7 @@
                     client.approvals_pending -= 1
                 try:
                     session.bye()
-                except (gnutls.errors.GNUTLSError), error:
+                except gnutls.errors.GNUTLSError as error:
                     logger.warning("GnuTLS bye failed")
     
     @staticmethod
@@ -1387,11 +1516,15 @@
         except:
             self.handle_error(request, address)
         self.close_request(request)
-            
+    
     def process_request(self, request, address):
         """Start a new process to process the request."""
-        multiprocessing.Process(target = self.sub_process_main,
-                                args = (request, address)).start()
+        proc = multiprocessing.Process(target = self.sub_process_main,
+                                       args = (request,
+                                               address))
+        proc.start()
+        return proc
+
 
 class MultiprocessingMixInWithPipe(MultiprocessingMixIn, object):
     """ adds a pipe to the MixIn """
@@ -1401,15 +1534,16 @@
         This function creates a new pipe in self.pipe
         """
         parent_pipe, self.child_pipe = multiprocessing.Pipe()
-
-        super(MultiprocessingMixInWithPipe,
-              self).process_request(request, client_address)
+        
+        proc = MultiprocessingMixIn.process_request(self, request,
+                                                    client_address)
         self.child_pipe.close()
-        self.add_pipe(parent_pipe)
-
-    def add_pipe(self, parent_pipe):
+        self.add_pipe(parent_pipe, proc)
+    
+    def add_pipe(self, parent_pipe, proc):
         """Dummy function; override as necessary"""
-        pass
+        raise NotImplementedError
+
 
 class IPv6_TCPServer(MultiprocessingMixInWithPipe,
                      socketserver.TCPServer, object):
@@ -1442,7 +1576,7 @@
                                            SO_BINDTODEVICE,
                                            str(self.interface
                                                + '\0'))
-                except socket.error, error:
+                except socket.error as error:
                     if error[0] == errno.EPERM:
                         logger.error("No permission to"
                                      " bind to interface %s",
@@ -1500,17 +1634,21 @@
     def server_activate(self):
         if self.enabled:
             return socketserver.TCPServer.server_activate(self)
+    
     def enable(self):
         self.enabled = True
-    def add_pipe(self, parent_pipe):
+    
+    def add_pipe(self, parent_pipe, proc):
         # Call "handle_ipc" for both data and EOF events
         gobject.io_add_watch(parent_pipe.fileno(),
                              gobject.IO_IN | gobject.IO_HUP,
                              functools.partial(self.handle_ipc,
-                                               parent_pipe = parent_pipe))
-        
+                                               parent_pipe =
+                                               parent_pipe,
+                                               proc = proc))
+    
     def handle_ipc(self, source, condition, parent_pipe=None,
-                   client_object=None):
+                   proc = None, client_object=None):
         condition_names = {
             gobject.IO_IN: "IN",   # There is data to read.
             gobject.IO_OUT: "OUT", # Data can be written (without
@@ -1525,8 +1663,10 @@
                                        for cond, name in
                                        condition_names.iteritems()
                                        if cond & condition)
-        # error or the other end of multiprocessing.Pipe has closed
+        # error, or the other end of multiprocessing.Pipe has closed
         if condition & (gobject.IO_ERR | condition & gobject.IO_HUP):
+            # Wait for other process to exit
+            proc.join()
             return False
         
         # Read a request from the child
@@ -1542,41 +1682,49 @@
                     client = c
                     break
             else:
-                logger.warning("Client not found for fingerprint: %s, ad"
-                               "dress: %s", fpr, address)
+                logger.info("Client not found for fingerprint: %s, ad"
+                            "dress: %s", fpr, address)
                 if self.use_dbus:
                     # Emit D-Bus signal
-                    mandos_dbus_service.ClientNotFound(fpr, address[0])
+                    mandos_dbus_service.ClientNotFound(fpr,
+                                                       address[0])
                 parent_pipe.send(False)
                 return False
             
             gobject.io_add_watch(parent_pipe.fileno(),
                                  gobject.IO_IN | gobject.IO_HUP,
                                  functools.partial(self.handle_ipc,
-                                                   parent_pipe = parent_pipe,
-                                                   client_object = client))
+                                                   parent_pipe =
+                                                   parent_pipe,
+                                                   proc = proc,
+                                                   client_object =
+                                                   client))
             parent_pipe.send(True)
-            # remove the old hook in favor of the new above hook on same fileno
+            # remove the old hook in favor of the new above hook on
+            # same fileno
             return False
         if command == 'funcall':
             funcname = request[1]
             args = request[2]
             kwargs = request[3]
             
-            parent_pipe.send(('data', getattr(client_object, funcname)(*args, **kwargs)))
-
+            parent_pipe.send(('data', getattr(client_object,
+                                              funcname)(*args,
+                                                         **kwargs)))
+        
         if command == 'getattr':
             attrname = request[1]
             if callable(client_object.__getattribute__(attrname)):
                 parent_pipe.send(('function',))
             else:
-                parent_pipe.send(('data', client_object.__getattribute__(attrname)))
+                parent_pipe.send(('data', client_object
+                                  .__getattribute__(attrname)))
         
         if command == 'setattr':
             attrname = request[1]
             value = request[2]
             setattr(client_object, attrname, value)
-
+        
         return True
 
 
@@ -1613,8 +1761,8 @@
                 delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
             else:
                 raise ValueError("Unknown suffix %r" % suffix)
-        except (ValueError, IndexError), e:
-            raise ValueError(e.message)
+        except (ValueError, IndexError) as e:
+            raise ValueError(*(e.args))
         timevalue += delta
     return timevalue
 
@@ -1673,34 +1821,37 @@
     ##################################################################
     # Parsing of options, both command line and config file
     
-    parser = optparse.OptionParser(version = "%%prog %s" % version)
-    parser.add_option("-i", "--interface", type="string",
-                      metavar="IF", help="Bind to interface IF")
-    parser.add_option("-a", "--address", type="string",
-                      help="Address to listen for requests on")
-    parser.add_option("-p", "--port", type="int",
-                      help="Port number to receive requests on")
-    parser.add_option("--check", action="store_true",
-                      help="Run self-test")
-    parser.add_option("--debug", action="store_true",
-                      help="Debug mode; run in foreground and log to"
-                      " terminal")
-    parser.add_option("--debuglevel", type="string", metavar="LEVEL",
-                      help="Debug level for stdout output")
-    parser.add_option("--priority", type="string", help="GnuTLS"
-                      " priority string (see GnuTLS documentation)")
-    parser.add_option("--servicename", type="string",
-                      metavar="NAME", help="Zeroconf service name")
-    parser.add_option("--configdir", type="string",
-                      default="/etc/mandos", metavar="DIR",
-                      help="Directory to search for configuration"
-                      " files")
-    parser.add_option("--no-dbus", action="store_false",
-                      dest="use_dbus", help="Do not provide D-Bus"
-                      " system bus interface")
-    parser.add_option("--no-ipv6", action="store_false",
-                      dest="use_ipv6", help="Do not use IPv6")
-    options = parser.parse_args()[0]
+    parser = argparse.ArgumentParser()
+    parser.add_argument("-v", "--version", action="version",
+                        version = "%%(prog)s %s" % version,
+                        help="show version number and exit")
+    parser.add_argument("-i", "--interface", metavar="IF",
+                        help="Bind to interface IF")
+    parser.add_argument("-a", "--address",
+                        help="Address to listen for requests on")
+    parser.add_argument("-p", "--port", type=int,
+                        help="Port number to receive requests on")
+    parser.add_argument("--check", action="store_true",
+                        help="Run self-test")
+    parser.add_argument("--debug", action="store_true",
+                        help="Debug mode; run in foreground and log"
+                        " to terminal")
+    parser.add_argument("--debuglevel", metavar="LEVEL",
+                        help="Debug level for stdout output")
+    parser.add_argument("--priority", help="GnuTLS"
+                        " priority string (see GnuTLS documentation)")
+    parser.add_argument("--servicename",
+                        metavar="NAME", help="Zeroconf service name")
+    parser.add_argument("--configdir",
+                        default="/etc/mandos", metavar="DIR",
+                        help="Directory to search for configuration"
+                        " files")
+    parser.add_argument("--no-dbus", action="store_false",
+                        dest="use_dbus", help="Do not provide D-Bus"
+                        " system bus interface")
+    parser.add_argument("--no-ipv6", action="store_false",
+                        dest="use_ipv6", help="Do not use IPv6")
+    options = parser.parse_args()
     
     if options.check:
         import doctest
@@ -1758,7 +1909,7 @@
     debuglevel = server_settings["debuglevel"]
     use_dbus = server_settings["use_dbus"]
     use_ipv6 = server_settings["use_ipv6"]
-
+    
     if server_settings["servicename"] != "Mandos":
         syslogger.setFormatter(logging.Formatter
                                ('Mandos (%s) [%%(process)d]:'
@@ -1766,8 +1917,9 @@
                                 % server_settings["servicename"]))
     
     # Parse config file with clients
-    client_defaults = { "timeout": "1h",
-                        "interval": "5m",
+    client_defaults = { "timeout": "5m",
+                        "extended_timeout": "15m",
+                        "interval": "2m",
                         "checker": "fping -q -- %%(host)s",
                         "host": "",
                         "approval_delay": "0s",
@@ -1813,7 +1965,7 @@
     try:
         os.setgid(gid)
         os.setuid(uid)
-    except OSError, error:
+    except OSError as error:
         if error[0] != errno.EPERM:
             raise error
     
@@ -1824,7 +1976,7 @@
         level = getattr(logging, debuglevel.upper())
         syslogger.setLevel(level)
         console.setLevel(level)
-
+    
     if debug:
         # Enable all possible GnuTLS debugging
         
@@ -1861,9 +2013,12 @@
     # End of Avahi example code
     if use_dbus:
         try:
-            bus_name = dbus.service.BusName("se.bsnet.fukt.Mandos",
+            bus_name = dbus.service.BusName("se.recompile.Mandos",
                                             bus, do_not_queue=True)
-        except dbus.exceptions.NameExistsException, e:
+            old_bus_name = (dbus.service.BusName
+                            ("se.bsnet.fukt.Mandos", bus,
+                             do_not_queue=True))
+        except dbus.exceptions.NameExistsException as e:
             logger.error(unicode(e) + ", disabling D-Bus")
             use_dbus = False
             server_settings["use_dbus"] = False
@@ -1881,7 +2036,8 @@
     
     client_class = Client
     if use_dbus:
-        client_class = functools.partial(ClientDBus, bus = bus)
+        client_class = functools.partial(ClientDBusTransitional,
+                                         bus = bus)
     def client_config_items(config, section):
         special_settings = {
             "approved_by_default":
@@ -1917,7 +2073,7 @@
         del pidfilename
         
         signal.signal(signal.SIGINT, signal.SIG_IGN)
-
+    
     signal.signal(signal.SIGHUP, lambda signum, frame: sys.exit())
     signal.signal(signal.SIGTERM, lambda signum, frame: sys.exit())
     
@@ -1926,7 +2082,7 @@
             """A D-Bus proxy object"""
             def __init__(self):
                 dbus.service.Object.__init__(self, bus, "/")
-            _interface = "se.bsnet.fukt.Mandos"
+            _interface = "se.recompile.Mandos"
             
             @dbus.service.signal(_interface, signature="o")
             def ClientAdded(self, objpath):
@@ -1974,12 +2130,15 @@
             
             del _interface
         
-        mandos_dbus_service = MandosDBusService()
+        class MandosDBusServiceTransitional(MandosDBusService):
+            __metaclass__ = AlternateDBusNamesMetaclass
+        mandos_dbus_service = MandosDBusServiceTransitional()
     
     def cleanup():
         "Cleanup function; run on exit"
         service.cleanup()
         
+        multiprocessing.active_children()
         while tcp_server.clients:
             client = tcp_server.clients.pop()
             if use_dbus:
@@ -1989,7 +2148,8 @@
             client.disable(quiet=True)
             if use_dbus:
                 # Emit D-Bus signal
-                mandos_dbus_service.ClientRemoved(client.dbus_object_path,
+                mandos_dbus_service.ClientRemoved(client
+                                                  .dbus_object_path,
                                                   client.name)
     
     atexit.register(cleanup)
@@ -2019,7 +2179,7 @@
         # From the Avahi example code
         try:
             service.activate()
-        except dbus.exceptions.DBusException, error:
+        except dbus.exceptions.DBusException as error:
             logger.critical("DBusException: %s", error)
             cleanup()
             sys.exit(1)
@@ -2032,7 +2192,7 @@
         
         logger.debug("Starting main loop")
         main_loop.run()
-    except AvahiError, error:
+    except AvahiError as error:
         logger.critical("AvahiError: %s", error)
         cleanup()
         sys.exit(1)
@@ -2044,5 +2204,6 @@
     # Must run before the D-Bus bus name gets deregistered
     cleanup()
 
+
 if __name__ == '__main__':
     main()

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2010-09-27 18:57:12 +0000
+++ mandos-clients.conf.xml	2011-10-10 20:29:58 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2011-10-10">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -20,14 +20,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
@@ -35,6 +35,7 @@
       <year>2008</year>
       <year>2009</year>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -181,6 +182,29 @@
       </varlistentry>
       
       <varlistentry>
+	<term><option>extended_timeout<literal> = </literal><replaceable
+	>TIME</replaceable></option></term>
+	<listitem>
+	  <para>
+	    This option is <emphasis>optional</emphasis>.
+	  </para>
+	  <para>
+	    Extended timeout is an added timeout that is given once
+	    after a password has been sent successfully to a client.
+	    The timeout is by default longer than the normal timeout,
+	    and is used for handling the extra long downtime while a
+	    machine is booting up.  Time to take into consideration
+	    when changing this value is file system checks and quota
+	    checks.  The default value is 15 minutes.
+	  </para>
+	  <para>
+	    The format of <replaceable>TIME</replaceable> is the same
+	    as for <varname>timeout</varname> below.
+	  </para>
+	</listitem>
+      </varlistentry>
+      
+      <varlistentry>
 	<term><option>fingerprint<literal> = </literal
 	><replaceable>HEXSTRING</replaceable></option></term>
 	<listitem>
@@ -228,7 +252,7 @@
 	    will wait for a checker to complete until the below
 	    <quote><varname>timeout</varname></quote> occurs, at which
 	    time the client will be disabled, and any running checker
-	    killed.  The default interval is 5 minutes.
+	    killed.  The default interval is 2 minutes.
 	  </para>
 	  <para>
 	    The format of <replaceable>TIME</replaceable> is the same
@@ -298,10 +322,11 @@
 	    This option is <emphasis>optional</emphasis>.
 	  </para>
 	  <para>
-	    The timeout is how long the server will wait (for either a
-	    successful checker run or a client receiving its secret)
-	    until a client is disabled and not allowed to get the data
-	    this server holds.  By default Mandos will use 1 hour.
+	    The timeout is how long the server will wait, after a
+	    successful checker run, until a client is disabled and not
+	    allowed to get the data this server holds.  By default
+	    Mandos will use 5 minutes.  See also the
+	    <option>extended_timeout</option> option.
 	  </para>
 	  <para>
 	    The <replaceable>TIME</replaceable> is specified as a
@@ -419,8 +444,8 @@
     <informalexample>
       <programlisting>
 [DEFAULT]
-timeout = 1h
-interval = 5m
+timeout = 5m
+interval = 2m
 checker = fping -q -- %%(host)s
 
 # Client "foo"
@@ -459,6 +484,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-keygen</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos.conf</refentrytitle>

=== modified file 'mandos-ctl'
--- mandos-ctl	2010-10-11 17:45:21 +0000
+++ mandos-ctl	2011-10-15 16:48:03 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
+# Copyright © 2008-2011 Teddy Hogeborn
+# Copyright © 2008-2011 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,76 +19,78 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 # 
-# Contact the authors at <mandos@fukt.bsnet.se>.
+# Contact the authors at <mandos@recompile.se>.
 # 
 
-from __future__ import division
+from __future__ import (division, absolute_import, print_function,
+                        unicode_literals)
+
 import sys
 import dbus
-from optparse import OptionParser
+import argparse
 import locale
 import datetime
 import re
 import os
 
-locale.setlocale(locale.LC_ALL, u'')
+locale.setlocale(locale.LC_ALL, "")
 
 tablewords = {
-    'Name': u'Name',
-    'Enabled': u'Enabled',
-    'Timeout': u'Timeout',
-    'LastCheckedOK': u'Last Successful Check',
-    'LastApprovalRequest': u'Last Approval Request',
-    'Created': u'Created',
-    'Interval': u'Interval',
-    'Host': u'Host',
-    'Fingerprint': u'Fingerprint',
-    'CheckerRunning': u'Check Is Running',
-    'LastEnabled': u'Last Enabled',
-    'ApprovalPending': u'Approval Is Pending',
-    'ApprovedByDefault': u'Approved By Default',
-    'ApprovalDelay': u"Approval Delay",
-    'ApprovalDuration': u"Approval Duration",
-    'Checker': u'Checker',
+    "Name": "Name",
+    "Enabled": "Enabled",
+    "Timeout": "Timeout",
+    "LastCheckedOK": "Last Successful Check",
+    "LastApprovalRequest": "Last Approval Request",
+    "Created": "Created",
+    "Interval": "Interval",
+    "Host": "Host",
+    "Fingerprint": "Fingerprint",
+    "CheckerRunning": "Check Is Running",
+    "LastEnabled": "Last Enabled",
+    "ApprovalPending": "Approval Is Pending",
+    "ApprovedByDefault": "Approved By Default",
+    "ApprovalDelay": "Approval Delay",
+    "ApprovalDuration": "Approval Duration",
+    "Checker": "Checker",
+    "ExtendedTimeout" : "Extended Timeout"
     }
-defaultkeywords = ('Name', 'Enabled', 'Timeout', 'LastCheckedOK')
-domain = 'se.bsnet.fukt'
-busname = domain + '.Mandos'
-server_path = '/'
-server_interface = domain + '.Mandos'
-client_interface = domain + '.Mandos.Client'
-version = "1.2.3"
+defaultkeywords = ("Name", "Enabled", "Timeout", "LastCheckedOK")
+domain = "se.recompile"
+busname = domain + ".Mandos"
+server_path = "/"
+server_interface = domain + ".Mandos"
+client_interface = domain + ".Mandos.Client"
+version = "1.4.1"
 
 def timedelta_to_milliseconds(td):
-    "Convert a datetime.timedelta object to milliseconds"
+    """Convert a datetime.timedelta object to milliseconds"""
     return ((td.days * 24 * 60 * 60 * 1000)
             + (td.seconds * 1000)
             + (td.microseconds // 1000))
 
 def milliseconds_to_string(ms):
     td = datetime.timedelta(0, 0, 0, ms)
-    return (u"%(days)s%(hours)02d:%(minutes)02d:%(seconds)02d"
+    return ("%(days)s%(hours)02d:%(minutes)02d:%(seconds)02d"
             % { "days": "%dT" % td.days if td.days else "",
                 "hours": td.seconds // 3600,
                 "minutes": (td.seconds % 3600) // 60,
                 "seconds": td.seconds % 60,
                 })
 
-
 def string_to_delta(interval):
     """Parse a string and return a datetime.timedelta
-
-    >>> string_to_delta('7d')
+    
+    >>> string_to_delta("7d")
     datetime.timedelta(7)
-    >>> string_to_delta('60s')
+    >>> string_to_delta("60s")
     datetime.timedelta(0, 60)
-    >>> string_to_delta('60m')
+    >>> string_to_delta("60m")
     datetime.timedelta(0, 3600)
-    >>> string_to_delta('24h')
+    >>> string_to_delta("24h")
     datetime.timedelta(1)
-    >>> string_to_delta(u'1w')
+    >>> string_to_delta("1w")
     datetime.timedelta(7)
-    >>> string_to_delta('5m 30s')
+    >>> string_to_delta("5m 30s")
     datetime.timedelta(0, 330)
     """
     timevalue = datetime.timedelta(0)
@@ -98,15 +100,15 @@
         try:
             suffix = unicode(s[-1])
             value = int(s[:-1])
-            if suffix == u"d":
+            if suffix == "d":
                 delta = datetime.timedelta(value)
-            elif suffix == u"s":
+            elif suffix == "s":
                 delta = datetime.timedelta(0, value)
-            elif suffix == u"m":
+            elif suffix == "m":
                 delta = datetime.timedelta(0, 0, 0, 0, value)
-            elif suffix == u"h":
+            elif suffix == "h":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, value)
-            elif suffix == u"w":
+            elif suffix == "w":
                 delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
             else:
                 raise ValueError
@@ -118,25 +120,25 @@
 def print_clients(clients, keywords):
     def valuetostring(value, keyword):
         if type(value) is dbus.Boolean:
-            return u"Yes" if value else u"No"
-        if keyword in (u"Timeout", u"Interval", u"ApprovalDelay",
-                       u"ApprovalDuration"):
+            return "Yes" if value else "No"
+        if keyword in ("Timeout", "Interval", "ApprovalDelay",
+                       "ApprovalDuration"):
             return milliseconds_to_string(value)
         return unicode(value)
     
     # Create format string to print table rows
-    format_string = u' '.join(u'%%-%ds' %
-                              max(len(tablewords[key]),
-                                  max(len(valuetostring(client[key],
-                                                        key))
-                                      for client in
-                                      clients))
-                              for key in keywords)
+    format_string = " ".join("%%-%ds" %
+                             max(len(tablewords[key]),
+                                 max(len(valuetostring(client[key],
+                                                       key))
+                                     for client in
+                                     clients))
+                             for key in keywords)
     # Print header line
-    print format_string % tuple(tablewords[key] for key in keywords)
+    print(format_string % tuple(tablewords[key] for key in keywords))
     for client in clients:
-        print format_string % tuple(valuetostring(client[key], key)
-                                    for key in keywords)
+        print(format_string % tuple(valuetostring(client[key], key)
+                                    for key in keywords))
 
 def has_actions(options):
     return any((options.enable,
@@ -148,6 +150,7 @@
                 options.remove,
                 options.checker is not None,
                 options.timeout is not None,
+                options.extended_timeout is not None,
                 options.interval is not None,
                 options.approved_by_default is not None,
                 options.approval_delay is not None,
@@ -156,182 +159,198 @@
                 options.secret is not None,
                 options.approve,
                 options.deny))
-        
+
 def main():
-	parser = OptionParser(version = "%%prog %s" % version)
-	parser.add_option("-a", "--all", action="store_true",
-	                  help="Select all clients")
-	parser.add_option("-v", "--verbose", action="store_true",
-	                  help="Print all fields")
-	parser.add_option("-e", "--enable", action="store_true",
-	                  help="Enable client")
-	parser.add_option("-d", "--disable", action="store_true",
-	                  help="disable client")
-	parser.add_option("-b", "--bump-timeout", action="store_true",
-	                  help="Bump timeout for client")
-	parser.add_option("--start-checker", action="store_true",
-	                  help="Start checker for client")
-	parser.add_option("--stop-checker", action="store_true",
-	                  help="Stop checker for client")
-	parser.add_option("-V", "--is-enabled", action="store_true",
-	                  help="Check if client is enabled")
-	parser.add_option("-r", "--remove", action="store_true",
-	                  help="Remove client")
-	parser.add_option("-c", "--checker", type="string",
-	                  help="Set checker command for client")
-	parser.add_option("-t", "--timeout", type="string",
-	                  help="Set timeout for client")
-	parser.add_option("-i", "--interval", type="string",
-	                  help="Set checker interval for client")
-        parser.add_option("--approve-by-default", action="store_true",
-                          dest=u"approved_by_default",
-                          help="Set client to be approved by default")
-        parser.add_option("--deny-by-default", action="store_false",
-                          dest=u"approved_by_default",
-                          help="Set client to be denied by default")
-        parser.add_option("--approval-delay", type="string",
-                          help="Set delay before client approve/deny")
-        parser.add_option("--approval-duration", type="string",
-                          help="Set duration of one client approval")
-	parser.add_option("-H", "--host", type="string",
-	                  help="Set host for client")
-	parser.add_option("-s", "--secret", type="string",
-	                  help="Set password blob (file) for client")
-	parser.add_option("-A", "--approve", action="store_true",
-	                  help="Approve any current client request")
-	parser.add_option("-D", "--deny", action="store_true",
-	                  help="Deny any current client request")
-	options, client_names = parser.parse_args()
-        
-        if has_actions(options) and not client_names and not options.all:
-            parser.error('Options require clients names or --all.')
-        if options.verbose and has_actions(options):
-            parser.error('--verbose can only be used alone or with'
-                         ' --all.')
-        if options.all and not has_actions(options):
-            parser.error('--all requires an action.')
-        
-        try:
-            bus = dbus.SystemBus()
-            mandos_dbus_objc = bus.get_object(busname, server_path)
-        except dbus.exceptions.DBusException:
-            print >> sys.stderr, "Could not connect to Mandos server"
-            sys.exit(1)
-    
-        mandos_serv = dbus.Interface(mandos_dbus_objc,
-                                     dbus_interface = server_interface)
-
-        #block stderr since dbus library prints to stderr
-        null = os.open(os.path.devnull, os.O_RDWR)
-        stderrcopy = os.dup(sys.stderr.fileno())
-        os.dup2(null, sys.stderr.fileno())
-        os.close(null)
-        try:
-            try:
-                mandos_clients = mandos_serv.GetAllClientsWithProperties()
-            finally:
-                #restore stderr
-                os.dup2(stderrcopy, sys.stderr.fileno())
-                os.close(stderrcopy)
-        except dbus.exceptions.DBusException, e:
-            print >> sys.stderr, "Access denied: Accessing mandos server through dbus."
-            sys.exit(1)
-            
-	# Compile dict of (clients: properties) to process
-	clients={}
-        
-        if options.all or not client_names:
-            clients = dict((bus.get_object(busname, path), properties)
-                           for path, properties in
-                           mandos_clients.iteritems())
-        else:
-            for name in client_names:
-                for path, client in mandos_clients.iteritems():
-                    if client['Name'] == name:
-                        client_objc = bus.get_object(busname, path)
-                        clients[client_objc] = client
-                        break
-                else:
-                    print >> sys.stderr, "Client not found on server: %r" % name
-                    sys.exit(1)
-            
-	if not has_actions(options) and clients:
-	    if options.verbose:
-	        keywords = ('Name', 'Enabled', 'Timeout',
-                            'LastCheckedOK', 'Created', 'Interval',
-                            'Host', 'Fingerprint', 'CheckerRunning',
-                            'LastEnabled', 'ApprovalPending',
-                            'ApprovedByDefault',
-                            'LastApprovalRequest', 'ApprovalDelay',
-                            'ApprovalDuration', 'Checker')
+    parser = argparse.ArgumentParser()
+    parser.add_argument("--version", action="version",
+                        version = "%%prog %s" % version,
+                        help="show version number and exit")
+    parser.add_argument("-a", "--all", action="store_true",
+                        help="Select all clients")
+    parser.add_argument("-v", "--verbose", action="store_true",
+                        help="Print all fields")
+    parser.add_argument("-e", "--enable", action="store_true",
+                        help="Enable client")
+    parser.add_argument("-d", "--disable", action="store_true",
+                        help="disable client")
+    parser.add_argument("-b", "--bump-timeout", action="store_true",
+                        help="Bump timeout for client")
+    parser.add_argument("--start-checker", action="store_true",
+                        help="Start checker for client")
+    parser.add_argument("--stop-checker", action="store_true",
+                        help="Stop checker for client")
+    parser.add_argument("-V", "--is-enabled", action="store_true",
+                        help="Check if client is enabled")
+    parser.add_argument("-r", "--remove", action="store_true",
+                        help="Remove client")
+    parser.add_argument("-c", "--checker",
+                        help="Set checker command for client")
+    parser.add_argument("-t", "--timeout",
+                        help="Set timeout for client")
+    parser.add_argument("--extended-timeout",
+                        help="Set extended timeout for client")
+    parser.add_argument("-i", "--interval",
+                        help="Set checker interval for client")
+    parser.add_argument("--approve-by-default", action="store_true",
+                        default=None, dest="approved_by_default",
+                        help="Set client to be approved by default")
+    parser.add_argument("--deny-by-default", action="store_false",
+                        dest="approved_by_default",
+                        help="Set client to be denied by default")
+    parser.add_argument("--approval-delay",
+                        help="Set delay before client approve/deny")
+    parser.add_argument("--approval-duration",
+                        help="Set duration of one client approval")
+    parser.add_argument("-H", "--host", help="Set host for client")
+    parser.add_argument("-s", "--secret", type=file,
+                        help="Set password blob (file) for client")
+    parser.add_argument("-A", "--approve", action="store_true",
+                        help="Approve any current client request")
+    parser.add_argument("-D", "--deny", action="store_true",
+                        help="Deny any current client request")
+    parser.add_argument("client", nargs="*", help="Client name")
+    options = parser.parse_args()
+    
+    if has_actions(options) and not options.client and not options.all:
+        parser.error("Options require clients names or --all.")
+    if options.verbose and has_actions(options):
+        parser.error("--verbose can only be used alone or with"
+                     " --all.")
+    if options.all and not has_actions(options):
+        parser.error("--all requires an action.")
+    
+    try:
+        bus = dbus.SystemBus()
+        mandos_dbus_objc = bus.get_object(busname, server_path)
+    except dbus.exceptions.DBusException:
+        print("Could not connect to Mandos server",
+              file=sys.stderr)
+        sys.exit(1)
+    
+    mandos_serv = dbus.Interface(mandos_dbus_objc,
+                                 dbus_interface = server_interface)
+    
+    #block stderr since dbus library prints to stderr
+    null = os.open(os.path.devnull, os.O_RDWR)
+    stderrcopy = os.dup(sys.stderr.fileno())
+    os.dup2(null, sys.stderr.fileno())
+    os.close(null)
+    try:
+        try:
+            mandos_clients = mandos_serv.GetAllClientsWithProperties()
+        finally:
+            #restore stderr
+            os.dup2(stderrcopy, sys.stderr.fileno())
+            os.close(stderrcopy)
+    except dbus.exceptions.DBusException, e:
+        print("Access denied: Accessing mandos server through dbus.",
+              file=sys.stderr)
+        sys.exit(1)
+    
+    # Compile dict of (clients: properties) to process
+    clients={}
+    
+    if options.all or not options.client:
+        clients = dict((bus.get_object(busname, path), properties)
+                       for path, properties in
+                       mandos_clients.iteritems())
+    else:
+        for name in options.client:
+            for path, client in mandos_clients.iteritems():
+                if client["Name"] == name:
+                    client_objc = bus.get_object(busname, path)
+                    clients[client_objc] = client
+                    break
             else:
-                keywords = defaultkeywords
-            
-	    print_clients(clients.values(), keywords)
+                print("Client not found on server: %r" % name,
+                      file=sys.stderr)
+                sys.exit(1)
+    
+    if not has_actions(options) and clients:
+        if options.verbose:
+            keywords = ("Name", "Enabled", "Timeout",
+                        "LastCheckedOK", "Created", "Interval",
+                        "Host", "Fingerprint", "CheckerRunning",
+                        "LastEnabled", "ApprovalPending",
+                        "ApprovedByDefault",
+                        "LastApprovalRequest", "ApprovalDelay",
+                        "ApprovalDuration", "Checker",
+                        "ExtendedTimeout")
         else:
-            # Process each client in the list by all selected options
-            for client in clients:
-                if options.remove:
-                    mandos_serv.RemoveClient(client.__dbus_object_path__)
-                if options.enable:
-                    client.Enable(dbus_interface=client_interface)
-                if options.disable:
-                    client.Disable(dbus_interface=client_interface)
-                if options.bump_timeout:
-                    client.CheckedOK(dbus_interface=client_interface)
-                if options.start_checker:
-                    client.StartChecker(dbus_interface=client_interface)
-                if options.stop_checker:
-                    client.StopChecker(dbus_interface=client_interface)
-                if options.is_enabled:
-                    sys.exit(0 if client.Get(client_interface,
-                                             u"Enabled",
-                                             dbus_interface=dbus.PROPERTIES_IFACE)
-                             else 1)
-                if options.checker:
-                    client.Set(client_interface, u"Checker", options.checker,
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.host:
-                    client.Set(client_interface, u"Host", options.host,
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.interval:
-                    client.Set(client_interface, u"Interval",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.interval)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approval_delay:
-                    client.Set(client_interface, u"ApprovalDelay",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.
-                                                approval_delay)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approval_duration:
-                    client.Set(client_interface, u"ApprovalDuration",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.
-                                                approval_duration)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.timeout:
-                    client.Set(client_interface, u"Timeout",
-                               timedelta_to_milliseconds
-                               (string_to_delta(options.timeout)),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.secret:
-                    client.Set(client_interface, u"Secret",
-                               dbus.ByteArray(open(options.secret,
-                                                   u'rb').read()),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approved_by_default is not None:
-                    client.Set(client_interface, u"ApprovedByDefault",
-                               dbus.Boolean(options
-                                            .approved_by_default),
-                               dbus_interface=dbus.PROPERTIES_IFACE)
-                if options.approve:
-                    client.Approve(dbus.Boolean(True),
-                                   dbus_interface=client_interface)
-                elif options.deny:
-                    client.Approve(dbus.Boolean(False),
-                                   dbus_interface=client_interface)
+            keywords = defaultkeywords
+        
+        print_clients(clients.values(), keywords)
+    else:
+        # Process each client in the list by all selected options
+        for client in clients:
+            if options.remove:
+                mandos_serv.RemoveClient(client.__dbus_object_path__)
+            if options.enable:
+                client.Enable(dbus_interface=client_interface)
+            if options.disable:
+                client.Disable(dbus_interface=client_interface)
+            if options.bump_timeout:
+                client.CheckedOK(dbus_interface=client_interface)
+            if options.start_checker:
+                client.StartChecker(dbus_interface=client_interface)
+            if options.stop_checker:
+                client.StopChecker(dbus_interface=client_interface)
+            if options.is_enabled:
+                sys.exit(0 if client.Get(client_interface,
+                                         "Enabled",
+                                         dbus_interface=
+                                         dbus.PROPERTIES_IFACE)
+                         else 1)
+            if options.checker is not None:
+                client.Set(client_interface, "Checker",
+                           options.checker,
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.host is not None:
+                client.Set(client_interface, "Host", options.host,
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.interval is not None:
+                client.Set(client_interface, "Interval",
+                           timedelta_to_milliseconds
+                           (string_to_delta(options.interval)),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.approval_delay is not None:
+                client.Set(client_interface, "ApprovalDelay",
+                           timedelta_to_milliseconds
+                           (string_to_delta(options.
+                                            approval_delay)),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.approval_duration is not None:
+                client.Set(client_interface, "ApprovalDuration",
+                           timedelta_to_milliseconds
+                           (string_to_delta(options.
+                                            approval_duration)),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.timeout is not None:
+                client.Set(client_interface, "Timeout",
+                           timedelta_to_milliseconds
+                           (string_to_delta(options.timeout)),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.extended_timeout is not None:
+                client.Set(client_interface, "ExtendedTimeout",
+                           timedelta_to_milliseconds
+                           (string_to_delta(options.extended_timeout)),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.secret is not None:
+                client.Set(client_interface, "Secret",
+                           dbus.ByteArray(open(options.secret,
+                                               "rb").read()),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.approved_by_default is not None:
+                client.Set(client_interface, "ApprovedByDefault",
+                           dbus.Boolean(options
+                                        .approved_by_default),
+                           dbus_interface=dbus.PROPERTIES_IFACE)
+            if options.approve:
+                client.Approve(dbus.Boolean(True),
+                               dbus_interface=client_interface)
+            elif options.deny:
+                client.Approve(dbus.Boolean(False),
+                               dbus_interface=client_interface)
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     main()

=== modified file 'mandos-ctl.xml'
--- mandos-ctl.xml	2010-09-25 23:52:17 +0000
+++ mandos-ctl.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-ctl">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,19 +19,20 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -94,6 +95,11 @@
       </group>
       <sbr/>
       <group>
+	<arg choice="plain"><option>--extended-timeout
+	<replaceable>TIME</replaceable></option></arg>
+      </group>
+      <sbr/>
+      <group>
 	<arg choice="plain"><option>--interval
 	<replaceable>TIME</replaceable></option></arg>
 	<arg choice="plain"><option>-i
@@ -317,6 +323,19 @@
 	  </para>
 	</listitem>
       </varlistentry>
+
+      <varlistentry>
+	<term><option>--extended-timeout
+	<replaceable>TIME</replaceable></option></term>
+	<listitem>
+	  <para>
+	    Set the <varname>extended_timeout</varname> option of the
+	    specified client(s); see <citerefentry><refentrytitle
+	    >mandos-clients.conf</refentrytitle><manvolnum
+	    >5</manvolnum></citerefentry>.
+	  </para>
+	</listitem>
+      </varlistentry>
       
       <varlistentry>
 	<term><option>--interval
@@ -553,6 +572,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>

=== modified file 'mandos-keygen'
--- mandos-keygen	2010-10-11 17:45:21 +0000
+++ mandos-keygen	2011-10-15 16:48:03 +0000
@@ -2,8 +2,8 @@
 # 
 # Mandos key generator - create a new OpenPGP key for a Mandos client
 # 
-# Copyright © 2008-2010 Teddy Hogeborn
-# Copyright © 2008-2010 Björn Påhlsson
+# Copyright © 2008-2011 Teddy Hogeborn
+# Copyright © 2008-2011 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -18,10 +18,10 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 # 
-# Contact the authors at <mandos@fukt.bsnet.se>.
+# Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.2.3"
+VERSION="1.4.1"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA
@@ -192,7 +192,7 @@
 shred --remove \"$RINGDIR\"/sec*;
 test -n \"$BATCHFILE\" && rm --force \"$BATCHFILE\"; \
 rm --recursive --force \"$RINGDIR\";
-stty echo; \
+tty --quiet && stty echo; \
 " EXIT
 
 set -e
@@ -289,31 +289,37 @@
     
     FILECOMMENT="Encrypted password for a Mandos client"
     
-    if [ -n "$PASSFILE" ]; then
-	cat "$PASSFILE"
-    else
-	stty -echo
-	echo -n "Enter passphrase: " >&2
-	first="$(head --lines=1 | tr --delete '\n')"
-	echo >&2
-	echo -n "Repeat passphrase: " >&2
-	second="$(head --lines=1 | tr --delete '\n')"
-	echo >&2
-	stty echo
-	if [ "$first" != "$second" ]; then
-	    echo "Passphrase mismatch" >&2
-	    touch "$RINGDIR"/mismatch
+    while [ ! -s "$SECFILE" ]; do
+	if [ -n "$PASSFILE" ]; then
+	    cat "$PASSFILE"
 	else
-	    echo -n "$first"
+	    tty --quiet && stty -echo
+	    read -p "Enter passphrase: " first
+	    tty --quiet && echo >&2
+	    read -p "Repeat passphrase: " second
+	    if tty --quiet; then
+		echo >&2
+		stty echo
+	    fi
+	    if [ "$first" != "$second" ]; then
+		echo "Passphrase mismatch" >&2
+		touch "$RINGDIR"/mismatch
+	    else
+		echo -n "$first"
+	    fi
+	fi | gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
+	    --homedir "$RINGDIR" --trust-model always --armor \
+	    --encrypt --sign --recipient "$FINGERPRINT" --comment \
+	    "$FILECOMMENT" > "$SECFILE"
+	if [ -e "$RINGDIR"/mismatch ]; then
+	    rm --force "$RINGDIR"/mismatch
+	    if tty --quiet; then
+		> "$SECFILE"
+	    else
+		exit 1
+	    fi
 	fi
-    fi | gpg --quiet --batch --no-tty --no-options --enable-dsa2 \
-	--homedir "$RINGDIR" --trust-model always --armor --encrypt \
-	--sign --recipient "$FINGERPRINT" --comment "$FILECOMMENT" \
-	> "$SECFILE"
-    if [ -e "$RINGDIR"/mismatch ]; then
-	rm --force "$RINGDIR"/mismatch
-	exit 1
-    fi
+    done
     
     cat <<-EOF
 	[$KEYNAME]

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2009-01-04 21:54:55 +0000
+++ mandos-keygen.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-keygen">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,20 +19,21 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -492,6 +493,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>gpg</refentrytitle>
       <manvolnum>1</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>

=== modified file 'mandos-monitor'
--- mandos-monitor	2011-02-11 19:02:24 +0000
+++ mandos-monitor	2011-10-15 16:48:03 +0000
@@ -3,8 +3,8 @@
 # 
 # Mandos Monitor - Control and monitor the Mandos server
 # 
-# Copyright © 2009,2010 Teddy Hogeborn
-# Copyright © 2009,2010 Björn Påhlsson
+# Copyright © 2009-2011 Teddy Hogeborn
+# Copyright © 2009-2011 Björn Påhlsson
 # 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,10 +19,11 @@
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 # 
-# Contact the authors at <mandos@fukt.bsnet.se>.
+# Contact the authors at <mandos@recompile.se>.
 # 
 
-from __future__ import division, absolute_import, print_function, unicode_literals
+from __future__ import (division, absolute_import, print_function,
+                        unicode_literals)
 
 import sys
 import os
@@ -48,10 +49,10 @@
 logging.getLogger('dbus.proxies').setLevel(logging.CRITICAL)
 
 # Some useful constants
-domain = 'se.bsnet.fukt'
+domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.2.3"
+version = "1.4.1"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False
@@ -86,16 +87,17 @@
         self.proxy = proxy_object # Mandos Client proxy object
         
         self.properties = dict()
-        self.proxy.connect_to_signal("PropertyChanged",
-                                     self.property_changed,
-                                     client_interface,
-                                     byte_arrays=True)
+        self.property_changed_match = (
+            self.proxy.connect_to_signal("PropertyChanged",
+                                         self.property_changed,
+                                         client_interface,
+                                         byte_arrays=True))
         
         self.properties.update(
             self.proxy.GetAll(client_interface,
                               dbus_interface = dbus.PROPERTIES_IFACE))
 
-        #XXX This break good super behaviour!
+        #XXX This breaks good super behaviour
 #        super(MandosClientPropertyCache, self).__init__(
 #            *args, **kwargs)
     
@@ -105,6 +107,11 @@
         """
         # Update properties dict with new value
         self.properties[property] = value
+    
+    def delete(self, *args, **kwargs):
+        self.property_changed_match.remove()
+        super(MandosClientPropertyCache, self).__init__(
+            *args, **kwargs)
 
 
 class MandosClientWidget(urwid.FlowWidget, MandosClientPropertyCache):
@@ -154,26 +161,28 @@
         if self.need_approval:
             self.using_timer(True)
         
-        self.proxy.connect_to_signal("CheckerCompleted",
-                                     self.checker_completed,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal("CheckerStarted",
-                                     self.checker_started,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal("GotSecret",
-                                     self.got_secret,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal("NeedApproval",
-                                     self.need_approval,
-                                     client_interface,
-                                     byte_arrays=True)
-        self.proxy.connect_to_signal("Rejected",
-                                     self.rejected,
-                                     client_interface,
-                                     byte_arrays=True)
+        self.match_objects = (
+            self.proxy.connect_to_signal("CheckerCompleted",
+                                         self.checker_completed,
+                                         client_interface,
+                                         byte_arrays=True),
+            self.proxy.connect_to_signal("CheckerStarted",
+                                         self.checker_started,
+                                         client_interface,
+                                         byte_arrays=True),
+            self.proxy.connect_to_signal("GotSecret",
+                                         self.got_secret,
+                                         client_interface,
+                                         byte_arrays=True),
+            self.proxy.connect_to_signal("NeedApproval",
+                                         self.need_approval,
+                                         client_interface,
+                                         byte_arrays=True),
+            self.proxy.connect_to_signal("Rejected",
+                                         self.rejected,
+                                         client_interface,
+                                         byte_arrays=True))
+        #self.logger('Created client %s' % (self.properties["Name"]))
     
     def property_changed(self, property=None, value=None):
         super(self, MandosClientWidget).property_changed(property,
@@ -191,6 +200,7 @@
         else:
             self._update_timer_callback_lock -= 1
         if old == 0 and self._update_timer_callback_lock:
+            # Will update the shown timer value every second
             self._update_timer_callback_tag = (gobject.timeout_add
                                                (1000,
                                                 self.update_timer))
@@ -305,14 +315,14 @@
                 message = "Denial in %s. (a)pprove?"
             message = message % unicode(timer).rsplit(".", 1)[0]
         elif self.last_checker_failed:
-            timeout = datetime.timedelta(milliseconds
-                                         = self.properties
-                                         ["Timeout"])
-            last_ok = isoformat_to_datetime(
-                max((self.properties["LastCheckedOK"]
-                     or self.properties["Created"]),
-                    self.properties["LastEnabled"]))
-            timer = timeout - (datetime.datetime.utcnow() - last_ok)
+            # When checker has failed, print a timer until client expires
+            expires = self.properties["Expires"]
+            if expires == "":
+                timer = datetime.timedelta(0)
+            else:
+                expires = datetime.datetime.strptime(expires,
+                                                     '%Y-%m-%dT%H:%M:%S.%f')
+                timer = expires - datetime.datetime.utcnow()
             message = ('A checker has failed! Time until client'
                        ' gets disabled: %s'
                            % unicode(timer).rsplit(".", 1)[0])
@@ -337,16 +347,21 @@
             self.update_hook()
     
     def update_timer(self):
-        "called by gobject"
+        """called by gobject. Will indefinitely loop until
+        gobject.source_remove() on tag is called"""
         self.update()
         return True             # Keep calling this
     
-    def delete(self):
+    def delete(self, *args, **kwargs):
         if self._update_timer_callback_tag is not None:
             gobject.source_remove(self._update_timer_callback_tag)
             self._update_timer_callback_tag = None
+        for match in self.match_objects:
+            match.remove()
+        self.match_objects = ()
         if self.delete_hook is not None:
             self.delete_hook(self)
+        return super(MandosClientWidget, self).delete(*args, **kwargs)
     
     def render(self, maxcolrow, focus=False):
         """Render differently if we have focus.
@@ -358,24 +373,32 @@
         """Handle keys.
         This overrides the method from urwid.FlowWidget"""
         if key == "+":
-            self.proxy.Enable(dbus_interface = client_interface)
+            self.proxy.Enable(dbus_interface = client_interface,
+                              ignore_reply=True)
         elif key == "-":
-            self.proxy.Disable(dbus_interface = client_interface)
+            self.proxy.Disable(dbus_interface = client_interface,
+                               ignore_reply=True)
         elif key == "a":
             self.proxy.Approve(dbus.Boolean(True, variant_level=1),
-                               dbus_interface = client_interface)
+                               dbus_interface = client_interface,
+                               ignore_reply=True)
         elif key == "d":
             self.proxy.Approve(dbus.Boolean(False, variant_level=1),
-                                  dbus_interface = client_interface)
+                                  dbus_interface = client_interface,
+                               ignore_reply=True)
         elif key == "R" or key == "_" or key == "ctrl k":
             self.server_proxy_object.RemoveClient(self.proxy
-                                                  .object_path)
+                                                  .object_path,
+                                                  ignore_reply=True)
         elif key == "s":
-            self.proxy.StartChecker(dbus_interface = client_interface)
+            self.proxy.StartChecker(dbus_interface = client_interface,
+                                    ignore_reply=True)
         elif key == "S":
-            self.proxy.StopChecker(dbus_interface = client_interface)
+            self.proxy.StopChecker(dbus_interface = client_interface,
+                                   ignore_reply=True)
         elif key == "C":
-            self.proxy.CheckedOK(dbus_interface = client_interface)
+            self.proxy.CheckedOK(dbus_interface = client_interface,
+                                 ignore_reply=True)
         # xxx
 #         elif key == "p" or key == "=":
 #             self.proxy.pause()
@@ -572,7 +595,7 @@
         #self.log_message("Wrap mode: " + self.log_wrap)
     
     def find_and_remove_client(self, path, name):
-        """Find an client from its object path and remove it.
+        """Find a client by its object path and remove it.
         
         This is connected to the ClientRemoved signal from the
         Mandos server object."""
@@ -580,8 +603,10 @@
             client = self.clients_dict[path]
         except KeyError:
             # not found?
+            self.log_message("Unknown client %r (%r) removed", name,
+                             path)
             return
-        self.remove_client(client, path)
+        client.delete()
     
     def add_new_client(self, path):
         client_proxy_object = self.bus.get_object(self.busname, path)

=== modified file 'mandos-monitor.xml'
--- mandos-monitor.xml	2010-09-30 06:24:20 +0000
+++ mandos-monitor.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-monitor">
-<!ENTITY TIMESTAMP "2010-09-14">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,19 +19,20 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -218,6 +219,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos-ctl</refentrytitle>

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2009-02-25 01:14:29 +0000
+++ mandos.conf.xml	2011-10-05 16:00:56 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2009-02-25">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -20,20 +20,21 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -204,6 +205,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>gnutls_priority_init</refentrytitle
       ><manvolnum>3</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>mandos</refentrytitle>

=== modified file 'mandos.lsm'
--- mandos.lsm	2010-10-11 17:45:21 +0000
+++ mandos.lsm	2011-10-15 16:48:03 +0000
@@ -1,21 +1,21 @@
 Begin4
 Title:		Mandos
-Version:	1.2.3
-Entered-date:	2010-10-11
+Version:	1.4.1
+Entered-date:	2011-10-15
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
 Keywords:	boot, encryption, luks, cryptsetup, network, openpgp,
 tls, dm-crypt
-Author:		teddy@fukt.bsnet.se (Teddy Hogeborn),
-		belorn@fukt.bsnet.se (Björn Påhlsson)
-Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
-		belorn@fukt.bsnet.se (Björn Påhlsson)
-Primary-site: http://www.fukt.bsnet.se/mandos
-	      133K mandos_1.2.3.orig.tar.gz
-Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
-		133K mandos_1.2.3.orig.tar.gz
-Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.5, and
+Author:		teddy@recompile.se (Teddy Hogeborn),
+		belorn@recompile.se (Björn Påhlsson)
+Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
+		belorn@recompile.se (Björn Påhlsson)
+Primary-site: http://www.recompile.se/mandos
+	      138K mandos_1.4.1.orig.tar.gz
+Alternate-site: ftp://ftp.recompile.se/pub/mandos
+		138K mandos_1.4.1.orig.tar.gz
+Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.
 Copying-policy: GNU General Public License version 3.0 or later

=== modified file 'mandos.xml'
--- mandos.xml	2010-09-27 17:39:03 +0000
+++ mandos.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,14 +19,14 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
@@ -34,6 +34,7 @@
       <year>2008</year>
       <year>2009</year>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -116,14 +117,16 @@
     <para>
       <command>&COMMANDNAME;</command> is a server daemon which
       handles incoming request for passwords for a pre-defined list of
-      client host computers.  The Mandos server uses Zeroconf to
-      announce itself on the local network, and uses TLS to
-      communicate securely with and to authenticate the clients.  The
-      Mandos server uses IPv6 to allow Mandos clients to use IPv6
-      link-local addresses, since the clients will probably not have
-      any other addresses configured (see <xref linkend="overview"/>).
-      Any authenticated client is then given the stored pre-encrypted
-      password for that specific client.
+      client host computers. For an introduction, see
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>. The Mandos server
+      uses Zeroconf to announce itself on the local network, and uses
+      TLS to communicate securely with and to authenticate the
+      clients.  The Mandos server uses IPv6 to allow Mandos clients to
+      use IPv6 link-local addresses, since the clients will probably
+      not have any other addresses configured (see <xref
+      linkend="overview"/>).  Any authenticated client is then given
+      the stored pre-encrypted password for that specific client.
     </para>
   </refsect1>
   
@@ -351,9 +354,9 @@
       for some time, the client is assumed to be compromised and is no
       longer eligible to receive the encrypted password.  (Manual
       intervention is required to re-enable a client.)  The timeout,
-      checker program, and interval between checks can be configured
-      both globally and per client; see <citerefentry>
-      <refentrytitle>mandos-clients.conf</refentrytitle>
+      extended timeout, checker program, and interval between checks
+      can be configured both globally and per client; see
+      <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>.  A client successfully
       receiving its password will also be treated as a successful
       checker run.
@@ -609,15 +612,16 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
-      <citerefentry>
-	<refentrytitle>mandos-clients.conf</refentrytitle>
-	<manvolnum>5</manvolnum></citerefentry>, <citerefentry>
-	<refentrytitle>mandos.conf</refentrytitle>
-	<manvolnum>5</manvolnum></citerefentry>, <citerefentry>
-	<refentrytitle>mandos-client</refentrytitle>
-	<manvolnum>8mandos</manvolnum></citerefentry>, <citerefentry>
-	<refentrytitle>sh</refentrytitle><manvolnum>1</manvolnum>
-      </citerefentry>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-clients.conf</refentrytitle>
+      <manvolnum>5</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos.conf</refentrytitle>
+      <manvolnum>5</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>mandos-client</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
+      <citerefentry><refentrytitle>sh</refentrytitle>
+      <manvolnum>1</manvolnum></citerefentry>
     </para>
     <variablelist>
       <varlistentry>

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2010-09-26 21:27:28 +0000
+++ plugin-runner.c	2011-10-09 12:32:13 +0000
@@ -2,8 +2,8 @@
 /*
  * Mandos plugin runner - Run Mandos plugins
  *
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), getline(),
@@ -79,7 +79,7 @@
 #define AFILE "/conf/conf.d/mandos/plugin-runner.conf"
 
 const char *argp_program_version = "plugin-runner " VERSION;
-const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
+const char *argp_program_bug_address = "<mandos@recompile.se>";
 
 typedef struct plugin{
   char *name;			/* can be NULL or any plugin name */
@@ -742,7 +742,29 @@
     }
   }
   
-  /* Strip permissions down to nobody */
+  {
+    /* Work around Debian bug #633582:
+       <http://bugs.debian.org/633582> */
+    int plugindir_fd = open(/* plugindir or */ PDIR, O_RDONLY);
+    if(plugindir_fd == -1){
+      error(0, errno, "open");
+    } else {
+      ret = (int)TEMP_FAILURE_RETRY(fstat(plugindir_fd, &st));
+      if(ret == -1){
+	error(0, errno, "fstat");
+      } else {
+	if(S_ISDIR(st.st_mode) and st.st_uid == 0 and st.st_gid == 0){
+	  ret = fchown(plugindir_fd, uid, gid);
+	  if(ret == -1){
+	    error(0, errno, "fchown");
+	  }
+	}
+      }
+      TEMP_FAILURE_RETRY(close(plugindir_fd));
+    }
+  }
+  
+  /* Lower permissions */
   setgid(gid);
   if(ret == -1){
     error(0, errno, "setgid");

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2009-01-18 06:41:57 +0000
+++ plugin-runner.xml	2011-10-05 16:56:06 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2009-01-17">
+<!ENTITY TIMESTAMP "2011-10-05">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -19,20 +19,21 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -260,7 +261,7 @@
 	    Disable the plugin named
 	    <replaceable>PLUGIN</replaceable>.  The plugin will not be
 	    started.
-	  </para>	
+	  </para>
 	</listitem>
       </varlistentry>
       
@@ -617,6 +618,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>cryptsetup</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>crypttab</refentrytitle>

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2010-09-26 18:32:58 +0000
+++ plugins.d/askpass-fifo.c	2011-10-05 16:00:56 +0000
@@ -2,8 +2,8 @@
 /*
  * Askpass-FIFO - Read a password from a FIFO and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY() */
@@ -32,6 +32,8 @@
 				   ENFILE, ENOMEM, EBADF, EINVAL, EIO,
 				   EISDIR, EFBIG */
 #include <error.h>		/* error() */
+#include <stdio.h>		/* fprintf(), vfprintf(),
+				   vasprintf() */
 #include <stdlib.h>		/* EXIT_FAILURE, NULL, size_t, free(),
 				   realloc(), EXIT_SUCCESS */
 #include <fcntl.h>		/* open(), O_RDONLY */
@@ -39,7 +41,32 @@
 				   STDOUT_FILENO */
 #include <sysexits.h>		/* EX_OSERR, EX_OSFILE,
 				   EX_UNAVAILABLE, EX_IOERR */
-
+#include <string.h> 		/* strerror() */
+#include <stdarg.h>		/* va_list, va_start(), ... */
+
+
+/* Function to use when printing errors */
+void error_plus(int status, int errnum, const char *formatstring,
+		...){
+  va_list ap;
+  char *text;
+  int ret;
+  
+  va_start(ap, formatstring);
+  ret = vasprintf(&text, formatstring, ap);
+  if (ret == -1){
+    fprintf(stderr, "Mandos plugin %s: ",
+	    program_invocation_short_name);
+    vfprintf(stderr, formatstring, ap);
+    fprintf(stderr, ": ");
+    fprintf(stderr, "%s\n", strerror(errnum));
+    error(status, errno, "vasprintf while printing error");
+    return;
+  }
+  fprintf(stderr, "Mandos plugin ");
+  error(status, errnum, "%s", text);
+  free(text);
+}
 
 int main(__attribute__((unused))int argc,
 	 __attribute__((unused))char **argv){
@@ -51,19 +78,19 @@
   ret = mkfifo(passfifo, S_IRUSR | S_IWUSR);
   if(ret == -1){
     int e = errno;
-    error(0, errno, "mkfifo");
     switch(e){
     case EACCES:
     case ENOTDIR:
     case ELOOP:
-      return EX_OSFILE;
+      error_plus(EX_OSFILE, errno, "mkfifo");
     case ENAMETOOLONG:
     case ENOSPC:
     case EROFS:
     default:
-      return EX_OSERR;
+      error_plus(EX_OSERR, errno, "mkfifo");
     case ENOENT:
-      return EX_UNAVAILABLE;	/* no "/lib/cryptsetup"? */
+      /* no "/lib/cryptsetup"? */
+      error_plus(EX_UNAVAILABLE, errno, "mkfifo");
     case EEXIST:
       break;			/* not an error */
     }
@@ -73,7 +100,7 @@
   int fifo_fd = open(passfifo, O_RDONLY);
   if(fifo_fd == -1){
     int e = errno;
-    error(0, errno, "open");
+    error_plus(0, errno, "open");
     switch(e){
     case EACCES:
     case ENOENT:
@@ -101,7 +128,7 @@
       if(buf_len + blocksize > buf_allocated){
 	char *tmp = realloc(buf, buf_allocated + blocksize);
 	if(tmp == NULL){
-	  error(0, errno, "realloc");
+	  error_plus(0, errno, "realloc");
 	  free(buf);
 	  return EX_OSERR;
 	}
@@ -113,7 +140,7 @@
 	int e = errno;
 	free(buf);
 	errno = e;
-	error(0, errno, "read");
+	error_plus(0, errno, "read");
 	switch(e){
 	case EBADF:
 	case EFAULT:
@@ -141,7 +168,7 @@
       int e = errno;
       free(buf);
       errno = e;
-      error(0, errno, "write");
+      error_plus(0, errno, "write");
       switch(e){
       case EBADF:
       case EFAULT:
@@ -161,7 +188,7 @@
   ret = close(STDOUT_FILENO);
   if(ret == -1){
     int e = errno;
-    error(0, errno, "close");
+    error_plus(0, errno, "close");
     switch(e){
     case EBADF:
       return EX_OSFILE;

=== modified file 'plugins.d/askpass-fifo.xml'
--- plugins.d/askpass-fifo.xml	2009-01-04 21:54:55 +0000
+++ plugins.d/askpass-fifo.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "askpass-fifo">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,20 +19,21 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -148,6 +149,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>fifo</refentrytitle>
       <manvolnum>7</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>plugin-runner</refentrytitle>

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2010-09-26 21:27:28 +0000
+++ plugins.d/mandos-client.c	2011-11-13 20:49:21 +0000
@@ -9,8 +9,8 @@
  * "browse_callback", and parts of "main".
  * 
  * Everything else is
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -26,7 +26,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 /* Needed by GPGME, specifically gpgme_data_seek() */
@@ -53,7 +53,7 @@
 				   sockaddr_in6, PF_INET6,
 				   SOCK_STREAM, uid_t, gid_t, open(),
 				   opendir(), DIR */
-#include <sys/stat.h>		/* open() */
+#include <sys/stat.h>		/* open(), S_ISREG */
 #include <sys/socket.h>		/* socket(), struct sockaddr_in6,
 				   inet_pton(), connect() */
 #include <fcntl.h>		/* open() */
@@ -62,7 +62,8 @@
 #include <inttypes.h>		/* PRIu16, PRIdMAX, intmax_t,
 				   strtoimax() */
 #include <assert.h>		/* assert() */
-#include <errno.h>		/* perror(), errno */
+#include <errno.h>		/* perror(), errno,
+				   program_invocation_short_name */
 #include <time.h>		/* nanosleep(), time(), sleep() */
 #include <net/if.h>		/* ioctl, ifreq, SIOCGIFFLAGS, IFF_UP,
 				   SIOCSIFFLAGS, if_indextoname(),
@@ -73,7 +74,7 @@
 #include <unistd.h>		/* close(), SEEK_SET, off_t, write(),
 				   getuid(), getgid(), seteuid(),
 				   setgid(), pause() */
-#include <arpa/inet.h>		/* inet_pton(), htons */
+#include <arpa/inet.h>		/* inet_pton(), htons, inet_ntop() */
 #include <iso646.h>		/* not, or, and */
 #include <argp.h>		/* struct argp_option, error_t, struct
 				   argp_state, struct argp,
@@ -84,6 +85,8 @@
 				   raise() */
 #include <sysexits.h>		/* EX_OSERR, EX_USAGE, EX_UNAVAILABLE,
 				   EX_NOHOST, EX_IOERR, EX_PROTOCOL */
+#include <sys/wait.h>		/* waitpid(), WIFEXITED(),
+				   WEXITSTATUS(), WTERMSIG() */
 
 #ifdef __linux__
 #include <sys/klog.h> 		/* klogctl() */
@@ -107,8 +110,8 @@
 				   init_gnutls_session(),
 				   GNUTLS_* */
 #include <gnutls/openpgp.h>
-			  /* gnutls_certificate_set_openpgp_key_file(),
-				   GNUTLS_OPENPGP_FMT_BASE64 */
+			 /* gnutls_certificate_set_openpgp_key_file(),
+			    GNUTLS_OPENPGP_FMT_BASE64 */
 
 /* GPGME */
 #include <gpgme.h> 		/* All GPGME types, constants and
@@ -122,13 +125,26 @@
 #define PATHDIR "/conf/conf.d/mandos"
 #define SECKEY "seckey.txt"
 #define PUBKEY "pubkey.txt"
+#define HOOKDIR "/lib/mandos/network-hooks.d"
 
 bool debug = false;
 static const char mandos_protocol_version[] = "1";
 const char *argp_program_version = "mandos-client " VERSION;
-const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
+const char *argp_program_bug_address = "<mandos@recompile.se>";
 static const char sys_class_net[] = "/sys/class/net";
 char *connect_to = NULL;
+const char *hookdir = HOOKDIR;
+
+/* Doubly linked list that need to be circularly linked when used */
+typedef struct server{
+  const char *ip;
+  uint16_t port;
+  AvahiIfIndex if_index;
+  int af;
+  struct timespec last_seen;
+  struct server *next;
+  struct server *prev;
+} server;
 
 /* Used for passing in values through the Avahi callback functions */
 typedef struct {
@@ -139,23 +155,32 @@
   gnutls_dh_params_t dh_params;
   const char *priority;
   gpgme_ctx_t ctx;
+  server *current_server;
 } mandos_context;
 
 /* global context so signal handler can reach it*/
 mandos_context mc = { .simple_poll = NULL, .server = NULL,
 		      .dh_bits = 1024, .priority = "SECURE256"
-		      ":!CTYPE-X.509:+CTYPE-OPENPGP" };
+		      ":!CTYPE-X.509:+CTYPE-OPENPGP",
+		      .current_server = NULL };
 
 sig_atomic_t quit_now = 0;
 int signal_received = 0;
 
+/* Function to use when printing errors */
+void perror_plus(const char *print_text){
+  fprintf(stderr, "Mandos plugin %s: ",
+	  program_invocation_short_name);
+  perror(print_text);
+}
+
 /*
  * Make additional room in "buffer" for at least BUFFER_SIZE more
  * bytes. "buffer_capacity" is how much is currently allocated,
  * "buffer_length" is how much is already used.
  */
 size_t incbuffer(char **buffer, size_t buffer_length,
-		  size_t buffer_capacity){
+		 size_t buffer_capacity){
   if(buffer_length + BUFFER_SIZE > buffer_capacity){
     *buffer = realloc(*buffer, buffer_capacity + BUFFER_SIZE);
     if(buffer == NULL){
@@ -166,11 +191,48 @@
   return buffer_capacity;
 }
 
+/* Add server to set of servers to retry periodically */
+int add_server(const char *ip, uint16_t port, AvahiIfIndex if_index,
+	       int af){
+  int ret;
+  server *new_server = malloc(sizeof(server));
+  if(new_server == NULL){
+    perror_plus("malloc");
+    return -1;
+  }
+  *new_server = (server){ .ip = strdup(ip),
+			  .port = port,
+			  .if_index = if_index,
+			  .af = af };
+  if(new_server->ip == NULL){
+    perror_plus("strdup");
+    return -1;
+  }
+  /* Special case of first server */
+  if (mc.current_server == NULL){
+    new_server->next = new_server;
+    new_server->prev = new_server;
+    mc.current_server = new_server;
+  /* Place the new server last in the list */
+  } else {
+    new_server->next = mc.current_server;
+    new_server->prev = mc.current_server->prev;
+    new_server->prev->next = new_server;
+    mc.current_server->prev = new_server;
+  }
+  ret = clock_gettime(CLOCK_MONOTONIC, &mc.current_server->last_seen);
+  if(ret == -1){
+    perror_plus("clock_gettime");
+    return -1;
+  }
+  return 0;
+}
+
 /* 
  * Initialize GPGME.
  */
-static bool init_gpgme(const char *seckey,
-		       const char *pubkey, const char *tempdir){
+static bool init_gpgme(const char *seckey, const char *pubkey,
+		       const char *tempdir){
   gpgme_error_t rc;
   gpgme_engine_info_t engine_info;
   
@@ -185,49 +247,54 @@
     
     fd = (int)TEMP_FAILURE_RETRY(open(filename, O_RDONLY));
     if(fd == -1){
-      perror("open");
+      perror_plus("open");
       return false;
     }
     
     rc = gpgme_data_new_from_fd(&pgp_data, fd);
     if(rc != GPG_ERR_NO_ERROR){
-      fprintf(stderr, "bad gpgme_data_new_from_fd: %s: %s\n",
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "bad gpgme_data_new_from_fd: %s: %s\n",
 	      gpgme_strsource(rc), gpgme_strerror(rc));
       return false;
     }
     
     rc = gpgme_op_import(mc.ctx, pgp_data);
     if(rc != GPG_ERR_NO_ERROR){
-      fprintf(stderr, "bad gpgme_op_import: %s: %s\n",
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "bad gpgme_op_import: %s: %s\n",
 	      gpgme_strsource(rc), gpgme_strerror(rc));
       return false;
     }
     
     ret = (int)TEMP_FAILURE_RETRY(close(fd));
     if(ret == -1){
-      perror("close");
+      perror_plus("close");
     }
     gpgme_data_release(pgp_data);
     return true;
   }
   
   if(debug){
-    fprintf(stderr, "Initializing GPGME\n");
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Initializing GPGME\n");
   }
   
   /* Init GPGME */
   gpgme_check_version(NULL);
   rc = gpgme_engine_check_version(GPGME_PROTOCOL_OpenPGP);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_engine_check_version: %s: %s\n",
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "bad gpgme_engine_check_version: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
   
-    /* Set GPGME home directory for the OpenPGP engine only */
+  /* Set GPGME home directory for the OpenPGP engine only */
   rc = gpgme_get_engine_info(&engine_info);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_get_engine_info: %s: %s\n",
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "bad gpgme_get_engine_info: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
@@ -240,15 +307,17 @@
     engine_info = engine_info->next;
   }
   if(engine_info == NULL){
-    fprintf(stderr, "Could not set GPGME home dir to %s\n", tempdir);
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Could not set GPGME home dir to %s\n", tempdir);
     return false;
   }
   
   /* Create new GPGME "context" */
   rc = gpgme_new(&(mc.ctx));
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_new: %s: %s\n",
-	    gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "bad gpgme_new: %s: %s\n", gpgme_strsource(rc),
+	    gpgme_strerror(rc));
     return false;
   }
   
@@ -273,14 +342,16 @@
   ssize_t plaintext_length = 0;
   
   if(debug){
-    fprintf(stderr, "Trying to decrypt OpenPGP data\n");
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Trying to decrypt OpenPGP data\n");
   }
   
   /* Create new GPGME data buffer from memory cryptotext */
   rc = gpgme_data_new_from_mem(&dh_crypto, cryptotext, crypto_size,
 			       0);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_data_new_from_mem: %s: %s\n",
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "bad gpgme_data_new_from_mem: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     return -1;
   }
@@ -288,7 +359,8 @@
   /* Create new empty GPGME data buffer for the plaintext */
   rc = gpgme_data_new(&dh_plain);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_data_new: %s: %s\n",
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "bad gpgme_data_new: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     gpgme_data_release(dh_crypto);
     return -1;
@@ -298,29 +370,37 @@
      data buffer */
   rc = gpgme_op_decrypt(mc.ctx, dh_crypto, dh_plain);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf(stderr, "bad gpgme_op_decrypt: %s: %s\n",
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "bad gpgme_op_decrypt: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     plaintext_length = -1;
     if(debug){
       gpgme_decrypt_result_t result;
       result = gpgme_op_decrypt_result(mc.ctx);
       if(result == NULL){
-	fprintf(stderr, "gpgme_op_decrypt_result failed\n");
+	fprintf(stderr, "Mandos plugin mandos-client: "
+		"gpgme_op_decrypt_result failed\n");
       } else {
-	fprintf(stderr, "Unsupported algorithm: %s\n",
+	fprintf(stderr, "Mandos plugin mandos-client: "
+		"Unsupported algorithm: %s\n",
 		result->unsupported_algorithm);
-	fprintf(stderr, "Wrong key usage: %u\n",
+	fprintf(stderr, "Mandos plugin mandos-client: "
+		"Wrong key usage: %u\n",
 		result->wrong_key_usage);
 	if(result->file_name != NULL){
-	  fprintf(stderr, "File name: %s\n", result->file_name);
+	  fprintf(stderr, "Mandos plugin mandos-client: "
+		  "File name: %s\n", result->file_name);
 	}
 	gpgme_recipient_t recipient;
 	recipient = result->recipients;
 	while(recipient != NULL){
-	  fprintf(stderr, "Public key algorithm: %s\n",
+	  fprintf(stderr, "Mandos plugin mandos-client: "
+		  "Public key algorithm: %s\n",
 		  gpgme_pubkey_algo_name(recipient->pubkey_algo));
-	  fprintf(stderr, "Key ID: %s\n", recipient->keyid);
-	  fprintf(stderr, "Secret key available: %s\n",
+	  fprintf(stderr, "Mandos plugin mandos-client: "
+		  "Key ID: %s\n", recipient->keyid);
+	  fprintf(stderr, "Mandos plugin mandos-client: "
+		  "Secret key available: %s\n",
 		  recipient->status == GPG_ERR_NO_SECKEY
 		  ? "No" : "Yes");
 	  recipient = recipient->next;
@@ -331,12 +411,13 @@
   }
   
   if(debug){
-    fprintf(stderr, "Decryption of OpenPGP data succeeded\n");
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Decryption of OpenPGP data succeeded\n");
   }
   
   /* Seek back to the beginning of the GPGME plaintext data buffer */
   if(gpgme_data_seek(dh_plain, (off_t)0, SEEK_SET) == -1){
-    perror("gpgme_data_seek");
+    perror_plus("gpgme_data_seek");
     plaintext_length = -1;
     goto decrypt_end;
   }
@@ -344,12 +425,12 @@
   *plaintext = NULL;
   while(true){
     plaintext_capacity = incbuffer(plaintext,
-				      (size_t)plaintext_length,
-				      plaintext_capacity);
+				   (size_t)plaintext_length,
+				   plaintext_capacity);
     if(plaintext_capacity == 0){
-	perror("incbuffer");
-	plaintext_length = -1;
-	goto decrypt_end;
+      perror_plus("incbuffer");
+      plaintext_length = -1;
+      goto decrypt_end;
     }
     
     ret = gpgme_data_read(dh_plain, *plaintext + plaintext_length,
@@ -360,7 +441,7 @@
       break;
     }
     if(ret < 0){
-      perror("gpgme_data_read");
+      perror_plus("gpgme_data_read");
       plaintext_length = -1;
       goto decrypt_end;
     }
@@ -368,7 +449,8 @@
   }
   
   if(debug){
-    fprintf(stderr, "Decrypted password is: ");
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Decrypted password is: ");
     for(ssize_t i = 0; i < plaintext_length; i++){
       fprintf(stderr, "%02hhX ", (*plaintext)[i]);
     }
@@ -396,7 +478,7 @@
 /* GnuTLS log function callback */
 static void debuggnutls(__attribute__((unused)) int level,
 			const char* string){
-  fprintf(stderr, "GnuTLS: %s", string);
+  fprintf(stderr, "Mandos plugin mandos-client: GnuTLS: %s", string);
 }
 
 static int init_gnutls_global(const char *pubkeyfilename,
@@ -404,13 +486,14 @@
   int ret;
   
   if(debug){
-    fprintf(stderr, "Initializing GnuTLS\n");
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Initializing GnuTLS\n");
   }
   
   ret = gnutls_global_init();
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "GnuTLS global_init: %s\n",
-	    safer_gnutls_strerror(ret));
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "GnuTLS global_init: %s\n", safer_gnutls_strerror(ret));
     return -1;
   }
   
@@ -423,19 +506,17 @@
   }
   
   /* OpenPGP credentials */
-  gnutls_certificate_allocate_credentials(&mc.cred);
+  ret = gnutls_certificate_allocate_credentials(&mc.cred);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "GnuTLS memory error: %s\n", /* Spurious warning
-						    from
-						    -Wunreachable-code
-						 */
-	    safer_gnutls_strerror(ret));
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "GnuTLS memory error: %s\n", safer_gnutls_strerror(ret));
     gnutls_global_deinit();
     return -1;
   }
   
   if(debug){
-    fprintf(stderr, "Attempting to use OpenPGP public key %s and"
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Attempting to use OpenPGP public key %s and"
 	    " secret key %s as GnuTLS credentials\n", pubkeyfilename,
 	    seckeyfilename);
   }
@@ -445,23 +526,26 @@
      GNUTLS_OPENPGP_FMT_BASE64);
   if(ret != GNUTLS_E_SUCCESS){
     fprintf(stderr,
+	    "Mandos plugin mandos-client: "
 	    "Error[%d] while reading the OpenPGP key pair ('%s',"
 	    " '%s')\n", ret, pubkeyfilename, seckeyfilename);
-    fprintf(stderr, "The GnuTLS error is: %s\n",
-	    safer_gnutls_strerror(ret));
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "The GnuTLS error is: %s\n", safer_gnutls_strerror(ret));
     goto globalfail;
   }
   
   /* GnuTLS server initialization */
   ret = gnutls_dh_params_init(&mc.dh_params);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "Error in GnuTLS DH parameter initialization:"
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Error in GnuTLS DH parameter initialization:"
 	    " %s\n", safer_gnutls_strerror(ret));
     goto globalfail;
   }
   ret = gnutls_dh_params_generate2(mc.dh_params, mc.dh_bits);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "Error in GnuTLS prime generation: %s\n",
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Error in GnuTLS prime generation: %s\n",
 	    safer_gnutls_strerror(ret));
     goto globalfail;
   }
@@ -488,7 +572,8 @@
     }
   } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "Error in GnuTLS session initialization: %s\n",
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Error in GnuTLS session initialization: %s\n",
 	    safer_gnutls_strerror(ret));
   }
   
@@ -502,9 +587,10 @@
       }
     } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
     if(ret != GNUTLS_E_SUCCESS){
-      fprintf(stderr, "Syntax error at: %s\n", err);
-      fprintf(stderr, "GnuTLS error: %s\n",
-	      safer_gnutls_strerror(ret));
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "Syntax error at: %s\n", err);
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "GnuTLS error: %s\n", safer_gnutls_strerror(ret));
       gnutls_deinit(*session);
       return -1;
     }
@@ -519,7 +605,8 @@
     }
   } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf(stderr, "Error setting GnuTLS credentials: %s\n",
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Error setting GnuTLS credentials: %s\n",
 	    safer_gnutls_strerror(ret));
     gnutls_deinit(*session);
     return -1;
@@ -571,7 +658,8 @@
     pf = PF_INET;
     break;
   default:
-    fprintf(stderr, "Bad address family: %d\n", af);
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Bad address family: %d\n", af);
     errno = EINVAL;
     return -1;
   }
@@ -582,14 +670,15 @@
   }
   
   if(debug){
-    fprintf(stderr, "Setting up a TCP connection to %s, port %" PRIu16
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Setting up a TCP connection to %s, port %" PRIu16
 	    "\n", ip, port);
   }
   
   tcp_sd = socket(pf, SOCK_STREAM, 0);
   if(tcp_sd < 0){
     int e = errno;
-    perror("socket");
+    perror_plus("socket");
     errno = e;
     goto mandos_end;
   }
@@ -609,13 +698,14 @@
   }
   if(ret < 0 ){
     int e = errno;
-    perror("inet_pton");
+    perror_plus("inet_pton");
     errno = e;
     goto mandos_end;
   }
   if(ret == 0){
     int e = errno;
-    fprintf(stderr, "Bad address: %s\n", ip);
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Bad address: %s\n", ip);
     errno = e;
     goto mandos_end;
   }
@@ -626,9 +716,10 @@
     
     if(IN6_IS_ADDR_LINKLOCAL /* Spurious warnings from */
        (&to.in6.sin6_addr)){ /* -Wstrict-aliasing=2 or lower and
-			      -Wunreachable-code*/
+				-Wunreachable-code*/
       if(if_index == AVAHI_IF_UNSPEC){
-	fprintf(stderr, "An IPv6 link-local address is incomplete"
+	fprintf(stderr, "Mandos plugin mandos-client: "
+		"An IPv6 link-local address is incomplete"
 		" without a network interface\n");
 	errno = EINVAL;
 	goto mandos_end;
@@ -651,14 +742,15 @@
     if(af == AF_INET6 and if_index != AVAHI_IF_UNSPEC){
       char interface[IF_NAMESIZE];
       if(if_indextoname((unsigned int)if_index, interface) == NULL){
-	perror("if_indextoname");
+	perror_plus("if_indextoname");
       } else {
-	fprintf(stderr, "Connection to: %s%%%s, port %" PRIu16 "\n",
+	fprintf(stderr, "Mandos plugin mandos-client: "
+		"Connection to: %s%%%s, port %" PRIu16 "\n",
 		ip, interface, port);
       }
     } else {
-      fprintf(stderr, "Connection to: %s, port %" PRIu16 "\n", ip,
-	      port);
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "Connection to: %s, port %" PRIu16 "\n", ip, port);
     }
     char addrstr[(INET_ADDRSTRLEN > INET6_ADDRSTRLEN) ?
 		 INET_ADDRSTRLEN : INET6_ADDRSTRLEN] = "";
@@ -671,10 +763,11 @@
 			sizeof(addrstr));
     }
     if(pcret == NULL){
-      perror("inet_ntop");
+      perror_plus("inet_ntop");
     } else {
       if(strcmp(addrstr, ip) != 0){
-	fprintf(stderr, "Canonical address form: %s\n", addrstr);
+	fprintf(stderr, "Mandos plugin mandos-client: "
+		"Canonical address form: %s\n", addrstr);
       }
     }
   }
@@ -692,7 +785,7 @@
   if(ret < 0){
     if ((errno != ECONNREFUSED and errno != ENETUNREACH) or debug){
       int e = errno;
-      perror("connect");
+      perror_plus("connect");
       errno = e;
     }
     goto mandos_end;
@@ -708,10 +801,10 @@
   while(true){
     size_t out_size = strlen(out);
     ret = (int)TEMP_FAILURE_RETRY(write(tcp_sd, out + written,
-				   out_size - written));
+					out_size - written));
     if(ret == -1){
       int e = errno;
-      perror("write");
+      perror_plus("write");
       errno = e;
       goto mandos_end;
     }
@@ -734,7 +827,8 @@
   }
   
   if(debug){
-    fprintf(stderr, "Establishing TLS session with %s\n", ip);
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Establishing TLS session with %s\n", ip);
   }
   
   if(quit_now){
@@ -742,6 +836,7 @@
     goto mandos_end;
   }
   
+  /* Spurious warning from -Wint-to-pointer-cast */
   gnutls_transport_set_ptr(session, (gnutls_transport_ptr_t) tcp_sd);
   
   if(quit_now){
@@ -759,7 +854,8 @@
   
   if(ret != GNUTLS_E_SUCCESS){
     if(debug){
-      fprintf(stderr, "*** GnuTLS Handshake failed ***\n");
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "*** GnuTLS Handshake failed ***\n");
       gnutls_perror(ret);
     }
     errno = EPROTO;
@@ -769,8 +865,8 @@
   /* Read OpenPGP packet that contains the wanted password */
   
   if(debug){
-    fprintf(stderr, "Retrieving OpenPGP encrypted password from %s\n",
-	    ip);
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Retrieving OpenPGP encrypted password from %s\n", ip);
   }
   
   while(true){
@@ -781,10 +877,10 @@
     }
     
     buffer_capacity = incbuffer(&buffer, buffer_length,
-				   buffer_capacity);
+				buffer_capacity);
     if(buffer_capacity == 0){
       int e = errno;
-      perror("incbuffer");
+      perror_plus("incbuffer");
       errno = e;
       goto mandos_end;
     }
@@ -814,14 +910,16 @@
 	  }
 	} while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
 	if(ret < 0){
-	  fprintf(stderr, "*** GnuTLS Re-handshake failed ***\n");
+	  fprintf(stderr, "Mandos plugin mandos-client: "
+		  "*** GnuTLS Re-handshake failed ***\n");
 	  gnutls_perror(ret);
 	  errno = EPROTO;
 	  goto mandos_end;
 	}
 	break;
       default:
-	fprintf(stderr, "Unknown error while reading data from"
+	fprintf(stderr, "Mandos plugin mandos-client: "
+		"Unknown error while reading data from"
 		" encrypted session with Mandos server\n");
 	gnutls_bye(session, GNUTLS_SHUT_RDWR);
 	errno = EIO;
@@ -833,7 +931,8 @@
   }
   
   if(debug){
-    fprintf(stderr, "Closing TLS session\n");
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Closing TLS session\n");
   }
   
   if(quit_now){
@@ -851,8 +950,7 @@
   
   if(buffer_length > 0){
     ssize_t decrypted_buffer_size;
-    decrypted_buffer_size = pgp_packet_decrypt(buffer,
-					       buffer_length,
+    decrypted_buffer_size = pgp_packet_decrypt(buffer, buffer_length,
 					       &decrypted_buffer);
     if(decrypted_buffer_size >= 0){
       
@@ -869,7 +967,8 @@
 	if(ret == 0 and ferror(stdout)){
 	  int e = errno;
 	  if(debug){
-	    fprintf(stderr, "Error writing encrypted data: %s\n",
+	    fprintf(stderr, "Mandos plugin mandos-client: "
+		    "Error writing encrypted data: %s\n",
 		    strerror(errno));
 	  }
 	  errno = e;
@@ -895,14 +994,14 @@
       if(e == 0){
 	e = errno;
       }
-      perror("close");
+      perror_plus("close");
     }
     gnutls_deinit(session);
+    errno = e;
     if(quit_now){
-      e = EINTR;
+      errno = EINTR;
       retval = -1;
     }
-    errno = e;
   }
   return retval;
 }
@@ -933,7 +1032,8 @@
   switch(event){
   default:
   case AVAHI_RESOLVER_FAILURE:
-    fprintf(stderr, "(Avahi Resolver) Failed to resolve service '%s'"
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "(Avahi Resolver) Failed to resolve service '%s'"
 	    " of type '%s' in domain '%s': %s\n", name, type, domain,
 	    avahi_strerror(avahi_server_errno(mc.server)));
     break;
@@ -943,7 +1043,8 @@
       char ip[AVAHI_ADDRESS_STR_MAX];
       avahi_address_snprint(ip, sizeof(ip), address);
       if(debug){
-	fprintf(stderr, "Mandos server \"%s\" found on %s (%s, %"
+	fprintf(stderr, "Mandos plugin mandos-client: "
+		"Mandos server \"%s\" found on %s (%s, %"
 		PRIdMAX ") on port %" PRIu16 "\n", name, host_name,
 		ip, (intmax_t)interface, port);
       }
@@ -951,6 +1052,9 @@
 					   avahi_proto_to_af(proto));
       if(ret == 0){
 	avahi_simple_poll_quit(mc.simple_poll);
+      } else {
+	ret = add_server(ip, port, interface,
+			 avahi_proto_to_af(proto));
       }
     }
   }
@@ -980,7 +1084,8 @@
   default:
   case AVAHI_BROWSER_FAILURE:
     
-    fprintf(stderr, "(Avahi browser) %s\n",
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "(Avahi browser) %s\n",
 	    avahi_strerror(avahi_server_errno(mc.server)));
     avahi_simple_poll_quit(mc.simple_poll);
     return;
@@ -994,7 +1099,8 @@
     if(avahi_s_service_resolver_new(mc.server, interface, protocol,
 				    name, type, domain, protocol, 0,
 				    resolve_callback, NULL) == NULL)
-      fprintf(stderr, "Avahi: Failed to resolve service '%s': %s\n",
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "Avahi: Failed to resolve service '%s': %s\n",
 	      name, avahi_strerror(avahi_server_errno(mc.server)));
     break;
     
@@ -1004,13 +1110,14 @@
   case AVAHI_BROWSER_ALL_FOR_NOW:
   case AVAHI_BROWSER_CACHE_EXHAUSTED:
     if(debug){
-      fprintf(stderr, "No Mandos server found, still searching...\n");
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "No Mandos server found, still searching...\n");
     }
     break;
   }
 }
 
-/* stop main loop after sigterm has been called */
+/* Signal handler that stops main loop after SIGTERM */
 static void handle_sigterm(int sig){
   if(quit_now){
     return;
@@ -1018,105 +1125,289 @@
   quit_now = 1;
   signal_received = sig;
   int old_errno = errno;
+  /* set main loop to exit */
   if(mc.simple_poll != NULL){
     avahi_simple_poll_quit(mc.simple_poll);
   }
   errno = old_errno;
 }
 
-/* 
- * This function determines if a directory entry in /sys/class/net
- * corresponds to an acceptable network device.
- * (This function is passed to scandir(3) as a filter function.)
- */
-int good_interface(const struct dirent *if_entry){
-  ssize_t ssret;
-  char *flagname = NULL;
-  int ret = asprintf(&flagname, "%s/%s/flags", sys_class_net,
-		     if_entry->d_name);
-  if(ret < 0){
-    perror("asprintf");
-    return 0;
-  }
-  if(if_entry->d_name[0] == '.'){
-    return 0;
-  }
-  int flags_fd = (int)TEMP_FAILURE_RETRY(open(flagname, O_RDONLY));
-  if(flags_fd == -1){
-    perror("open");
-    return 0;
-  }
-  typedef short ifreq_flags;	/* ifreq.ifr_flags in netdevice(7) */
-  /* read line from flags_fd */
-  ssize_t to_read = (sizeof(ifreq_flags)*2)+3; /* "0x1003\n" */
-  char *flagstring = malloc((size_t)to_read+1); /* +1 for final \0 */
-  flagstring[(size_t)to_read] = '\0';
-  if(flagstring == NULL){
-    perror("malloc");
-    close(flags_fd);
-    return 0;
-  }
-  while(to_read > 0){
-    ssret = (ssize_t)TEMP_FAILURE_RETRY(read(flags_fd, flagstring,
-					     (size_t)to_read));
-    if(ssret == -1){
-      perror("read");
-      free(flagstring);
-      close(flags_fd);
-      return 0;
-    }
-    to_read -= ssret;
-    if(ssret == 0){
-      break;
-    }
-  }
-  close(flags_fd);
-  intmax_t tmpmax;
-  char *tmp;
-  errno = 0;
-  tmpmax = strtoimax(flagstring, &tmp, 0);
-  if(errno != 0 or tmp == flagstring or (*tmp != '\0'
-					 and not (isspace(*tmp)))
-     or tmpmax != (ifreq_flags)tmpmax){
+bool get_flags(const char *ifname, struct ifreq *ifr){
+  int ret;
+  
+  int s = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
+  if(s < 0){
+    perror_plus("socket");
+    return false;
+  }
+  strcpy(ifr->ifr_name, ifname);
+  ret = ioctl(s, SIOCGIFFLAGS, ifr);
+  if(ret == -1){
     if(debug){
-      fprintf(stderr, "Invalid flags \"%s\" for interface \"%s\"\n",
-	      flagstring, if_entry->d_name);
+      perror_plus("ioctl SIOCGIFFLAGS");
     }
-    free(flagstring);
-    return 0;
+    return false;
   }
-  free(flagstring);
-  ifreq_flags flags = (ifreq_flags)tmpmax;
+  return true;
+}
+
+bool good_flags(const char *ifname, const struct ifreq *ifr){
+  
   /* Reject the loopback device */
-  if(flags & IFF_LOOPBACK){
+  if(ifr->ifr_flags & IFF_LOOPBACK){
     if(debug){
-      fprintf(stderr, "Rejecting loopback interface \"%s\"\n",
-	      if_entry->d_name);
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "Rejecting loopback interface \"%s\"\n", ifname);
     }
-    return 0;
+    return false;
   }
   /* Accept point-to-point devices only if connect_to is specified */
-  if(connect_to != NULL and (flags & IFF_POINTOPOINT)){
+  if(connect_to != NULL and (ifr->ifr_flags & IFF_POINTOPOINT)){
     if(debug){
-      fprintf(stderr, "Accepting point-to-point interface \"%s\"\n",
-	      if_entry->d_name);
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "Accepting point-to-point interface \"%s\"\n", ifname);
     }
-    return 1;
+    return true;
   }
   /* Otherwise, reject non-broadcast-capable devices */
-  if(not (flags & IFF_BROADCAST)){
-    if(debug){
-      fprintf(stderr, "Rejecting non-broadcast interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 0;
-  }
+  if(not (ifr->ifr_flags & IFF_BROADCAST)){
+    if(debug){
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "Rejecting non-broadcast interface \"%s\"\n", ifname);
+    }
+    return false;
+  }
+  /* Reject non-ARP interfaces (including dummy interfaces) */
+  if(ifr->ifr_flags & IFF_NOARP){
+    if(debug){
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "Rejecting non-ARP interface \"%s\"\n", ifname);
+    }
+    return false;
+  }
+  
   /* Accept this device */
   if(debug){
-    fprintf(stderr, "Interface \"%s\" is acceptable\n",
-	    if_entry->d_name);
-  }
-  return 1;
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Interface \"%s\" is good\n", ifname);
+  }
+  return true;
+}
+
+/* 
+ * This function determines if a directory entry in /sys/class/net
+ * corresponds to an acceptable network device.
+ * (This function is passed to scandir(3) as a filter function.)
+ */
+int good_interface(const struct dirent *if_entry){
+  if(if_entry->d_name[0] == '.'){
+    return 0;
+  }
+  
+  struct ifreq ifr;
+  if(not get_flags(if_entry->d_name, &ifr)){
+    if(debug){
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "Failed to get flags for interface \"%s\"\n",
+	      if_entry->d_name);
+    }
+    return 0;
+  }
+  
+  if(not good_flags(if_entry->d_name, &ifr)){
+    return 0;
+  }
+  return 1;
+}
+
+/* 
+ * This function determines if a directory entry in /sys/class/net
+ * corresponds to an acceptable network device which is up.
+ * (This function is passed to scandir(3) as a filter function.)
+ */
+int up_interface(const struct dirent *if_entry){
+  if(if_entry->d_name[0] == '.'){
+    return 0;
+  }
+  
+  struct ifreq ifr;
+  if(not get_flags(if_entry->d_name, &ifr)){
+    if(debug){
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "Failed to get flags for interface \"%s\"\n",
+	      if_entry->d_name);
+    }
+    return 0;
+  }
+  
+  /* Reject down interfaces */
+  if(not (ifr.ifr_flags & IFF_UP)){
+    if(debug){
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "Rejecting down interface \"%s\"\n",
+	      if_entry->d_name);
+    }
+    return 0;
+  }
+  
+  /* Reject non-running interfaces */
+  if(not (ifr.ifr_flags & IFF_RUNNING)){
+    if(debug){
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "Rejecting non-running interface \"%s\"\n",
+	      if_entry->d_name);
+    }
+    return 0;
+  }
+  
+  if(not good_flags(if_entry->d_name, &ifr)){
+    return 0;
+  }
+  return 1;
+}
+
+int notdotentries(const struct dirent *direntry){
+  /* Skip "." and ".." */
+  if(direntry->d_name[0] == '.'
+     and (direntry->d_name[1] == '\0'
+	  or (direntry->d_name[1] == '.'
+	      and direntry->d_name[2] == '\0'))){
+    return 0;
+  }
+  return 1;
+}
+
+/* Is this directory entry a runnable program? */
+int runnable_hook(const struct dirent *direntry){
+  int ret;
+  size_t sret;
+  struct stat st;
+  
+  if((direntry->d_name)[0] == '\0'){
+    /* Empty name? */
+    return 0;
+  }
+  
+  sret = strspn(direntry->d_name, "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
+		"abcdefghijklmnopqrstuvwxyz"
+		"0123456789"
+		"_-");
+  if((direntry->d_name)[sret] != '\0'){
+    /* Contains non-allowed characters */
+    if(debug){
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "Ignoring hook \"%s\" with bad name\n",
+	      direntry->d_name);
+    }
+    return 0;
+  }
+  
+  char *fullname = NULL;
+  ret = asprintf(&fullname, "%s/%s", hookdir, direntry->d_name);
+  if(ret < 0){
+    perror_plus("asprintf");
+    return 0;
+  }
+  
+  ret = stat(fullname, &st);
+  if(ret == -1){
+    if(debug){
+      perror_plus("Could not stat hook");
+    }
+    return 0;
+  }
+  if(not (S_ISREG(st.st_mode))){
+    /* Not a regular file */
+    if(debug){
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "Ignoring hook \"%s\" - not a file\n",
+	      direntry->d_name);
+    }
+    return 0;
+  }
+  if(not (st.st_mode & (S_IXUSR | S_IXGRP | S_IXOTH))){
+    /* Not executable */
+    if(debug){
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "Ignoring hook \"%s\" - not executable\n",
+	      direntry->d_name);
+    }
+    return 0;
+  }
+  return 1;
+}
+
+int avahi_loop_with_timeout(AvahiSimplePoll *s, int retry_interval){
+  int ret;
+  struct timespec now;
+  struct timespec waited_time;
+  intmax_t block_time;
+  
+  while(true){
+    if(mc.current_server == NULL){
+      if (debug){
+	fprintf(stderr, "Mandos plugin mandos-client: "
+		"Wait until first server is found. No timeout!\n");
+      }
+      ret = avahi_simple_poll_iterate(s, -1);
+    } else {
+      if (debug){
+	fprintf(stderr, "Mandos plugin mandos-client: "
+		"Check current_server if we should run it,"
+		" or wait\n");
+      }
+      /* the current time */
+      ret = clock_gettime(CLOCK_MONOTONIC, &now);
+      if(ret == -1){
+	perror_plus("clock_gettime");
+	return -1;
+      }
+      /* Calculating in ms how long time between now and server
+	 who we visted longest time ago. Now - last seen.  */
+      waited_time.tv_sec = (now.tv_sec
+			    - mc.current_server->last_seen.tv_sec);
+      waited_time.tv_nsec = (now.tv_nsec
+			     - mc.current_server->last_seen.tv_nsec);
+      /* total time is 10s/10,000ms.
+	 Converting to s from ms by dividing by 1,000,
+	 and ns to ms by dividing by 1,000,000. */
+      block_time = ((retry_interval
+		     - ((intmax_t)waited_time.tv_sec * 1000))
+		    - ((intmax_t)waited_time.tv_nsec / 1000000));
+      
+      if (debug){
+	fprintf(stderr, "Mandos plugin mandos-client: "
+		"Blocking for %" PRIdMAX " ms\n", block_time);
+      }
+      
+      if(block_time <= 0){
+	ret = start_mandos_communication(mc.current_server->ip,
+					 mc.current_server->port,
+					 mc.current_server->if_index,
+					 mc.current_server->af);
+	if(ret == 0){
+	  avahi_simple_poll_quit(mc.simple_poll);
+	  return 0;
+	}
+	ret = clock_gettime(CLOCK_MONOTONIC,
+			    &mc.current_server->last_seen);
+	if(ret == -1){
+	  perror_plus("clock_gettime");
+	  return -1;
+	}
+	mc.current_server = mc.current_server->next;
+	block_time = 0; 	/* Call avahi to find new Mandos
+				   servers, but don't block */
+      }
+      
+      ret = avahi_simple_poll_iterate(s, (int)block_time);
+    }
+    if(ret != 0){
+      if (ret > 0 or errno != EINTR){
+	return (ret != 1) ? ret : 0;
+      }
+    }
+  }
 }
 
 int main(int argc, char *argv[]){
@@ -1141,6 +1432,8 @@
   bool gnutls_initialized = false;
   bool gpgme_initialized = false;
   float delay = 2.5f;
+  double retry_interval = 10; /* 10s between trying a server and
+				 retrying the same server again */
   
   struct sigaction old_sigterm_action = { .sa_handler = SIG_DFL };
   struct sigaction sigterm_action = { .sa_handler = handle_sigterm };
@@ -1152,14 +1445,14 @@
   errno = 0;
   ret = setgid(gid);
   if(ret == -1){
-    perror("setgid");
+    perror_plus("setgid");
   }
   
   /* Lower user privileges (temporarily) */
   errno = 0;
   ret = seteuid(uid);
   if(ret == -1){
-    perror("seteuid");
+    perror_plus("seteuid");
   }
   
   if(quit_now){
@@ -1200,6 +1493,14 @@
 	.arg = "SECONDS",
 	.doc = "Maximum delay to wait for interface startup",
 	.group = 2 },
+      { .name = "retry", .key = 132,
+	.arg = "SECONDS",
+	.doc = "Retry interval used when denied by the mandos server",
+	.group = 2 },
+      { .name = "network-hook-dir", .key = 133,
+	.arg = "DIR",
+	.doc = "Directory where network hooks are located",
+	.group = 2 },
       /*
        * These reproduce what we would get without ARGP_NO_HELP
        */
@@ -1249,6 +1550,17 @@
 	if(errno != 0 or tmp == arg or *tmp != '\0'){
 	  argp_error(state, "Bad delay");
 	}
+      case 132:			/* --retry */
+	errno = 0;
+	retry_interval = strtod(arg, &tmp);
+	if(errno != 0 or tmp == arg or *tmp != '\0'
+	   or (retry_interval * 1000) > INT_MAX
+	   or retry_interval < 0){
+	  argp_error(state, "Bad retry interval");
+	}
+	break;
+      case 133:			/* --network-hook-dir */
+	hookdir = arg;
 	break;
 	/*
 	 * These reproduce what we would get without ARGP_NO_HELP
@@ -1261,6 +1573,7 @@
 	argp_state_help(state, state->out_stream,
 			ARGP_HELP_USAGE | ARGP_HELP_EXIT_ERR);
       case 'V':			/* --version */
+	fprintf(state->out_stream, "Mandos plugin mandos-client: ");
 	fprintf(state->out_stream, "%s\n", argp_program_version);
 	exit(argp_err_exit_status);
 	break;
@@ -1282,7 +1595,7 @@
     case ENOMEM:
     default:
       errno = ret;
-      perror("argp_parse");
+      perror_plus("argp_parse");
       exitcode = EX_OSERR;
       goto end;
     case EINVAL:
@@ -1290,23 +1603,190 @@
       goto end;
     }
   }
+    
+  {
+    /* Work around Debian bug #633582:
+       <http://bugs.debian.org/633582> */
+    struct stat st;
+    
+    /* Re-raise priviliges */
+    errno = 0;
+    ret = seteuid(0);
+    if(ret == -1){
+      perror_plus("seteuid");
+    }
+    
+    if(strcmp(seckey, PATHDIR "/" SECKEY) == 0){
+      int seckey_fd = open(seckey, O_RDONLY);
+      if(seckey_fd == -1){
+	perror_plus("open");
+      } else {
+	ret = (int)TEMP_FAILURE_RETRY(fstat(seckey_fd, &st));
+	if(ret == -1){
+	  perror_plus("fstat");
+	} else {
+	  if(S_ISREG(st.st_mode) and st.st_uid == 0 and st.st_gid == 0){
+	    ret = fchown(seckey_fd, uid, gid);
+	    if(ret == -1){
+	      perror_plus("fchown");
+	    }
+	  }
+	}
+	TEMP_FAILURE_RETRY(close(seckey_fd));
+      }
+    }
+    
+    if(strcmp(pubkey, PATHDIR "/" PUBKEY) == 0){
+      int pubkey_fd = open(pubkey, O_RDONLY);
+      if(pubkey_fd == -1){
+	perror_plus("open");
+      } else {
+	ret = (int)TEMP_FAILURE_RETRY(fstat(pubkey_fd, &st));
+	if(ret == -1){
+	  perror_plus("fstat");
+	} else {
+	  if(S_ISREG(st.st_mode) and st.st_uid == 0 and st.st_gid == 0){
+	    ret = fchown(pubkey_fd, uid, gid);
+	    if(ret == -1){
+	      perror_plus("fchown");
+	    }
+	  }
+	}
+	TEMP_FAILURE_RETRY(close(pubkey_fd));
+      }
+    }
+    
+    /* Lower privileges */
+    errno = 0;
+    ret = seteuid(uid);
+    if(ret == -1){
+      perror_plus("seteuid");
+    }
+  }
+  
+  /* Find network hooks and run them */
+  {
+    struct dirent **direntries;
+    struct dirent *direntry;
+    int numhooks = scandir(hookdir, &direntries, runnable_hook,
+			   alphasort);
+    if(numhooks == -1){
+      perror_plus("scandir");
+    } else {
+      int devnull = open("/dev/null", O_RDONLY);
+      for(int i = 0; i < numhooks; i++){
+	direntry = direntries[0];
+	char *fullname = NULL;
+	ret = asprintf(&fullname, "%s/%s", hookdir, direntry->d_name);
+	if(ret < 0){
+	  perror_plus("asprintf");
+	  continue;
+	}
+	pid_t hook_pid = fork();
+	if(hook_pid == 0){
+	  /* Child */
+	  dup2(devnull, STDIN_FILENO);
+	  close(devnull);
+	  dup2(STDERR_FILENO, STDOUT_FILENO);
+	  ret = setenv("MANDOSNETHOOKDIR", hookdir, 1);
+	  if(ret == -1){
+	    perror_plus("setenv");
+	    exit(1);
+	  }
+	  ret = setenv("DEVICE", interface, 1);
+	  if(ret == -1){
+	    perror_plus("setenv");
+	    exit(1);
+	  }
+	  ret = setenv("VERBOSE", debug ? "1" : "0", 1);
+	  if(ret == -1){
+	    perror_plus("setenv");
+	    exit(1);
+	  }
+	  ret = setenv("MODE", "start", 1);
+	  if(ret == -1){
+	    perror_plus("setenv");
+	    exit(1);
+	  }
+	  char *delaystring;
+	  ret = asprintf(&delaystring, "%f", delay);
+	  if(ret == -1){
+	    perror_plus("asprintf");
+	    exit(1);
+	  }
+	  ret = setenv("DELAY", delaystring, 1);
+	  if(ret == -1){
+	    free(delaystring);
+	    perror_plus("setenv");
+	    exit(1);
+	  }
+	  free(delaystring);
+	  ret = execl(fullname, direntry->d_name, "start", NULL);
+	  perror_plus("execl");
+	} else {
+	  int status;
+	  if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
+	    perror_plus("waitpid");
+	    free(fullname);
+	    continue;
+	  }
+	  if(WIFEXITED(status)){
+	    if(WEXITSTATUS(status) != 0){
+	      fprintf(stderr, "Mandos plugin mandos-client: "
+		      "Warning: network hook \"%s\" exited"
+		      " with status %d\n", direntry->d_name,
+		      WEXITSTATUS(status));
+	      free(fullname);
+	      continue;
+	    }
+	  } else if(WIFSIGNALED(status)){
+	    fprintf(stderr, "Mandos plugin mandos-client: "
+		    "Warning: network hook \"%s\" died by"
+		    " signal %d\n", direntry->d_name,
+		    WTERMSIG(status));
+	    free(fullname);
+	    continue;
+	  } else {
+	    fprintf(stderr, "Mandos plugin mandos-client: "
+		    "Warning: network hook \"%s\" crashed\n",
+		    direntry->d_name);
+	    free(fullname);
+	    continue;
+	  }
+	}
+	free(fullname);
+	if(quit_now){
+	  goto end;
+	}
+      }
+      close(devnull);
+    }
+  }
   
   if(not debug){
     avahi_set_log_function(empty_log);
   }
-
+  
   if(interface[0] == '\0'){
     struct dirent **direntries;
-    ret = scandir(sys_class_net, &direntries, good_interface,
+    /* First look for interfaces that are up */
+    ret = scandir(sys_class_net, &direntries, up_interface,
 		  alphasort);
+    if(ret == 0){
+      /* No up interfaces, look for any good interfaces */
+      free(direntries);
+      ret = scandir(sys_class_net, &direntries, good_interface,
+		    alphasort);
+    }
     if(ret >= 1){
-      /* Pick the first good interface */
+      /* Pick the first interface returned */
       interface = strdup(direntries[0]->d_name);
       if(debug){
-	fprintf(stderr, "Using interface \"%s\"\n", interface);
+	fprintf(stderr, "Mandos plugin mandos-client: "
+		"Using interface \"%s\"\n", interface);
       }
       if(interface == NULL){
-	perror("malloc");
+	perror_plus("malloc");
 	free(direntries);
 	exitcode = EXIT_FAILURE;
 	goto end;
@@ -1314,7 +1794,8 @@
       free(direntries);
     } else {
       free(direntries);
-      fprintf(stderr, "Could not find a network interface\n");
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "Could not find a network interface\n");
       exitcode = EXIT_FAILURE;
       goto end;
     }
@@ -1326,7 +1807,8 @@
   srand((unsigned int) time(NULL));
   mc.simple_poll = avahi_simple_poll_new();
   if(mc.simple_poll == NULL){
-    fprintf(stderr, "Avahi: Failed to create simple poll object.\n");
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Avahi: Failed to create simple poll object.\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
   }
@@ -1334,19 +1816,19 @@
   sigemptyset(&sigterm_action.sa_mask);
   ret = sigaddset(&sigterm_action.sa_mask, SIGINT);
   if(ret == -1){
-    perror("sigaddset");
+    perror_plus("sigaddset");
     exitcode = EX_OSERR;
     goto end;
   }
   ret = sigaddset(&sigterm_action.sa_mask, SIGHUP);
   if(ret == -1){
-    perror("sigaddset");
+    perror_plus("sigaddset");
     exitcode = EX_OSERR;
     goto end;
   }
   ret = sigaddset(&sigterm_action.sa_mask, SIGTERM);
   if(ret == -1){
-    perror("sigaddset");
+    perror_plus("sigaddset");
     exitcode = EX_OSERR;
     goto end;
   }
@@ -1356,39 +1838,39 @@
   */
   ret = sigaction(SIGINT, NULL, &old_sigterm_action);
   if(ret == -1){
-    perror("sigaction");
+    perror_plus("sigaction");
     return EX_OSERR;
   }
   if(old_sigterm_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGINT, &sigterm_action, NULL);
     if(ret == -1){
-      perror("sigaction");
+      perror_plus("sigaction");
       exitcode = EX_OSERR;
       goto end;
     }
   }
   ret = sigaction(SIGHUP, NULL, &old_sigterm_action);
   if(ret == -1){
-    perror("sigaction");
+    perror_plus("sigaction");
     return EX_OSERR;
   }
   if(old_sigterm_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGHUP, &sigterm_action, NULL);
     if(ret == -1){
-      perror("sigaction");
+      perror_plus("sigaction");
       exitcode = EX_OSERR;
       goto end;
     }
   }
   ret = sigaction(SIGTERM, NULL, &old_sigterm_action);
   if(ret == -1){
-    perror("sigaction");
+    perror_plus("sigaction");
     return EX_OSERR;
   }
   if(old_sigterm_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGTERM, &sigterm_action, NULL);
     if(ret == -1){
-      perror("sigaction");
+      perror_plus("sigaction");
       exitcode = EX_OSERR;
       goto end;
     }
@@ -1398,7 +1880,8 @@
   if(strcmp(interface, "none") != 0){
     if_index = (AvahiIfIndex) if_nametoindex(interface);
     if(if_index == 0){
-      fprintf(stderr, "No such interface: \"%s\"\n", interface);
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "No such interface: \"%s\"\n", interface);
       exitcode = EX_UNAVAILABLE;
       goto end;
     }
@@ -1411,7 +1894,7 @@
     errno = 0;
     ret = seteuid(0);
     if(ret == -1){
-      perror("seteuid");
+      perror_plus("seteuid");
     }
     
 #ifdef __linux__
@@ -1421,19 +1904,19 @@
     bool restore_loglevel = true;
     if(ret == -1){
       restore_loglevel = false;
-      perror("klogctl");
+      perror_plus("klogctl");
     }
 #endif	/* __linux__ */
     
     sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
     if(sd < 0){
-      perror("socket");
+      perror_plus("socket");
       exitcode = EX_OSERR;
 #ifdef __linux__
       if(restore_loglevel){
 	ret = klogctl(7, NULL, 0);
 	if(ret == -1){
-	  perror("klogctl");
+	  perror_plus("klogctl");
 	}
       }
 #endif	/* __linux__ */
@@ -1441,19 +1924,19 @@
       errno = 0;
       ret = seteuid(uid);
       if(ret == -1){
-	perror("seteuid");
+	perror_plus("seteuid");
       }
       goto end;
     }
     strcpy(network.ifr_name, interface);
     ret = ioctl(sd, SIOCGIFFLAGS, &network);
     if(ret == -1){
-      perror("ioctl SIOCGIFFLAGS");
+      perror_plus("ioctl SIOCGIFFLAGS");
 #ifdef __linux__
       if(restore_loglevel){
 	ret = klogctl(7, NULL, 0);
 	if(ret == -1){
-	  perror("klogctl");
+	  perror_plus("klogctl");
 	}
       }
 #endif	/* __linux__ */
@@ -1462,7 +1945,7 @@
       errno = 0;
       ret = seteuid(uid);
       if(ret == -1){
-	perror("seteuid");
+	perror_plus("seteuid");
       }
       goto end;
     }
@@ -1472,13 +1955,13 @@
       ret = ioctl(sd, SIOCSIFFLAGS, &network);
       if(ret == -1){
 	take_down_interface = false;
-	perror("ioctl SIOCSIFFLAGS +IFF_UP");
+	perror_plus("ioctl SIOCSIFFLAGS +IFF_UP");
 	exitcode = EX_OSERR;
 #ifdef __linux__
 	if(restore_loglevel){
 	  ret = klogctl(7, NULL, 0);
 	  if(ret == -1){
-	    perror("klogctl");
+	    perror_plus("klogctl");
 	  }
 	}
 #endif	/* __linux__ */
@@ -1486,30 +1969,31 @@
 	errno = 0;
 	ret = seteuid(uid);
 	if(ret == -1){
-	  perror("seteuid");
+	  perror_plus("seteuid");
 	}
 	goto end;
       }
     }
-    /* sleep checking until interface is running */
+    /* Sleep checking until interface is running.
+       Check every 0.25s, up to total time of delay */
     for(int i=0; i < delay * 4; i++){
       ret = ioctl(sd, SIOCGIFFLAGS, &network);
       if(ret == -1){
-	perror("ioctl SIOCGIFFLAGS");
+	perror_plus("ioctl SIOCGIFFLAGS");
       } else if(network.ifr_flags & IFF_RUNNING){
 	break;
       }
       struct timespec sleeptime = { .tv_nsec = 250000000 };
       ret = nanosleep(&sleeptime, NULL);
       if(ret == -1 and errno != EINTR){
-	perror("nanosleep");
+	perror_plus("nanosleep");
       }
     }
     if(not take_down_interface){
       /* We won't need the socket anymore */
       ret = (int)TEMP_FAILURE_RETRY(close(sd));
       if(ret == -1){
-	perror("close");
+	perror_plus("close");
       }
     }
 #ifdef __linux__
@@ -1517,7 +2001,7 @@
       /* Restores kernel loglevel to default */
       ret = klogctl(7, NULL, 0);
       if(ret == -1){
-	perror("klogctl");
+	perror_plus("klogctl");
       }
     }
 #endif	/* __linux__ */
@@ -1527,13 +2011,13 @@
       /* Lower privileges */
       ret = seteuid(uid);
       if(ret == -1){
-	perror("seteuid");
+	perror_plus("seteuid");
       }
     } else {
       /* Lower privileges permanently */
       ret = setuid(uid);
       if(ret == -1){
-	perror("setuid");
+	perror_plus("setuid");
       }
     }
   }
@@ -1544,7 +2028,8 @@
   
   ret = init_gnutls_global(pubkey, seckey);
   if(ret == -1){
-    fprintf(stderr, "init_gnutls_global failed\n");
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "init_gnutls_global failed\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
   } else {
@@ -1555,19 +2040,19 @@
     goto end;
   }
   
+  if(mkdtemp(tempdir) == NULL){
+    perror_plus("mkdtemp");
+    goto end;
+  }
   tempdir_created = true;
-  if(mkdtemp(tempdir) == NULL){
-    tempdir_created = false;
-    perror("mkdtemp");
-    goto end;
-  }
   
   if(quit_now){
     goto end;
   }
   
   if(not init_gpgme(pubkey, seckey, tempdir)){
-    fprintf(stderr, "init_gpgme failed\n");
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "init_gpgme failed\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
   } else {
@@ -1583,7 +2068,8 @@
     /* (Mainly meant for debugging) */
     char *address = strrchr(connect_to, ':');
     if(address == NULL){
-      fprintf(stderr, "No colon in address\n");
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "No colon in address\n");
       exitcode = EX_USAGE;
       goto end;
     }
@@ -1597,7 +2083,8 @@
     tmpmax = strtoimax(address+1, &tmp, 10);
     if(errno != 0 or tmp == address+1 or *tmp != '\0'
        or tmpmax != (uint16_t)tmpmax){
-      fprintf(stderr, "Bad port number\n");
+      fprintf(stderr, "Mandos plugin mandos-client: "
+	      "Bad port number\n");
       exitcode = EX_USAGE;
       goto end;
     }
@@ -1608,31 +2095,41 @@
     
     port = (uint16_t)tmpmax;
     *address = '\0';
-    address = connect_to;
     /* Colon in address indicates IPv6 */
     int af;
-    if(strchr(address, ':') != NULL){
+    if(strchr(connect_to, ':') != NULL){
       af = AF_INET6;
+      /* Accept [] around IPv6 address - see RFC 5952 */
+      if(connect_to[0] == '[' and address[-1] == ']')
+	{
+	  connect_to++;
+	  address[-1] = '\0';
+	}
     } else {
       af = AF_INET;
     }
+    address = connect_to;
     
     if(quit_now){
       goto end;
     }
-
+    
     while(not quit_now){
       ret = start_mandos_communication(address, port, if_index, af);
       if(quit_now or ret == 0){
 	break;
       }
-      sleep(15);
-    };
-
+      if(debug){
+	fprintf(stderr, "Mandos plugin mandos-client: "
+		"Retrying in %d seconds\n", (int)retry_interval);
+      }
+      sleep((int)retry_interval);
+    }
+    
     if (not quit_now){
       exitcode = EXIT_SUCCESS;
     }
-
+    
     goto end;
   }
   
@@ -1660,7 +2157,8 @@
   
   /* Check if creating the Avahi server object succeeded */
   if(mc.server == NULL){
-    fprintf(stderr, "Failed to create Avahi server: %s\n",
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Failed to create Avahi server: %s\n",
 	    avahi_strerror(error));
     exitcode = EX_UNAVAILABLE;
     goto end;
@@ -1675,7 +2173,8 @@
 				   AVAHI_PROTO_UNSPEC, "_mandos._tcp",
 				   NULL, 0, browse_callback, NULL);
   if(sb == NULL){
-    fprintf(stderr, "Failed to create service browser: %s\n",
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Failed to create service browser: %s\n",
 	    avahi_strerror(avahi_server_errno(mc.server)));
     exitcode = EX_UNAVAILABLE;
     goto end;
@@ -1688,15 +2187,23 @@
   /* Run the main loop */
   
   if(debug){
-    fprintf(stderr, "Starting Avahi loop search\n");
-  }
-  
-  avahi_simple_poll_loop(mc.simple_poll);
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "Starting Avahi loop search\n");
+  }
+
+  ret = avahi_loop_with_timeout(mc.simple_poll,
+				(int)(retry_interval * 1000));
+  if(debug){
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "avahi_loop_with_timeout exited %s\n",
+	    (ret == 0) ? "successfully" : "with error");
+  }
   
  end:
   
   if(debug){
-    fprintf(stderr, "%s exiting\n", argv[0]);
+    fprintf(stderr, "Mandos plugin mandos-client: "
+	    "%s exiting\n", argv[0]);
   }
   
   /* Cleanup things */
@@ -1718,6 +2225,19 @@
   if(gpgme_initialized){
     gpgme_release(mc.ctx);
   }
+
+  /* Cleans up the circular linked list of Mandos servers the client
+     has seen */
+  if(mc.current_server != NULL){
+    mc.current_server->prev->next = NULL;
+    while(mc.current_server != NULL){
+      server *next = mc.current_server->next;
+      free(mc.current_server);
+      mc.current_server = next;
+    }
+  }
+  
+  /* XXX run network hooks "stop" here  */
   
   /* Take down the network interface */
   if(take_down_interface){
@@ -1725,73 +2245,65 @@
     errno = 0;
     ret = seteuid(0);
     if(ret == -1){
-      perror("seteuid");
+      perror_plus("seteuid");
     }
     if(geteuid() == 0){
       ret = ioctl(sd, SIOCGIFFLAGS, &network);
       if(ret == -1){
-	perror("ioctl SIOCGIFFLAGS");
-      } else if(network.ifr_flags & IFF_UP) {
+	perror_plus("ioctl SIOCGIFFLAGS");
+      } else if(network.ifr_flags & IFF_UP){
 	network.ifr_flags &= ~(short)IFF_UP; /* clear flag */
 	ret = ioctl(sd, SIOCSIFFLAGS, &network);
 	if(ret == -1){
-	  perror("ioctl SIOCSIFFLAGS -IFF_UP");
+	  perror_plus("ioctl SIOCSIFFLAGS -IFF_UP");
 	}
       }
       ret = (int)TEMP_FAILURE_RETRY(close(sd));
       if(ret == -1){
-	perror("close");
+	perror_plus("close");
       }
       /* Lower privileges permanently */
       errno = 0;
       ret = setuid(uid);
       if(ret == -1){
-	perror("setuid");
+	perror_plus("setuid");
       }
     }
   }
   
-  /* Removes the temp directory used by GPGME */
+  /* Removes the GPGME temp directory and all files inside */
   if(tempdir_created){
-    DIR *d;
-    struct dirent *direntry;
-    d = opendir(tempdir);
-    if(d == NULL){
-      if(errno != ENOENT){
-	perror("opendir");
-      }
-    } else {
-      while(true){
-	direntry = readdir(d);
-	if(direntry == NULL){
-	  break;
-	}
-	/* Skip "." and ".." */
-	if(direntry->d_name[0] == '.'
-	   and (direntry->d_name[1] == '\0'
-		or (direntry->d_name[1] == '.'
-		    and direntry->d_name[2] == '\0'))){
-	  continue;
-	}
+    struct dirent **direntries = NULL;
+    struct dirent *direntry = NULL;
+    int numentries = scandir(tempdir, &direntries, notdotentries,
+			     alphasort);
+    if (numentries > 0){
+      for(int i = 0; i < numentries; i++){
+	direntry = direntries[i];
 	char *fullname = NULL;
 	ret = asprintf(&fullname, "%s/%s", tempdir,
 		       direntry->d_name);
 	if(ret < 0){
-	  perror("asprintf");
+	  perror_plus("asprintf");
 	  continue;
 	}
 	ret = remove(fullname);
 	if(ret == -1){
-	  fprintf(stderr, "remove(\"%s\"): %s\n", fullname,
-		  strerror(errno));
+	  fprintf(stderr, "Mandos plugin mandos-client: "
+		  "remove(\"%s\"): %s\n", fullname, strerror(errno));
 	}
 	free(fullname);
       }
-      closedir(d);
+    }
+
+    /* need to clean even if 0 because man page doesn't specify */
+    free(direntries);
+    if (numentries == -1){
+      perror_plus("scandir");
     }
     ret = rmdir(tempdir);
     if(ret == -1 and errno != ENOENT){
-      perror("rmdir");
+      perror_plus("rmdir");
     }
   }
   
@@ -1802,13 +2314,13 @@
 					    &old_sigterm_action,
 					    NULL));
     if(ret == -1){
-      perror("sigaction");
+      perror_plus("sigaction");
     }
     do {
       ret = raise(signal_received);
     } while(ret != 0 and errno == EINTR);
     if(ret != 0){
-      perror("raise");
+      perror_plus("raise");
       abort();
     }
     TEMP_FAILURE_RETRY(pause());

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2010-09-26 18:32:58 +0000
+++ plugins.d/mandos-client.xml	2011-11-13 20:49:21 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,20 +19,21 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -97,6 +98,14 @@
       </arg>
       <sbr/>
       <arg>
+	<option>--retry <replaceable>SECONDS</replaceable></option>
+      </arg>
+      <sbr/>
+      <arg>
+	<option>--network-hook-dir<replaceable>DIR</replaceable></option>
+      </arg>
+      <sbr/>
+      <arg>
 	<option>--debug</option>
       </arg>
     </cmdsynopsis>
@@ -133,9 +142,9 @@
       using TLS with an OpenPGP key to ensure authenticity and
       confidentiality.  This client program keeps running, trying all
       servers on the network, until it receives a satisfactory reply
-      or a TERM signal is received.  If no servers are found, or after
-      all servers have been tried, it waits indefinitely for new
-      servers to appear.
+      or a TERM signal.  After all servers have been tried, all
+      servers are periodically retried.  If no servers are found it
+      will wait indefinitely for new servers to appear.
     </para>
     <para>
       This program is not meant to be run directly; it is really meant
@@ -293,6 +302,31 @@
 	  </para>
 	</listitem>
       </varlistentry>
+
+      <varlistentry>
+	<term><option>--retry=<replaceable
+	>SECONDS</replaceable></option></term>
+	<listitem>
+	  <para>
+	    All Mandos servers are tried repeatedly until a password
+	    is received.  This value specifies, in seconds, how long
+	    between each successive try <emphasis>for the same
+	    server</emphasis>.  The default is 10 seconds.
+	  </para>
+	</listitem>
+      </varlistentry>
+
+      <varlistentry>
+	<term><option>--network-hook-dir=<replaceable
+	>DIR</replaceable></option></term>
+	<listitem>
+	  <para>
+	    Network hook directory.  The default directory is
+	    <quote><filename class="directory"
+	    >/lib/mandos/network-hooks.d</filename></quote>.
+	  </para>
+	</listitem>
+      </varlistentry>
       
       <varlistentry>
 	<term><option>--debug</option></term>
@@ -371,9 +405,9 @@
       server could be found and the password received from it could be
       successfully decrypted and output on standard output.  The
       program will exit with a non-zero exit status only if a critical
-      error occurs.  Otherwise, it will forever connect to new
-      <application>Mandos</application> servers as they appear, trying
-      to get a decryptable password and print it.
+      error occurs.  Otherwise, it will forever connect to any
+      discovered <application>Mandos</application> servers, trying to
+      get a decryptable password and print it.
     </para>
   </refsect1>
   
@@ -518,6 +552,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>cryptsetup</refentrytitle>
       <manvolnum>8</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>crypttab</refentrytitle>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2010-11-05 18:30:07 +0000
+++ plugins.d/password-prompt.c	2011-10-09 12:32:13 +0000
@@ -2,8 +2,8 @@
 /*
  * Password-prompt - Read a password from the terminal and print it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -19,12 +19,12 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 #define _GNU_SOURCE		/* getline(), asprintf() */
 
-#include <termios.h> 		/* struct termios, tcsetattr(),
+#include <termios.h>		/* struct termios, tcsetattr(),
 				   TCSAFLUSH, tcgetattr(), ECHO */
 #include <unistd.h>		/* struct termios, tcsetattr(),
 				   STDIN_FILENO, TCSAFLUSH,
@@ -35,13 +35,14 @@
 				   SIGQUIT, SIGHUP, SIGTERM,
 				   raise() */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
-#include <sys/types.h>		/* ssize_t, struct dirent, pid_t, ssize_t */
+#include <sys/types.h>		/* ssize_t, struct dirent, pid_t,
+				   ssize_t, open() */
 #include <stdlib.h>		/* EXIT_SUCCESS, EXIT_FAILURE,
 				   getenv(), free() */
 #include <dirent.h>		/* scandir(), alphasort() */
 #include <stdio.h>		/* fprintf(), stderr, getline(),
-				   stdin, feof(), fputc()
-				*/
+				   stdin, feof(), fputc(), vfprintf(),
+				   vasprintf() */
 #include <errno.h>		/* errno, EBADF, ENOTTY, EINVAL,
 				   EFAULT, EFBIG, EIO, ENOSPC, EINTR
 				*/
@@ -49,8 +50,9 @@
 #include <iso646.h>		/* or, not */
 #include <stdbool.h>		/* bool, false, true */
 #include <inttypes.h>		/* strtoumax() */
-#include <sys/stat.h> 		/* struct stat, lstat() */
-#include <string.h> 		/* strlen, rindex, memcmp */
+#include <sys/stat.h>		/* struct stat, lstat(), open() */
+#include <string.h>		/* strlen, rindex, memcmp, strerror()
+				 */
 #include <argp.h>		/* struct argp_option, struct
 				   argp_state, struct argp,
 				   argp_parse(), error_t,
@@ -58,16 +60,40 @@
 				   ARGP_ERR_UNKNOWN */
 #include <sysexits.h>		/* EX_SOFTWARE, EX_OSERR,
 				   EX_UNAVAILABLE, EX_IOERR, EX_OK */
+#include <fcntl.h>		/* open() */
+#include <stdarg.h>		/* va_list, va_start(), ... */
 
 volatile sig_atomic_t quit_now = 0;
 int signal_received;
 bool debug = false;
 const char *argp_program_version = "password-prompt " VERSION;
-const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
-
-/* Needed for conflic resolution */
-const char plymouthd_path[] = "/sbin/plymouth";
-
+const char *argp_program_bug_address = "<mandos@recompile.se>";
+
+/* Needed for conflict resolution */
+const char plymouth_name[] = "plymouthd";
+
+/* Function to use when printing errors */
+void error_plus(int status, int errnum, const char *formatstring,
+		...){
+  va_list ap;
+  char *text;
+  int ret;
+  
+  va_start(ap, formatstring);
+  ret = vasprintf(&text, formatstring, ap);
+  if (ret == -1){
+    fprintf(stderr, "Mandos plugin %s: ",
+	    program_invocation_short_name);
+    vfprintf(stderr, formatstring, ap);
+    fprintf(stderr, ": ");
+    fprintf(stderr, "%s\n", strerror(errnum));
+    error(status, errno, "vasprintf while printing error");
+    return;
+  }
+  fprintf(stderr, "Mandos plugin ");
+  error(status, errnum, "%s", text);
+  free(text);
+}
 
 static void termination_handler(int signum){
   if(quit_now){
@@ -79,12 +105,13 @@
 
 bool conflict_detection(void){
 
-  /* plymouth conflicts with password-promt since both want to control the
-     associated terminal. Password-prompt exit since plymouth perferms the same
-     functionallity.
+  /* plymouth conflicts with password-prompt since both want to read
+     from the terminal.  Password-prompt will exit if it detects
+     plymouth since plymouth performs the same functionality.
    */
   int is_plymouth(const struct dirent *proc_entry){
     int ret;
+    int cl_fd;
     {
       uintmax_t maxvalue;
       char *tmp;
@@ -96,52 +123,99 @@
 	return 0;
       }
     }
-    char exe_target[sizeof(plymouthd_path)];
-    char *exe_link;
-    ret = asprintf(&exe_link, "/proc/%s/exe", proc_entry->d_name);
+    
+    char *cmdline_filename;
+    ret = asprintf(&cmdline_filename, "/proc/%s/cmdline",
+		   proc_entry->d_name);
     if(ret == -1){
       error(0, errno, "asprintf");
       return 0;
     }
-  
-    struct stat exe_stat;
-    ret = lstat(exe_link, &exe_stat);
-    if(ret == -1){
-      free(exe_link);
+    
+    /* Open /proc/<pid>/cmdline */
+    cl_fd = open(cmdline_filename, O_RDONLY);
+    free(cmdline_filename);
+    if(cl_fd == -1){
       if(errno != ENOENT){
-	error(0, errno, "lstat");
-      }
-      return 0;
-    }
-  
-    if(not S_ISLNK(exe_stat.st_mode)
-       or exe_stat.st_uid != 0
-       or exe_stat.st_gid != 0){
-      free(exe_link);
-      return 0;
-    }
-  
-    ssize_t sret = readlink(exe_link, exe_target, sizeof(exe_target));
-    free(exe_link);
-    if((sret != (ssize_t)sizeof(plymouthd_path)-1) or
-       (memcmp(plymouthd_path, exe_target,
-	       sizeof(plymouthd_path)-1) != 0)){
-      return 0;
-    }
+	error(0, errno, "open");
+      }
+      return 0;
+    }
+    
+    char *cmdline = NULL;
+    {
+      size_t cmdline_len = 0;
+      size_t cmdline_allocated = 0;
+      char *tmp;
+      const size_t blocksize = 1024;
+      ssize_t sret;
+      do {
+	/* Allocate more space? */
+	if(cmdline_len + blocksize + 1 > cmdline_allocated){
+	  tmp = realloc(cmdline, cmdline_allocated + blocksize + 1);
+	  if(tmp == NULL){
+	    error(0, errno, "realloc");
+	    free(cmdline);
+	    close(cl_fd);
+	    return 0;
+	  }
+	  cmdline = tmp;
+	  cmdline_allocated += blocksize;
+	}
+	
+	/* Read data */
+	sret = read(cl_fd, cmdline + cmdline_len,
+		    cmdline_allocated - cmdline_len);
+	if(sret == -1){
+	  error(0, errno, "read");
+	  free(cmdline);
+	  close(cl_fd);
+	  return 0;
+	}
+	cmdline_len += (size_t)sret;
+      } while(sret != 0);
+      ret = close(cl_fd);
+      if(ret == -1){
+	error(0, errno, "close");
+	free(cmdline);
+	return 0;
+      }
+      cmdline[cmdline_len] = '\0'; /* Make sure it is terminated */
+    }
+    /* we now have cmdline */
+    
+    /* get basename */
+    char *cmdline_base = strrchr(cmdline, '/');
+    if(cmdline_base != NULL){
+      cmdline_base += 1;		/* skip the slash */
+    } else {
+      cmdline_base = cmdline;
+    }
+    
+    if(strcmp(cmdline_base, plymouth_name) != 0){
+      if(debug){
+	fprintf(stderr, "\"%s\" is not \"%s\"\n", cmdline_base,
+		plymouth_name);
+      }
+      free(cmdline);
+      return 0;
+    }
+    if(debug){
+      fprintf(stderr, "\"%s\" equals \"%s\"\n", cmdline_base,
+	      plymouth_name);
+    }
+    free(cmdline);
     return 1;
   }
-
-  struct dirent **direntries;
+  
+  struct dirent **direntries = NULL;
   int ret;
   ret = scandir("/proc", &direntries, is_plymouth, alphasort);
   if (ret == -1){
     error(1, errno, "scandir");
   }
-  if (ret < 0){
-    return 1;
-  } else {
-    return 0;
-  }
+  free(direntries);
+  return ret > 0;
 }
 
 
@@ -229,7 +303,7 @@
 
   if (conflict_detection()){
     if(debug){
-      fprintf(stderr, "Stopping %s because of conflict", argv[0]);
+      fprintf(stderr, "Stopping %s because of conflict\n", argv[0]);
     }
     return EXIT_FAILURE;
   }
@@ -437,8 +511,8 @@
 	break;
       }
     }
-    /* if(sret == 0), then the only sensible thing to do is to retry to
-       read from stdin */
+    /* if(sret == 0), then the only sensible thing to do is to retry
+       to read from stdin */
     fputc('\n', stderr);
     if(debug and not quit_now){
       /* If quit_now is nonzero, we were interrupted by a signal, and

=== modified file 'plugins.d/password-prompt.xml'
--- plugins.d/password-prompt.xml	2009-10-30 16:23:43 +0000
+++ plugins.d/password-prompt.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "password-prompt">
-<!ENTITY TIMESTAMP "2009-10-30">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,20 +19,21 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -292,6 +293,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>
       <citerefentry><refentrytitle>crypttab</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>
       <citerefentry><refentrytitle>mandos-client</refentrytitle>

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2010-11-16 18:10:22 +0000
+++ plugins.d/plymouth.c	2011-10-05 16:00:56 +0000
@@ -2,8 +2,8 @@
 /*
  * Plymouth - Read a password from Plymouth and output it
  * 
- * Copyright © 2010 Teddy Hogeborn
- * Copyright © 2010 Björn Påhlsson
+ * Copyright © 2010-2011 Teddy Hogeborn
+ * Copyright © 2010-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 #define _GNU_SOURCE		/* asprintf(), TEMP_FAILURE_RETRY() */
@@ -36,7 +36,8 @@
 #include <stddef.h>		/* NULL */
 #include <string.h>		/* strchr(), memcmp() */
 #include <stdio.h>		/* asprintf(), perror(), fopen(),
-				   fscanf() */
+				   fscanf(), vasprintf(), fprintf(),
+				   vfprintf() */
 #include <unistd.h>		/* close(), readlink(), read(),
 				   fork(), setsid(), chdir(), dup2(),
 				   STDERR_FILENO, execv(), access() */
@@ -50,17 +51,20 @@
 #include <error.h>		/* error() */
 #include <errno.h>		/* TEMP_FAILURE_RETRY */
 #include <argz.h>		/* argz_count(), argz_extract() */
+#include <stdarg.h>		/* va_list, va_start(), ... */
 
 sig_atomic_t interrupted_by_signal = 0;
-const char plymouth_pid[] = "/dev/.initramfs/plymouth.pid";
+
+/* Used by Ubuntu 11.04 (Natty Narwahl) */
+const char plymouth_old_pid[] = "/dev/.initramfs/plymouth.pid";
+/* Used by Ubuntu 11.10 (Oneiric Ocelot) */
+const char plymouth_pid[] = "/run/initramfs/plymouth.pid";
+
 const char plymouth_path[] = "/bin/plymouth";
 const char plymouthd_path[] = "/sbin/plymouthd";
 const char *plymouthd_default_argv[] = {"/sbin/plymouthd",
 					"--mode=boot",
 					"--attach-to-session",
-					"--pid-file="
-					"/dev/.initramfs/"
-					"plymouth.pid",
 					NULL };
 
 static void termination_handler(__attribute__((unused))int signum){
@@ -70,6 +74,29 @@
   interrupted_by_signal = 1;
 }
 
+/* Function to use when printing errors */
+void error_plus(int status, int errnum, const char *formatstring,
+		...){
+  va_list ap;
+  char *text;
+  int ret;
+  
+  va_start(ap, formatstring);
+  ret = vasprintf(&text, formatstring, ap);
+  if (ret == -1){
+    fprintf(stderr, "Mandos plugin %s: ",
+	    program_invocation_short_name);
+    vfprintf(stderr, formatstring, ap);
+    fprintf(stderr, ": ");
+    fprintf(stderr, "%s\n", strerror(errnum));
+    error(status, errno, "vasprintf while printing error");
+    return;
+  }
+  fprintf(stderr, "Mandos plugin ");
+  error(status, errnum, "%s", text);
+  free(text);
+}
+
 /* Create prompt string */
 char *makeprompt(void){
   int ret = 0;
@@ -109,18 +136,18 @@
 bool become_a_daemon(void){
   int ret = setuid(geteuid());
   if(ret == -1){
-    error(0, errno, "setuid");
+    error_plus(0, errno, "setuid");
   }
     
   setsid();
   ret = chdir("/");
   if(ret == -1){
-    error(0, errno, "chdir");
+    error_plus(0, errno, "chdir");
     return false;
   }
   ret = dup2(STDERR_FILENO, STDOUT_FILENO); /* replace our stdout */
   if(ret == -1){
-    error(0, errno, "dup2");
+    error_plus(0, errno, "dup2");
     return false;
   }
   return true;
@@ -134,7 +161,7 @@
   pid_t pid;
   pid = fork();
   if(pid == -1){
-    error(0, errno, "fork");
+    error_plus(0, errno, "fork");
     return false;
   }
   if(pid == 0){
@@ -151,7 +178,7 @@
     for (; argv[i]!=NULL; i++){
       tmp = realloc(new_argv, sizeof(const char *) * ((size_t)i + 1));
       if (tmp == NULL){
-	error(0, errno, "realloc");
+	error_plus(0, errno, "realloc");
 	free(new_argv);
 	_exit(EX_OSERR);
       }
@@ -161,7 +188,7 @@
     new_argv[i] = NULL;
     
     execv(path, (char *const *)new_argv);
-    error(0, errno, "execv");
+    error_plus(0, errno, "execv");
     _exit(EXIT_FAILURE);
   }
   if(pid_return != NULL){
@@ -176,7 +203,7 @@
     return false;
   }
   if(ret == -1){
-    error(0, errno, "waitpid");
+    error_plus(0, errno, "waitpid");
     return false;
   }
   if(WIFEXITED(status) and (WEXITSTATUS(status) == 0)){
@@ -202,7 +229,7 @@
   char *exe_link;
   ret = asprintf(&exe_link, "/proc/%s/exe", proc_entry->d_name);
   if(ret == -1){
-    error(0, errno, "asprintf");
+    error_plus(0, errno, "asprintf");
     return 0;
   }
   
@@ -211,7 +238,7 @@
   if(ret == -1){
     free(exe_link);
     if(errno != ENOENT){
-      error(0, errno, "lstat");
+      error_plus(0, errno, "lstat");
     }
     return 0;
   }
@@ -235,8 +262,9 @@
 
 pid_t get_pid(void){
   int ret;
+  uintmax_t maxvalue = 0;
   FILE *pidfile = fopen(plymouth_pid, "r");
-  uintmax_t maxvalue = 0;
+  /* Try the new pid file location */
   if(pidfile != NULL){
     ret = fscanf(pidfile, "%" SCNuMAX, &maxvalue);
     if(ret != 1){
@@ -244,18 +272,33 @@
     }
     fclose(pidfile);
   }
-  if(maxvalue == 0){
-    struct dirent **direntries;
+  /* Try the old pid file location */
+  if(maxvalue == 0){
+    pidfile = fopen(plymouth_pid, "r");
+    if(pidfile != NULL){
+      ret = fscanf(pidfile, "%" SCNuMAX, &maxvalue);
+      if(ret != 1){
+	maxvalue = 0;
+      }
+      fclose(pidfile);
+    }
+  }
+  /* Look for a plymouth process */
+  if(maxvalue == 0){
+    struct dirent **direntries = NULL;
     ret = scandir("/proc", &direntries, is_plymouth, alphasort);
     if (ret == -1){
-      error(0, errno, "scandir");
+      error_plus(0, errno, "scandir");
     }
     if (ret > 0){
       ret = sscanf(direntries[0]->d_name, "%" SCNuMAX, &maxvalue);
       if (ret < 0){
-	error(0, errno, "sscanf");
+	error_plus(0, errno, "sscanf");
       }
     }
+    /* scandir might preallocate for this variable (man page unclear).
+       even if ret == 0, therefore we need to free it. */
+    free(direntries);
   }
   pid_t pid;
   pid = (pid_t)maxvalue;
@@ -275,7 +318,7 @@
   ret = asprintf(&cmdline_filename, "/proc/%" PRIuMAX "/cmdline",
 		 (uintmax_t)pid);
   if(ret == -1){
-    error(0, errno, "asprintf");
+    error_plus(0, errno, "asprintf");
     return NULL;
   }
   
@@ -283,7 +326,7 @@
   cl_fd = open(cmdline_filename, O_RDONLY);
   free(cmdline_filename);
   if(cl_fd == -1){
-    error(0, errno, "open");
+    error_plus(0, errno, "open");
     return NULL;
   }
   
@@ -297,7 +340,7 @@
     if(cmdline_len + blocksize > cmdline_allocated){
       tmp = realloc(cmdline, cmdline_allocated + blocksize);
       if(tmp == NULL){
-	error(0, errno, "realloc");
+	error_plus(0, errno, "realloc");
 	free(cmdline);
 	close(cl_fd);
 	return NULL;
@@ -310,7 +353,7 @@
     sret = read(cl_fd, cmdline + cmdline_len,
 		cmdline_allocated - cmdline_len);
     if(sret == -1){
-      error(0, errno, "read");
+      error_plus(0, errno, "read");
       free(cmdline);
       close(cl_fd);
       return NULL;
@@ -319,7 +362,7 @@
   } while(sret != 0);
   ret = close(cl_fd);
   if(ret == -1){
-    error(0, errno, "close");
+    error_plus(0, errno, "close");
     free(cmdline);
     return NULL;
   }
@@ -328,7 +371,7 @@
   char **argv = malloc((argz_count(cmdline, cmdline_len) + 1)
 		       * sizeof(char *)); /* Get number of args */
   if(argv == NULL){
-    error(0, errno, "argv = malloc()");
+    error_plus(0, errno, "argv = malloc()");
     free(cmdline);
     return NULL;
   }
@@ -361,16 +404,16 @@
 	*sig != 0; sig++){
       ret = sigaddset(&new_action.sa_mask, *sig);
       if(ret == -1){
-	error(EX_OSERR, errno, "sigaddset");
+	error_plus(EX_OSERR, errno, "sigaddset");
       }
       ret = sigaction(*sig, NULL, &old_action);
       if(ret == -1){
-	error(EX_OSERR, errno, "sigaction");
+	error_plus(EX_OSERR, errno, "sigaction");
       }
       if(old_action.sa_handler != SIG_IGN){
 	ret = sigaction(*sig, &new_action, NULL);
 	if(ret == -1){
-	  error(EX_OSERR, errno, "sigaction");
+	  error_plus(EX_OSERR, errno, "sigaction");
 	}
       }
     }
@@ -395,7 +438,7 @@
   ret = asprintf(&prompt_arg, "--prompt=%s", prompt);
   free(prompt);
   if(ret == -1){
-    error(EX_OSERR, errno, "asprintf");
+    error_plus(EX_OSERR, errno, "asprintf");
   }
   
   /* plymouth ask-for-password --prompt="$prompt" */
@@ -417,7 +460,7 @@
   const char **plymouthd_argv;
   pid_t pid = get_pid();
   if(pid == 0){
-    error(0, 0, "plymouthd pid not found");
+    error_plus(0, 0, "plymouthd pid not found");
     plymouthd_argv = plymouthd_default_argv;
   } else {
     plymouthd_argv = getargv(pid);

=== modified file 'plugins.d/plymouth.xml'
--- plugins.d/plymouth.xml	2010-09-26 18:32:58 +0000
+++ plugins.d/plymouth.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plymouth">
-<!ENTITY TIMESTAMP "2010-09-26">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,19 +19,20 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2010</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -260,6 +261,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>crypttab</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>plugin-runner</refentrytitle>

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2010-10-07 17:46:56 +0000
+++ plugins.d/splashy.c	2011-10-05 16:00:56 +0000
@@ -2,8 +2,8 @@
 /*
  * Splashy - Read a password from splashy and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), asprintf() */
@@ -29,7 +29,8 @@
 				   SIG_IGN, kill(), SIGKILL */
 #include <stddef.h>		/* NULL */
 #include <stdlib.h>		/* getenv() */
-#include <stdio.h>		/* asprintf() */
+#include <stdio.h>		/* asprintf(), vasprintf(), vprintf(),
+				   fprintf() */
 #include <stdlib.h>		/* EXIT_FAILURE, free(),
 				   EXIT_SUCCESS */
 #include <sys/types.h>		/* pid_t, DIR, struct dirent,
@@ -42,7 +43,7 @@
 				   sleep(), dup2() STDERR_FILENO,
 				   STDOUT_FILENO, _exit(),
 				   pause() */
-#include <string.h>		/* memcmp() */
+#include <string.h>		/* memcmp(), strerror() */
 #include <errno.h>		/* errno, EACCES, ENOTDIR, ELOOP,
 				   ENOENT, ENAMETOOLONG, EMFILE,
 				   ENFILE, ENOMEM, ENOEXEC, EINVAL,
@@ -54,10 +55,35 @@
 				   WEXITSTATUS() */
 #include <sysexits.h>		/* EX_OSERR, EX_OSFILE,
 				   EX_UNAVAILABLE */
+#include <stdarg.h>		/* va_list, va_start(), ... */
 
 sig_atomic_t interrupted_by_signal = 0;
 int signal_received;
 
+/* Function to use when printing errors */
+void error_plus(int status, int errnum, const char *formatstring,
+		...){
+  va_list ap;
+  char *text;
+  int ret;
+  
+  va_start(ap, formatstring);
+  ret = vasprintf(&text, formatstring, ap);
+  if (ret == -1){
+    fprintf(stderr, "Mandos plugin %s: ",
+	    program_invocation_short_name);
+    vfprintf(stderr, formatstring, ap);
+    fprintf(stderr, ": ");
+    fprintf(stderr, "%s\n", strerror(errnum));
+    error(status, errno, "vasprintf while printing error");
+    return;
+  }
+  fprintf(stderr, "Mandos plugin ");
+  error(status, errnum, "%s", text);
+  free(text);
+}
+
+
 static void termination_handler(int signum){
   if(interrupted_by_signal){
     return;
@@ -110,7 +136,7 @@
     proc_dir = opendir("/proc");
     if(proc_dir == NULL){
       int e = errno;
-      error(0, errno, "opendir");
+      error_plus(0, errno, "opendir");
       switch(e){
       case EACCES:
       case ENOTDIR:
@@ -152,7 +178,7 @@
 	char *exe_link;
 	ret = asprintf(&exe_link, "/proc/%s/exe", proc_ent->d_name);
 	if(ret == -1){
-	  error(0, errno, "asprintf");
+	  error_plus(0, errno, "asprintf");
 	  exitstatus = EX_OSERR;
 	  goto failure;
 	}
@@ -166,7 +192,7 @@
 	    continue;
 	  }
 	  int e = errno;
-	  error(0, errno, "lstat");
+	  error_plus(0, errno, "lstat");
 	  free(exe_link);
 	  switch(e){
 	  case EACCES:
@@ -214,60 +240,60 @@
     sigemptyset(&new_action.sa_mask);
     ret = sigaddset(&new_action.sa_mask, SIGINT);
     if(ret == -1){
-      error(0, errno, "sigaddset");
+      error_plus(0, errno, "sigaddset");
       exitstatus = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGHUP);
     if(ret == -1){
-      error(0, errno, "sigaddset");
+      error_plus(0, errno, "sigaddset");
       exitstatus = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGTERM);
     if(ret == -1){
-      error(0, errno, "sigaddset");
+      error_plus(0, errno, "sigaddset");
       exitstatus = EX_OSERR;
       goto failure;
     }
     ret = sigaction(SIGINT, NULL, &old_action);
     if(ret == -1){
-      error(0, errno, "sigaction");
+      error_plus(0, errno, "sigaction");
       exitstatus = EX_OSERR;
       goto failure;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGINT, &new_action, NULL);
       if(ret == -1){
-	error(0, errno, "sigaction");
+	error_plus(0, errno, "sigaction");
 	exitstatus = EX_OSERR;
 	goto failure;
       }
     }
     ret = sigaction(SIGHUP, NULL, &old_action);
     if(ret == -1){
-      error(0, errno, "sigaction");
+      error_plus(0, errno, "sigaction");
       exitstatus = EX_OSERR;
       goto failure;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGHUP, &new_action, NULL);
       if(ret == -1){
-	error(0, errno, "sigaction");
+	error_plus(0, errno, "sigaction");
 	exitstatus = EX_OSERR;
 	goto failure;
       }
     }
     ret = sigaction(SIGTERM, NULL, &old_action);
     if(ret == -1){
-      error(0, errno, "sigaction");
+      error_plus(0, errno, "sigaction");
       exitstatus = EX_OSERR;
       goto failure;
     }
     if(old_action.sa_handler != SIG_IGN){
       ret = sigaction(SIGTERM, &new_action, NULL);
       if(ret == -1){
-	error(0, errno, "sigaction");
+	error_plus(0, errno, "sigaction");
 	exitstatus = EX_OSERR;
 	goto failure;
       }
@@ -284,7 +310,7 @@
     goto failure;
   }
   if(splashy_command_pid == -1){
-    error(0, errno, "fork");
+    error_plus(0, errno, "fork");
     exitstatus = EX_OSERR;
     goto failure;
   }
@@ -294,7 +320,7 @@
       const char splashy_command[] = "/sbin/splashy_update";
       execl(splashy_command, splashy_command, prompt, (char *)NULL);
       int e = errno;
-      error(0, errno, "execl");
+      error_plus(0, errno, "execl");
       switch(e){
       case EACCES:
       case ENOENT:
@@ -344,7 +370,7 @@
       goto failure;
     }
     if(ret == -1){
-      error(0, errno, "waitpid");
+      error_plus(0, errno, "waitpid");
       if(errno == ECHILD){
 	splashy_command_pid = 0;
       }
@@ -382,27 +408,27 @@
 	 the real user ID (_mandos) */
       ret = setuid(geteuid());
       if(ret == -1){
-	error(0, errno, "setuid");
+	error_plus(0, errno, "setuid");
       }
       
       setsid();
       ret = chdir("/");
       if(ret == -1){
-	error(0, errno, "chdir");
+	error_plus(0, errno, "chdir");
       }
 /*       if(fork() != 0){ */
 /* 	_exit(EXIT_SUCCESS); */
 /*       } */
       ret = dup2(STDERR_FILENO, STDOUT_FILENO); /* replace stdout */
       if(ret == -1){
-	error(0, errno, "dup2");
+	error_plus(0, errno, "dup2");
 	_exit(EX_OSERR);
       }
       
       execl("/sbin/splashy", "/sbin/splashy", "boot", (char *)NULL);
       {
 	int e = errno;
-	error(0, errno, "execl");
+	error_plus(0, errno, "execl");
 	switch(e){
 	case EACCES:
 	case ENOENT:
@@ -428,13 +454,13 @@
     ret = (int)TEMP_FAILURE_RETRY(sigaction(signal_received,
 					    &signal_action, NULL));
     if(ret == -1){
-      error(0, errno, "sigaction");
+      error_plus(0, errno, "sigaction");
     }
     do {
       ret = raise(signal_received);
     } while(ret != 0 and errno == EINTR);
     if(ret != 0){
-      error(0, errno, "raise");
+      error_plus(0, errno, "raise");
       abort();
     }
     TEMP_FAILURE_RETRY(pause());

=== modified file 'plugins.d/splashy.xml'
--- plugins.d/splashy.xml	2009-01-04 21:54:55 +0000
+++ plugins.d/splashy.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "splashy">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,20 +19,21 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -263,6 +264,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>crypttab</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>plugin-runner</refentrytitle>

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2010-09-26 18:32:58 +0000
+++ plugins.d/usplash.c	2011-10-05 16:00:56 +0000
@@ -2,8 +2,8 @@
 /*
  * Usplash - Read a password from usplash and output it
  * 
- * Copyright © 2008-2010 Teddy Hogeborn
- * Copyright © 2008-2010 Björn Påhlsson
+ * Copyright © 2008-2011 Teddy Hogeborn
+ * Copyright © 2008-2011 Björn Påhlsson
  * 
  * This program is free software: you can redistribute it and/or
  * modify it under the terms of the GNU General Public License as
@@ -19,7 +19,7 @@
  * along with this program.  If not, see
  * <http://www.gnu.org/licenses/>.
  * 
- * Contact the authors at <mandos@fukt.bsnet.se>.
+ * Contact the authors at <mandos@recompile.se>.
  */
 
 #define _GNU_SOURCE		/* asprintf(), TEMP_FAILURE_RETRY() */
@@ -35,8 +35,9 @@
 #include <sys/types.h>		/* size_t, ssize_t, pid_t, DIR, struct
 				   dirent */
 #include <stddef.h>		/* NULL */
-#include <string.h>		/* strlen(), memcmp() */
-#include <stdio.h>		/* asprintf()*/
+#include <string.h>		/* strlen(), memcmp(), strerror() */
+#include <stdio.h>		/* asprintf(), vasprintf(), vprintf(),
+				   fprintf() */
 #include <unistd.h>		/* close(), write(), readlink(),
 				   read(), STDOUT_FILENO, sleep(),
 				   fork(), setuid(), geteuid(),
@@ -50,11 +51,35 @@
 #include <sys/stat.h>		/* struct stat, lstat(), S_ISLNK */
 #include <sysexits.h>		/* EX_OSERR, EX_UNAVAILABLE */
 #include <argz.h>		/* argz_count(), argz_extract() */
+#include <stdarg.h>		/* va_list, va_start(), ... */
 
 sig_atomic_t interrupted_by_signal = 0;
 int signal_received;
 const char usplash_name[] = "/sbin/usplash";
 
+/* Function to use when printing errors */
+void error_plus(int status, int errnum, const char *formatstring,
+		...){
+  va_list ap;
+  char *text;
+  int ret;
+  
+  va_start(ap, formatstring);
+  ret = vasprintf(&text, formatstring, ap);
+  if (ret == -1){
+    fprintf(stderr, "Mandos plugin %s: ",
+	    program_invocation_short_name);
+    vfprintf(stderr, formatstring, ap);
+    fprintf(stderr, ": ");
+    fprintf(stderr, "%s\n", strerror(errnum));
+    error(status, errno, "vasprintf while printing error");
+    return;
+  }
+  fprintf(stderr, "Mandos plugin ");
+  error(status, errnum, "%s", text);
+  free(text);
+}
+
 static void termination_handler(int signum){
   if(interrupted_by_signal){
     return;
@@ -155,7 +180,7 @@
   size_t cmdline_len = 0;
   DIR *proc_dir = opendir("/proc");
   if(proc_dir == NULL){
-    error(0, errno, "opendir");
+    error_plus(0, errno, "opendir");
     return -1;
   }
   errno = 0;
@@ -183,7 +208,7 @@
       char *exe_link;
       ret = asprintf(&exe_link, "/proc/%s/exe", proc_ent->d_name);
       if(ret == -1){
-	error(0, errno, "asprintf");
+	error_plus(0, errno, "asprintf");
 	goto fail_find_usplash;
       }
       
@@ -195,7 +220,7 @@
 	  free(exe_link);
 	  continue;
 	}
-	error(0, errno, "lstat");
+	error_plus(0, errno, "lstat");
 	free(exe_link);
 	goto fail_find_usplash;
       }
@@ -226,13 +251,13 @@
 	ret = asprintf(&cmdline_filename, "/proc/%s/cmdline",
 		       proc_ent->d_name);
 	if(ret == -1){
-	  error(0, errno, "asprintf");
+	  error_plus(0, errno, "asprintf");
 	  goto fail_find_usplash;
 	}
 	cl_fd = open(cmdline_filename, O_RDONLY);
 	free(cmdline_filename);
 	if(cl_fd == -1){
-	  error(0, errno, "open");
+	  error_plus(0, errno, "open");
 	  goto fail_find_usplash;
 	}
       }
@@ -244,7 +269,7 @@
 	if(cmdline_len + blocksize > cmdline_allocated){
 	  tmp = realloc(cmdline, cmdline_allocated + blocksize);
 	  if(tmp == NULL){
-	    error(0, errno, "realloc");
+	    error_plus(0, errno, "realloc");
 	    close(cl_fd);
 	    goto fail_find_usplash;
 	  }
@@ -255,7 +280,7 @@
 	sret = read(cl_fd, cmdline + cmdline_len,
 		    cmdline_allocated - cmdline_len);
 	if(sret == -1){
-	  error(0, errno, "read");
+	  error_plus(0, errno, "read");
 	  close(cl_fd);
 	  goto fail_find_usplash;
 	}
@@ -263,14 +288,14 @@
       } while(sret != 0);
       ret = close(cl_fd);
       if(ret == -1){
-	error(0, errno, "close");
+	error_plus(0, errno, "close");
 	goto fail_find_usplash;
       }
     }
     /* Close directory */
     ret = closedir(proc_dir);
     if(ret == -1){
-      error(0, errno, "closedir");
+      error_plus(0, errno, "closedir");
       goto fail_find_usplash;
     }
     /* Success */
@@ -325,26 +350,26 @@
     sigemptyset(&new_action.sa_mask);
     ret = sigaddset(&new_action.sa_mask, SIGINT);
     if(ret == -1){
-      error(0, errno, "sigaddset");
+      error_plus(0, errno, "sigaddset");
       status = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGHUP);
     if(ret == -1){
-      error(0, errno, "sigaddset");
+      error_plus(0, errno, "sigaddset");
       status = EX_OSERR;
       goto failure;
     }
     ret = sigaddset(&new_action.sa_mask, SIGTERM);
     if(ret == -1){
-      error(0, errno, "sigaddset");
+      error_plus(0, errno, "sigaddset");
       status = EX_OSERR;
       goto failure;
     }
     ret = sigaction(SIGINT, NULL, &old_action);
     if(ret == -1){
       if(errno != EINTR){
-	error(0, errno, "sigaction");
+	error_plus(0, errno, "sigaction");
 	status = EX_OSERR;
       }
       goto failure;
@@ -353,7 +378,7 @@
       ret = sigaction(SIGINT, &new_action, NULL);
       if(ret == -1){
 	if(errno != EINTR){
-	  error(0, errno, "sigaction");
+	  error_plus(0, errno, "sigaction");
 	  status = EX_OSERR;
 	}
 	goto failure;
@@ -362,7 +387,7 @@
     ret = sigaction(SIGHUP, NULL, &old_action);
     if(ret == -1){
       if(errno != EINTR){
-	error(0, errno, "sigaction");
+	error_plus(0, errno, "sigaction");
 	status = EX_OSERR;
       }
       goto failure;
@@ -371,7 +396,7 @@
       ret = sigaction(SIGHUP, &new_action, NULL);
       if(ret == -1){
 	if(errno != EINTR){
-	  error(0, errno, "sigaction");
+	  error_plus(0, errno, "sigaction");
 	  status = EX_OSERR;
 	}
 	goto failure;
@@ -380,7 +405,7 @@
     ret = sigaction(SIGTERM, NULL, &old_action);
     if(ret == -1){
       if(errno != EINTR){
-	error(0, errno, "sigaction");
+	error_plus(0, errno, "sigaction");
 	status = EX_OSERR;
       }
       goto failure;
@@ -389,7 +414,7 @@
       ret = sigaction(SIGTERM, &new_action, NULL);
       if(ret == -1){
 	if(errno != EINTR){
-	  error(0, errno, "sigaction");
+	  error_plus(0, errno, "sigaction");
 	  status = EX_OSERR;
 	}
 	goto failure;
@@ -401,7 +426,7 @@
   /* Write command to FIFO */
   if(not usplash_write(&fifo_fd, "TIMEOUT", "0")){
     if(errno != EINTR){
-      error(0, errno, "usplash_write");
+      error_plus(0, errno, "usplash_write");
       status = EX_OSERR;
     }
     goto failure;
@@ -413,7 +438,7 @@
   
   if(not usplash_write(&fifo_fd, "INPUTQUIET", prompt)){
     if(errno != EINTR){
-      error(0, errno, "usplash_write");
+      error_plus(0, errno, "usplash_write");
       status = EX_OSERR;
     }
     goto failure;
@@ -431,7 +456,7 @@
   outfifo_fd = open("/dev/.initramfs/usplash_outfifo", O_RDONLY);
   if(outfifo_fd == -1){
     if(errno != EINTR){
-      error(0, errno, "open");
+      error_plus(0, errno, "open");
       status = EX_OSERR;
     }
     goto failure;
@@ -450,7 +475,7 @@
       char *tmp = realloc(buf, buf_allocated + blocksize);
       if(tmp == NULL){
 	if(errno != EINTR){
-	  error(0, errno, "realloc");
+	  error_plus(0, errno, "realloc");
 	  status = EX_OSERR;
 	}
 	goto failure;
@@ -462,7 +487,7 @@
 		buf_allocated - buf_len);
     if(sret == -1){
       if(errno != EINTR){
-	error(0, errno, "read");
+	error_plus(0, errno, "read");
 	status = EX_OSERR;
       }
       TEMP_FAILURE_RETRY(close(outfifo_fd));
@@ -477,7 +502,7 @@
   ret = close(outfifo_fd);
   if(ret == -1){
     if(errno != EINTR){
-      error(0, errno, "close");
+      error_plus(0, errno, "close");
       status = EX_OSERR;
     }
     goto failure;
@@ -490,7 +515,7 @@
   
   if(not usplash_write(&fifo_fd, "TIMEOUT", "15")){
     if(errno != EINTR){
-      error(0, errno, "usplash_write");
+      error_plus(0, errno, "usplash_write");
       status = EX_OSERR;
     }
     goto failure;
@@ -503,7 +528,7 @@
   ret = close(fifo_fd);
   if(ret == -1){
     if(errno != EINTR){
-      error(0, errno, "close");
+      error_plus(0, errno, "close");
       status = EX_OSERR;
     }
     goto failure;
@@ -517,7 +542,7 @@
       sret = write(STDOUT_FILENO, buf + written, buf_len - written);
       if(sret == -1){
 	if(errno != EINTR){
-	  error(0, errno, "write");
+	  error_plus(0, errno, "write");
 	  status = EX_OSERR;
 	}
 	goto failure;
@@ -554,7 +579,7 @@
   if(fifo_fd != -1){
     ret = (int)TEMP_FAILURE_RETRY(close(fifo_fd));
     if(ret == -1 and errno != EINTR){
-      error(0, errno, "close");
+      error_plus(0, errno, "close");
     }
     fifo_fd = -1;
   }
@@ -563,7 +588,7 @@
   if(outfifo_fd != -1){
     ret = (int)TEMP_FAILURE_RETRY(close(outfifo_fd));
     if(ret == -1){
-      error(0, errno, "close");
+      error_plus(0, errno, "close");
     }
   }
   
@@ -571,7 +596,7 @@
   char **cmdline_argv = malloc((argz_count(cmdline, cmdline_len) + 1)
 			       * sizeof(char *)); /* Count args */
   if(cmdline_argv == NULL){
-    error(0, errno, "malloc");
+    error_plus(0, errno, "malloc");
     return status;
   }
   argz_extract(cmdline, cmdline_len, cmdline_argv); /* Create argv */
@@ -592,13 +617,13 @@
        the real user ID (_mandos) */
     ret = setuid(geteuid());
     if(ret == -1){
-      error(0, errno, "setuid");
+      error_plus(0, errno, "setuid");
     }
     
     setsid();
     ret = chdir("/");
     if(ret == -1){
-      error(0, errno, "chdir");
+      error_plus(0, errno, "chdir");
       _exit(EX_OSERR);
     }
 /*     if(fork() != 0){ */
@@ -606,13 +631,13 @@
 /*     } */
     ret = dup2(STDERR_FILENO, STDOUT_FILENO); /* replace our stdout */
     if(ret == -1){
-      error(0, errno, "dup2");
+      error_plus(0, errno, "dup2");
       _exit(EX_OSERR);
     }
     
     execv(usplash_name, cmdline_argv);
     if(not interrupted_by_signal){
-      error(0, errno, "execv");
+      error_plus(0, errno, "execv");
     }
     free(cmdline);
     free(cmdline_argv);
@@ -623,7 +648,7 @@
   sleep(2);
   if(not usplash_write(&fifo_fd, "PULSATE", NULL)){
     if(errno != EINTR){
-      error(0, errno, "usplash_write");
+      error_plus(0, errno, "usplash_write");
     }
   }
   
@@ -631,7 +656,7 @@
   if(fifo_fd != -1){
     ret = (int)TEMP_FAILURE_RETRY(close(fifo_fd));
     if(ret == -1 and errno != EINTR){
-      error(0, errno, "close");
+      error_plus(0, errno, "close");
     }
     fifo_fd = -1;
   }
@@ -642,13 +667,13 @@
     ret = (int)TEMP_FAILURE_RETRY(sigaction(signal_received,
 					    &signal_action, NULL));
     if(ret == -1){
-      error(0, errno, "sigaction");
+      error_plus(0, errno, "sigaction");
     }
     do {
       ret = raise(signal_received);
     } while(ret != 0 and errno == EINTR);
     if(ret != 0){
-      error(0, errno, "raise");
+      error_plus(0, errno, "raise");
       abort();
     }
     TEMP_FAILURE_RETRY(pause());

=== modified file 'plugins.d/usplash.xml'
--- plugins.d/usplash.xml	2009-01-04 21:54:55 +0000
+++ plugins.d/usplash.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "usplash">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -19,20 +19,21 @@
 	<firstname>Björn</firstname>
 	<surname>Påhlsson</surname>
 	<address>
-	  <email>belorn@fukt.bsnet.se</email>
+	  <email>belorn@recompile.se</email>
 	</address>
       </author>
       <author>
 	<firstname>Teddy</firstname>
 	<surname>Hogeborn</surname>
 	<address>
-	  <email>teddy@fukt.bsnet.se</email>
+	  <email>teddy@recompile.se</email>
 	</address>
       </author>
     </authorgroup>
     <copyright>
       <year>2008</year>
       <year>2009</year>
+      <year>2011</year>
       <holder>Teddy Hogeborn</holder>
       <holder>Björn Påhlsson</holder>
     </copyright>
@@ -277,6 +278,8 @@
   <refsect1 id="see_also">
     <title>SEE ALSO</title>
     <para>
+      <citerefentry><refentrytitle>intro</refentrytitle>
+      <manvolnum>8mandos</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>crypttab</refentrytitle>
       <manvolnum>5</manvolnum></citerefentry>,
       <citerefentry><refentrytitle>fifo</refentrytitle>

